--this is exclusively for the round 16x16 buttons in the editor, not the wider buttons to access levelset properties and such, and not the yes/no buttons in ih8ui boxes
button = class:new()

button.quads = {
	["normal"] = love.graphics.newQuad(0, 0, 16, 16, 32, 16),
	["depressed"] = love.graphics.newQuad(16, 0, 16, 16, 32, 16)
}

function button:init(rel_x, rel_y, id, image, imagequad, action, onUpdate, tooltip, onDraw, relativeto)
	self.id = id
	self.image = image
	self.imagequad = imagequad
	self.rel_x = rel_x
	self.rel_y = rel_y
	self.width = tilesize
	self.height = tilesize
	self.action = action
	self.onUpdate = onUpdate
	self.depressed = false
	self.tooltip = tooltip
	self.iconrgba = {1, 1, 1, 1}
	self.onDraw = onDraw
	self.relativeto = relativeto
end

function button:setup(rel_x, rel_y, id, image, imagequad, action, onUpdate, tooltip, onDraw, relativeto, container_w, container_h)
	if (not relativeto) or relativeto == "none" then relativeto = "topleft" end
	local newbutton = button:new(rel_x, rel_y, id, image, imagequad, action, onUpdate, tooltip, onDraw, relativeto)
	newbutton:updateposfordimensions(container_w or love.graphics.getWidth(), container_h or love.graphics.getHeight())
	return newbutton
end

function button:update()
	self.onUpdate(self) --avoiding syntactical sugar here because onUpdate is supplied as an arg so i don't really know how that would work
end

function button:updateposfordimensions(w, h)
	local x = self.rel_x
	local y = self.rel_y
	if self.relativeto ~= "topleft" then
		if self.relativeto == "bottomleft" or self.relativeto == "bottomright" then
			y = h - self.rel_y
		end
		if self.relativeto == "topright" or self.relativeto == "bottomright" then
			x = w - self.rel_x
		end
	end
	self.x = x
	self.y = y
end

function button:draw()
	local x = self.x
	local y = self.y
	local mystate = "normal"
	if self.depressed then mystate = "depressed" end
	love.graphics.draw(graphics.load("ui/editorbutton"), button.quads[mystate], x, y)
	local r, g, b, a = love.graphics.getColor()
	love.graphics.setColor(self.iconrgba[1], self.iconrgba[2], self.iconrgba[3], self.iconrgba[4])
	if self.imagequad then
		love.graphics.draw(graphics.load("ui/" .. self.image), self.imagequad, x, y)
	else
		love.graphics.draw(graphics.load("ui/" .. self.image), x, y)
	end
	love.graphics.setColor(r, g, b, a)
	if type(self.onDraw) == "string" then
		print(self.id, self.onDraw)
	end
	if self.onDraw then self:onDraw() end
end

--return button