consts = {}
consts["E"] = {}
consts["empty"] = consts["E"]
consts["nographics"] = {["graphics"] = {}}
consts["red"] = {1, 0, 0}
consts["green"] = {0, 1, 0}
consts["blue"] = {0, 0, 1}
consts["black"] = {0, 0, 0}
consts["white"] = {1, 1, 1}
consts["gray"] = {0.5, 0.5, 0.5}
consts["lightgray"] = {0.75, 0.75, 0.75}
consts["lowalpha"] = {1,1,1,0.5}
consts["directions"] = {"up", "right", "down", "left"}
consts["oppositedirs"] = {
	["right"] = "left",
	["down"]  = "up",
	["left"]  = "right",
	["up"]    = "down"
}
consts["ascii"] = ' !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~'
print(consts.ascii)
consts["ascii_table"] = consts["ascii"]:split('')


consts["levelsets_linedistance"] = 25
consts["levelsets_itemsperpage"] = 10


consts["chars_reals"] = set("1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "-", ".") --omg! reals! jumper 4 real reference
consts["chars_reals_nonnegative"] = set("1", "2", "3", "4", "5", "6", "7", "8", "9", "0", ".")
consts["chars_integers"] = set("1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "-")
consts["chars_integers_nonnegative"] = set("1", "2", "3", "4", "5", "6", "7", "8", "9", "0")
consts["chars_integers_viewport"] = set("1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "p", "P")
consts["chars_hex"] = set("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "a", "b", "c", "d", "e", "f")
consts["chars_coordinates"] = set("1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "-", ",")
consts["check_iscolor"] = function(self)
	local input = self.box.vars[self.id]
	
	if (not input) or input == "" then
		return false, "input required"
	end
	
	if #input ~= 6 then
		return false, "should be length 6"
	end
	return true
end
consts["check_levelsize"] = function(self)
	local input = self.box.vars[self.id]
	
	if (not input) or input == "" then
		return false, "input required"
	end
	
	if not tonumber(input) then
		return false, "that's not a number"
	end
	input = tonumber(input)
	if input == 0 then
		return false, "a bit small for a level"
	end
	if input > 100 then
		return false, "100 or less please"
	end
	return true
end
consts["check_coordinatepair"] = function(self)
	local input = self.box.vars[self.id]
	
	if (not input) or input == "" then
		return false, "input required"
	end
	
	local _,c = string.gsub(input, ",", " ")
	if c ~= 1 then
		return false, "invalid coordinate pair"
	end
	local test = split(input, ",")
	if not tonumber(test[1]) then
		return false, "1st number is invalid"
	end
	if not tonumber(test[2]) then
		return false, "2nd number is invalid"
	end
	if #test[1] > 1 then
		if test[1] == "-0" then
			return false, "no negative zero"
		end
		if string.sub(test[1], 1, 1) == "0" or string.sub(test[1], 1, 2) == "-0" then
			return false, "leading zero on 1st number"
		end
		if tonumber(test[1]) < -32768 or tonumber(test[1]) > 32767 then --valid coordinates for rooms, which this check is used for thus far
			return false, "out of range (-32768 to 32767)"
		end
	end
	if #test[2] > 1 then
		if test[2] == "-0" then
			return false, "no negative zero"
		end
		if string.sub(test[2], 1, 1) == "0" or string.sub(test[2], 1, 2) == "-0" then
			return false, "leading zero on 2nd number"
		end
		if tonumber(test[2]) < -32768 or tonumber(test[2]) > 32767 then
			return false, "out of range (-32768 to 32767)"
		end
	end
	
	return true
end
consts["check_coordinatepair_orempty"] = function(self)
	local input = self.box.vars[self.id]
	if (not input) or input == "" then return true
	else return consts["check_coordinatepair"](self) end
end
consts["check_viewportsize"] = function(self)
	local input = self.box.vars[self.id]
	
	if (not input) or input == "" then
		return true
	end
	
	if not tonumber(input) then
		return false, "that's not a number"
	end
	input = tonumber(input)
	if input == 0 then
		return false, "a bit small for a viewport"
	end
	if input > 1000 then
		return false, "too large (and way larger than window)"
	end
	return true
end
consts["check_viewportsize_tiles"] = function(self)
	local input = self.box.vars[self.id]
	
	if (not input) or input == "" then
		return true
	end
	local pixels = false
	local amount
	
	local endchar = input:sub(-1)
	if endchar:lower() == "p" then
		input = input:sub(1,-2)
		pixels = true
	end
	
	amount = tonumber(input)
	if not amount then
		return false, "that's not a number"
	end
	if pixels then amount = amount * tilesize end
	
	if amount == 0 then
		return false, "a bit small for a viewport"
	end
	if amount > 1000 then
		return false, "too large (and way larger than window)"
	end
	return true
end
consts["check_uint16"] = function(self)
	local input = self.box.vars[self.id]
	
	if (not input) or input == "" then
		return false, "input required"
	end
	
	amount = tonumber(input)
	if not amount then
		return false, "that's not a number"
	end
	
	if amount < 0 or amount > 65536 then
		return false, "out of range (0 to 65536)"
	end
	
	return true
end
consts["check_uint16_or_empty"] = function(self)
	local input = self.box.vars[self.id]
	if (not input) or input == "" then return true
	else return consts["check_uint16"](self) end
end