symboldisplay = {
	titlefont = love.graphics.newFont(16),
	acknowledgeclick = false,
}
--[[
note:
	local crosshair = love.mouse.getSystemCursor("crosshair")
	love.mouse.setCursor(crosshair)
for "draw" button for pixel-precise hitboxes
]]

function symboldisplay.stop()
	symboldisplay.acknowledgeclick = false
end

function symboldisplay.update()
	editor.tooltip = nil
end

function symboldisplay.mousepressed(x, y, button)
	symboldisplay.acknowledgeclick = true
end

function symboldisplay.keypressed(key)
	if key == "escape" then
		statemachine.setstate("editor")
	end
end

function symboldisplay.draw()
	local y = 16
	local r, g, b, a = love.graphics.getColor()
	love.graphics.push()
	love.graphics.translate(0, (-1 * symboldisplay.scroll))
	love.graphics.setColor(0.2, 0.2, 0.2, 1)
	love.graphics.rectangle("fill", 0, y, love.graphics.getWidth(), love.graphics.getHeight() + symboldisplay.scrollmax)
	
	for _,category in ipairs(symboldisplay.categories) do
		love.graphics.setColor(0.333, 0.333, 0.333, 1)
		love.graphics.rectangle("fill", 0, y, love.graphics.getWidth(), 16)
		love.graphics.setColor(r, g, b, a)
		love.graphics.print(category, symboldisplay.titlefont, (16 * 2), y)
		y = y + (16 * 2)
		local section = symboldisplay.sections[category]
		if section then
			local x = 16
			for i,v in ipairs(section) do
				editor.drawSymbol(v, x, y, true, true)
				x = x + 16
				if section[i + 1] and x + (16 * 2) > love.graphics.getWidth() then x = 16; y = y + 16; end
			end
		end
		y = y + 32
	end
	love.graphics.pop()
	
	--love.graphics.print(symboldisplay.scroll)
	love.graphics.setColor(0, 0, 0, 1)
	love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), 16)
	love.graphics.rectangle("fill", 0, (editor.height - 16), love.graphics.getWidth(), 16)
	love.graphics.setColor(1, 1, 1, 1)
	love.graphics.print("custom elements submenu (shortcut: =)")
	
	if symboldisplay.backhovered then
		love.graphics.setColor(0.666, 0.666, 0.666, 1)
	else
		love.graphics.setColor(0.5, 0.5, 0.5, 1)
	end
	love.graphics.rectangle("fill", (editor.width - 64), (editor.height - 16), 64, 16)
	love.graphics.setColor(r, g, b, a)
	love.graphics.draw(symboldisplay.backtext, (editor.width - 64), (editor.height - 16))
	
	if editor.tooltip ~= nil then
		printAsTooltip(editor.tooltip, editor.tooltipScale)
	end
end