cutscene = {
	location = "idk"
	imagelist = {},
	image = nil,
	soundlist = {},
	sound = nil,
	page = 1,
	maximum = 1,
	nextstate = "idk"
}

function cutscene.showcutscene(location, nextstate)
	cutscene.nextstate = nextstate
	cutscene.location = location
	local filenames = love.filesystem.getDirectoryItems(location)
	table.sort(filenames)
	for i,v in filenames do
		if v:lower():sub(1, 5) == "scene" then
			local num = tonumber(v:sub(6))
			if num > cutscene.maximum then cutscene.maximum = num end
			imagelist[num] = v
		elseif v:lower():sub(1, 5) == "sound" then
			local num = tonumber(v:sub(6))
			if num > cutscene.maximum then cutscene.maximum = num end
			soundlist[num] = v
		end
	end
	statemachine.changestate("cutscene")
end

function cutscene.begin()
	cutscene.audiovisual()
end

function cutscene.audiovisual()
	cutscene.image = nil
	if love.filesystem.getInfo(location .. "/" .. imagelist[cutscene.page]) then
		cutscene.image = love.graphics.newImage(location .. "/" .. imagelist[cutscene.page])
	end
	if cutscene.sound then
		cutscene.sound:stop()
	end
	cutscene.sound = nil
	if love.filesystem.getInfo(location .. "/" .. soundlist[cutscene.page]) then
		cutscene.sound = love.audio.newSource(location .. "/" .. soundlist[cutscene.page])
		cutscene.sound:play()
	end
end

function cutscene.keypressed(key)
	local change = false --whether the image or sound should change
	if key == "left" then
		if cutscene.page > 1 then cutscene.page = cutscene.page - 1; change = true; end
	elseif key == "right" then
		cutscene.page = cutscene.page + 1; change = true
		if cutscene.page > cutscene.maximum then
			statemachine.changestate(cutscene.nextstate); change = false; --bit confusing?
		end
	end
	if change then cutscene.audiovisual() end
end

function cutscene.draw()
	if cutscene.image then love.graphics.draw(cutscene.image) end
end

function cutscene.stop()
	if cutscene.sound then cutscene.sound:stop() end
	cutscene.sound = nil
	cutscene.image = nil
end