boxes = {}
--width = 108
boxes.levelproperties = {
	title = "level properties",
	hasyesno = true,
	tabs = {
		[1] = {
			name = "main",
			elements = {
				{type = "text", content = "background color:"},
				{type = "textline", content = {hint = "enter a hex code", properties = {onlychars = consts.chars_hex, maxlength = 6}}, id = "bgcolor", check = consts["check_iscolor"]},
				{type = "text", content = "music:"},
				{type = "textline", content = {hint = "enter a song name"}, id = "music", --"enter a song name (or ID)"
					check = function(self)
						local input = self.box.vars[self.id]
						if (not input) or input == "" then return true end
						if tonumber(input) then
							if not game.currentlevelset.info.songs[tonumber(input)] then
								return false, "not a valid song ID"
							end
						elseif not audio.songnames[input] then
							return false, "not a valid song"
						end
						return true
					end,
				},
				{type = "text", content = "level width (tiles):"},
				{type = "textline", content = {hint = "enter a number", properties = {onlychars = consts["chars_integers_nonnegative"], maxlength = 2}}, id = "levelwidth", check = consts["check_levelsize"]},
				{type = "text", content = "level height (tiles):"},
				{type = "textline", content = {hint = "enter a number", properties = {onlychars = consts["chars_integers_nonnegative"], maxlength = 2}}, id = "levelheight", check = consts["check_levelsize"],},
				{type = "text", content = "(NOTE: decreasing level width deletes tiles from the right; decreasing level height\ndeletes tiles from the bottom)"},
			}
		},
		[2] = {
			name = "hints",
			elements = {
				{type = "text", content = "specify text for hint blocks with variant tags"},
				{type = "textline", content = {hint = "hint #1"}, id = "hint1"},
				{type = "textline", content = {hint = "hint #2"}, id = "hint2"},
				{type = "textline", content = {hint = "hint #3"}, id = "hint3"},
				{type = "textline", content = {hint = "hint #4"}, id = "hint4"},
				{type = "textline", content = {hint = "hint #5"}, id = "hint5"},
				{type = "textline", content = {hint = "hint #6"}, id = "hint6"},
				{type = "textline", content = {hint = "hint #7"}, id = "hint7"},
				{type = "textline", content = {hint = "hint #8"}, id = "hint8"},
				{type = "textline", content = {hint = "hint #9"}, id = "hint9"},
			}
		},
		[3] = {
			name = "npcs",
			--[[
			elements = {
				{type = "text", content = "specify names and up to 3 lines of dialogue for 2 npcs. further functionality WIP"},
				{type = "textline", content = {hint = "npc #1 name",  width = 160}, id = "npc1name"},
				{type = "textline", content = {hint = "npc #1 dialogue"}, id = "npc1dialogue1", req = "npc1name"},
				{type = "textline", content = {hint = "npc #1 dialogue"}, id = "npc1dialogue2", req = "npc1name"},
				{type = "textline", content = {hint = "npc #1 dialogue"}, id = "npc1dialogue3", req = "npc1name"},
				{type = "textline", content = {hint = "npc #2 name",  width = 160}, id = "npc2name"},
				{type = "textline", content = {hint = "npc #2 dialogue"}, id = "npc2dialogue1", req = "npc2name"},
				{type = "textline", content = {hint = "npc #2 dialogue"}, id = "npc2dialogue2", req = "npc2name"},
				{type = "textline", content = {hint = "npc #2 dialogue"}, id = "npc2dialogue3", req = "npc2name"},
			}]]
			minpage = 1,
			maxpage = 9,
			weakpages = true,
			createPage = function(n)
				n = tostring(n)
				local page = {
					{type = "textline", content = {hint = ("npc #"..n).." name",  width = 160}, id = ("npc"..n).."name"}
				}
				for i=1,9 do
					local s = tostring(i)
					page[i + 1] = (
						{type = "textline", content = {hint = ("npc #"..n).." dialogue"}, id = ("npc"..n)..("dialogue"..s), req = ("npc"..n).."name"}
					)
				end
				return page
			end,
			initvarsPage = function(n, vars)
				local lvl = editor.level
				local npc = lvl.npcs[n] or {name = "", text = {"","","","","","","",""}}
				n = tostring(n)
				vars[("npc" .. n) .. "name"] = npc.name or ""
				for i=1,9 do
					local s = tostring(i)
					vars[("npc" .. n) .. ("dialogue" .. s)] = npc.text[i] or ""
				end
			end
		},
		[4] = {
			name = "exits",
			elements = {
				{type = "text", content = "specify destinations for doors or exits with variant tags. exit 0 counts as winning the levelset"},
				{type = "textline", content = {hint = "exit #1 (x,y)", properties = {onlychars = consts.chars_coordinates}}, id = "exit1", check = consts["check_coordinatepair_orempty"]},
				{type = "textline", content = {hint = "exit #2 (x,y)", properties = {onlychars = consts.chars_coordinates}}, id = "exit2", check = consts["check_coordinatepair_orempty"]},
				{type = "textline", content = {hint = "exit #3 (x,y)", properties = {onlychars = consts.chars_coordinates}}, id = "exit3", check = consts["check_coordinatepair_orempty"]},
				{type = "textline", content = {hint = "exit #4 (x,y)", properties = {onlychars = consts.chars_coordinates}}, id = "exit4", check = consts["check_coordinatepair_orempty"]},
				{type = "textline", content = {hint = "exit #5 (x,y)", properties = {onlychars = consts.chars_coordinates}}, id = "exit5", check = consts["check_coordinatepair_orempty"]},
				{type = "textline", content = {hint = "exit #6 (x,y)", properties = {onlychars = consts.chars_coordinates}}, id = "exit6", check = consts["check_coordinatepair_orempty"]},
				{type = "textline", content = {hint = "exit #7 (x,y)", properties = {onlychars = consts.chars_coordinates}}, id = "exit7", check = consts["check_coordinatepair_orempty"]},
				{type = "textline", content = {hint = "exit #8 (x,y)", properties = {onlychars = consts.chars_coordinates}}, id = "exit8", check = consts["check_coordinatepair_orempty"]},
				{type = "textline", content = {hint = "exit #9 (x,y)", properties = {onlychars = consts.chars_coordinates}}, id = "exit9", check = consts["check_coordinatepair_orempty"]},
			}
		},
		[5] = {
			name = "resets",
			elements = {
				{type = "text", content = "reset various states when entering this room"},
				{type = "tickbox", content = "reset electricity", id = "resetelectricity"},
				{type = "tickbox", content = "reset voltage", id = "resetvoltage"},
				{type = "tickbox", content = "reset red/blue switches", id = "resetredblue"},
				{type = "tickbox", content = "reset cyan/yellow switches", id = "resetcyanyellow"},
			}
		}
	},
	initvars = function(vars)
		local lvl = editor.level
		vars["bgcolor"] = string.sub(lvl.background, 2, -1) --removes the pound sign
		vars["music"] = lvl.music or ""
		vars["levelwidth"] = tostring(editor.maptilewidth)
		vars["levelheight"] = tostring(editor.maptileheight)
		for i=1, 9 do
			vars["hint" .. tostring(i)] = lvl.hints[i] or ""
		end
		--[[
		for i=1, 2 do
			if lvl.npcs[i] then
				local npc = lvl.npcs[i]
				vars["npc" .. i .. "name"] = npc.name or ""
				vars["npc" .. i .. "dialogue1"] = npc.text[1] or ""
				vars["npc" .. i .. "dialogue2"] = npc.text[2] or ""
				vars["npc" .. i .. "dialogue3"] = npc.text[3] or ""
			else
				vars["npc" .. i .. "name"] = ""
				vars["npc" .. i .. "dialogue1"] = ""
				vars["npc" .. i .. "dialogue2"] = ""
				vars["npc" .. i .. "dialogue3"] = ""
			end
		end
		]]
		
		for i=1, 9 do
			vars["exit" .. tostring(i)] = lvl.exits[i] or ""
		end
		vars["resetelectricity"] = lvl.options["resetelectricity"]
		vars["resetvoltage"] = lvl.options["resetvoltage"]
		vars["resetredblue"] = lvl.options["resetredblue"]
		vars["resetcyanyellow"] = lvl.options["resetcyanyellow"]
	end,
	onok = function(self)
		if not self.changesmade then
			return
		end
		editor.notempty(true)
		editor.makeunsaved()
		local vars = self.vars
		local lvl = editor.level
		if self.clicked_bytab["main"] then
			if self.clicked_byid["bgcolor"] then lvl.background = "#" .. vars["bgcolor"] end
			if self.clicked_byid["music"] then lvl.music = vars["music"] end
			local doresize = false
			local width = editor.maptilewidth
			local height = editor.maptileheight
			if self.clicked_byid["levelwidth"] then
				doresize = true
				width = tonumber(vars["levelwidth"])
				if (not width) or width <= 0 then
					width = 1
					print("level width isn't a number?? gj")
				end
			end
			if self.clicked_byid["levelheight"] then
				doresize = true
				height = tonumber(vars["levelheight"])
				if (not height) or height <= 0 then
					height = 1
					print("level height isn't a number?? gj")
				end
			end
			if doresize then
				editor.resizelevel(width, height)
			end
		end
		if self.clicked_bytab["hints"] then
			local nonempty = false
			for i=9, 1, -1 do
				lvl.hints[i] = nil
				local hint = vars["hint" .. tostring(i)]
				if hint ~= "" or nonempty then
					nonempty = true
					lvl.hints[i] = hint
				end
			end
		end
		if self.clicked_bytab["npcs"] then
			for i=1, 9 do
				if self.clicked_bytab["npcs"][i] then --page i
					local npcno = "npc" .. i
					if vars[npcno .. "name"] and vars[npcno .. "name"] ~= "" then
						if not lvl.npcs[i] then lvl.npcs[i] = {} end
						lvl.npcs[i].name = vars[npcno .. "name"]
						if not lvl.npcs[i].text then lvl.npcs[i].text = {} end
						for ii=1, 9 do
							local dialogue = vars[npcno .. "dialogue" .. ii]
							if dialogue ~= "" then
								lvl.npcs[i].text[ii] = dialogue
							end
						end
					end
				end
			end
		end
		if self.clicked_bytab["exits"] then
			local nonempty = false
			for i=9, 1, -1 do
				lvl.exits[i] = nil
				local exit = vars["exit" .. tostring(i)]
				if exit ~= "" or nonempty then
					nonempty = true
					lvl.exits[i] = exit
				end
			end
		end
		if self.clicked_bytab["resets"] then
			lvl.options["resetelectricity"] = vars["resetelectricity"]
			lvl.options["resetvoltage"] = vars["resetvoltage"] 
			lvl.options["resetredblue"] = vars["resetredblue"]
			lvl.options["resetcyanyellow"] = vars["resetcyanyellow"]
		end
	end
}

boxes.levelsetproperties = {
	title = "levelset properties",
	hasyesno = true,
	tabs = {
		[1] = {
			name = "main",
			elements = {
				{type = "text", content = "levelset name:"},
				{type = "textline", content = {hint = "type here"}, id = "name",
					check = function(self)
						local input = self.box.vars[self.id]
						if (not input) or input == "" then
							return false, "bless it with a name"
						elseif not string.find(input, "%S") then
							return false, "something visible would be nice"
						end
						return true
					end
				},
				{type = "text", content = "levelset author:"},
				{type = "textline", content = {hint = "type here"}, id = "author",
					check = function(self)
						local input = self.box.vars[self.id]
						if (not input) or input == "" then
							self.box.vars[self.id] = "(?)"
						elseif not string.find(input, "%S") then
							self.box.vars[self.id] = "(?)"
						end
						return true
					end
				},
				{type = "text", content = "levelset description:"},
				{type = "textline", content = {hint = "type here"}, id = "description"},
				{type = "text", content = "first room:"},
				{type = "textline", content = {hint = "room coordinates (x,y)"}, id = "firstroom",
					check = function(self)
						local success, message = consts["check_coordinatepair"](self)
						if not success then
							return success, message
						end
						local input = self.box.vars[self.id]
						local test = split(input, ",")
						if (not editor.extantrooms[tonumber(test[2])]) or (not editor.extantrooms[tonumber(test[2])][tonumber(test[1])]) then
							return false, "no room exists at those coordinates"
						end
						return true
					end,
					properties = {onlychars = consts.chars_coordinates}},
				{type = "text", content = "end viewport sizes with \"p\" to measure in pixels instead of tiles"},
				{type = "text", content = "viewport width (tiles):"},
				{type = "textline", content = {hint = "enter a number (p for pixels)", properties = {onlychars = consts["chars_integers_viewport"], maxlength = 4}}, id = "viewportwidth", check = consts["check_viewportsize_tiles"]},
				{type = "text", content = "viewport height (tiles):"},
				{type = "textline", content = {hint = "enter a number (p for pixels)", properties = {onlychars = consts["chars_integers_viewport"], maxlength = 4}}, id = "viewportheight", check = consts["check_viewportsize_tiles"]},
				{type = "tickbox", content = "automatic flipscreen exits", id = "flipscreen"},
			}
		},
		[2] = {
			name = "gems",
			elements = {
				{type = "text", content = "the following 2 fields are purely for player convenience and are shown in the save screen"},
				--{type = "tickbox", content = "show total rooms with blue gems:", id = "showbluegems"},
				{type = "text", content = "total rooms with blue gems:"},
				{type = "textline", content = {hint = "enter a number", properties = {onlychars = consts["chars_integers_nonnegative"], maxlength = 5}, width = 128}, id = "totalbluegems", check = consts["check_uint16_or_empty"]},
				--{type = "tickbox", content = "show total rooms with red gems:", id = "showredgems"},
				{type = "text", content = "total rooms with red gems:"},
				{type = "textline", content = {hint = "enter a number", properties = {onlychars = consts["chars_integers_nonnegative"], maxlength = 5}, width = 128}, id = "totalredgems", check = consts["check_uint16_or_empty"]},
				{type = "recountgemsbutton"}
			}
		},
		--[[ --not done
		[3] = {
			name = "song IDs",
			--{type = "text", content = "numeric slots for music"},
			minpage = 1,
			maxpage = 9,
			weakpages = true,
			createPage = function(n)
				local page = {}
				for i=1,10 do
					local s = tostring(((n - 1) * 10) + i)
					page[i] = (
						{type = "textline", content = {hint = ("song #"..s)}, id = ("song"..s)}
					)
				end
				return page
			end,
			initvarsPage = function(n, vars)
				local songs = editor.levelset.info.songs
				for i=1,9 do
					local s = (((n - 1) * 10) + i)
					vars["song"..tostring(s)] = songs[s] or ""
				end
			end
		},
		]]
	},
	initvars = function(vars)
		vars["name"] = editor.levelset.info.name
		vars["author"] = editor.levelset.info.author or "(?)"
		vars["description"] = editor.levelset.info.description
		vars["firstroom"] = editor.levelset.info.firstroom
		
		----viewport handling----
		local viewportwidth = editor.levelset.info.viewportwidth or editor.levelset.info.screenwidth or "" --this is a string
		if viewportwidth ~= "" then
			local n = tonumber(viewportwidth)
			if not n then error("viewportwidth couldn't be tonumbered. " .. tostring(viewportwidth)) end
			if n % tilesize == 0 then
				viewportwidth = tostring(math.floor(n / tilesize))
			else
				viewportwidth = viewportwidth .. "p"
			end
		end
		vars["viewportwidth"] = viewportwidth
		local viewportheight = editor.levelset.info.viewportheight or editor.levelset.info.screenheight or ""
		if viewportheight ~= "" then
			local n = tonumber(viewportheight)
			if not n then error("viewportheight couldn't be tonumbered. " .. tostring(viewportheight)) end
			if n % tilesize == 0 then
				viewportheight = tostring(math.floor(n / tilesize))
			else
				viewportheight = viewportheight .. "p"
			end
		end
		vars["viewportheight"] = viewportheight
		----end viewport handling----
		
		vars["flipscreen"] = (editor.levelset.info.flipscreen == "true")
		
		local bg = editor.levelset.info.totalbluegems
		vars["totalbluegems"] = bg and tostring(bg) or "0"
		local rg = editor.levelset.info.totalbluegems
		vars["totalredgems"] = rg and tostring(rg) or "0"
	end,
	onok = function(self)
		if not self.changesmade then
			return
		end
		local vars = self.vars
		editor.levelset.info.name = vars["name"]
		editor.levelset.info.author = vars["author"]
		editor.levelset.info.description = vars["description"]
		editor.levelset.info.firstroom = vars["firstroom"]
		editor.levelset.info.screenwidth = nil
		editor.levelset.info.screenheight = nil
		
		----viewport handling----
		local viewportwidth = editor.levelset.info.viewportwidth
		if self.clicked_byid["viewportwidth"] then
			viewportwidth = nil
			if vars["viewportwidth"] == "" then vars["viewportwidth"] = nil end
			if vars["viewportwidth"] then
				viewportwidth = vars["viewportwidth"]
				if viewportwidth:sub(-1):lower() == "p" then
					viewportwidth = tonumber(viewportwidth:sub(1,-2))
				else
					viewportwidth = tonumber(viewportwidth) * tilesize
				end
				if viewportwidth == baseWidth then --don't bother storing the width if it's the default
					viewportwidth = nil
				end
			end
			if viewportwidth then viewportwidth = tonumber(viewportwidth) end
		end
		local viewportheight = editor.levelset.info.viewportheight
		if self.clicked_byid["viewportheight"] then
			viewportheight = nil
			if vars["viewportheight"] == "" then vars["viewportheight"] = nil end
			if vars["viewportheight"] then
				viewportheight = vars["viewportheight"]
				if viewportheight:sub(-1):lower() == "p" then
					viewportheight = tonumber(viewportheight:sub(1,-2))
				else
					viewportheight = tonumber(viewportheight) * tilesize
				end
				if viewportheight == baseHeight then --don't bother storing the height if it's the default
					viewportheight = nil
				end
			end
			if viewportheight then viewportheight = tonumber(viewportheight) end
		end
		if self.clicked_bytab["songs"] then
			local songs = levelset.info.songs
			for n=1, 9 do
				if self.clicked_bytab["songs"][n] then --page
					for i=1, 10 do
						local s = (((n - 1) * 10) + i)
						local song = vars["song" .. tostring(s)]
						if song ~= "" then
							songs[s] = song
						else
							songs[s] = nil
						end
					end
				end
			end
		end
		editor.levelset.info.viewportwidth = viewportwidth
		editor.levelset.info.viewportheight = viewportheight
		game.setviewport(viewportwidth, viewportheight)
		----end viewport handling----
		
		editor.levelset.info.flipscreen = tostring(vars["flipscreen"])
		game.flipscreen = vars["flipscreen"]
		editor.levelset.info.showbluegems = vars["showbluegems"]
		editor.levelset.info.totalbluegems = tonumber(vars["totalbluegems"])
		editor.levelset.info.showredgems = vars["showredgems"]
		editor.levelset.info.totalredgems = tonumber(vars["totalredgems"])
		writeto("levelsetinfo")
	end
}

boxes.cheat = {
	title = "cheat!!!",
	hasyesno = true,
	tabs = {
		[1] = {
			name = "main",
			elements = {
				{type = "text", content = "enter a cheat code:"},
				{type = "textline", content = {hint = "type here"}, id = "cheat",
					check = function(self)
						local input = self.box.vars[self.id]
						if input == "" then return true end
						local cht = cheat.get(input)
						if not cht then
							return false, "invalid code"
						end
						return true
					end
				},
			}
		}
	},
	initvars = function(vars) vars["cheat"] = "" end,
	onok = function(self)
		if self.vars["cheat"] == "" then return end
		local cht = cheat.get(self.vars["cheat"])
		if cht then
			menu.cheat(cht)
		end
	end
}
boxes.editorgoto = {
	title = "goto",
	hasyesno = true,
	tabs = {
		[1] = {
			name = "main",
			elements = {
				{type = "text", content = "go to room:"},
				{type = "textline", content = {hint = "room coordinates (x,y)"}, id = "goto", check = consts["check_coordinatepair_orempty"]},
			}
		}
	},
	onok = function(self)
		if self.vars["goto"] == "" then return end
		local coords = split(self.vars["goto"], ",")
		editor.gotoRoom(tonumber(coords[1]), tonumber(coords[2]))
	end
}
boxes.promo = {
	title = "i made a UI system!!1",
	tabs = {
		[1] = {
			name = "first tab",
			elements = {
				--{type = "text", content = "is this AWESOME or what"},
				{type = "text", content = "isn't this AWESOME"},
				{
					type = "tickbox",
					content = "nah",
					id = "liar",
					check = function(self)
						local input = self.box.vars[self.id]
						
						if input then
							return false, "untick this right now"
						end
						return true
					end
				},
			}
		},
		[2] = {
			name = "other tab",
			elements = {
				{
					type = "tickbox",
					content = "random tickbox",
					id = "lol",
				},
				{
					type = "tickbox",
					content = "random tickbox",
					id = "lol",
				},
				{
					type = "tickbox",
					content = "random tickbox",
					id = "lol",
				},
				{
					type = "tickbox",
					content = "random tickbox",
					id = "lol",
				},
				{
					type = "tickbox",
					content = "random tickbox",
					id = "lol",
				},
			}
		},
	},
	hasyesno = true,
	initvars = function(vars) end,
	onok = function(self)
	
	end
}
boxes.pagetest = {
	title = "page test",
	tabs = {
		[1] = {
			name = "first tab",
			pages = {
				[1] = {
				{type = "text", content = "isn't this AWESOME"},
					{
						type = "tickbox",
						content = "nah",
						id = "liar",
						check = function(self)
							local input = self.box.vars[self.id]
							
							if input then
								return false, "untick this right now"
							end
							return true
						end
					},
				},
				[2] = {
				{type = "text", content = "this one isnt as awesome :/"},
					{
						type = "tickbox",
						content = "yeah",
						id = "agreed"
					},
				},
			}
		},
		[2] = {
			name = "other tab",
			elements = {
				{type = "text", content = "theres stuff in yonder tab aswell woahh"},
				{
					type = "tickbox",
					content = "random tickbox",
					id = "lol",
				},
				{
					type = "tickbox",
					content = "random tickbox",
					id = "lol",
				},
				{
					type = "tickbox",
					content = "random tickbox",
					id = "lol",
				},
				{
					type = "tickbox",
					content = "random tickbox",
					id = "lol",
				},
				{
					type = "tickbox",
					content = "random tickbox",
					id = "lol",
				},
			}
		},
		[3] = {
			name = "createpage tab",
			anumber = 0,
			minpage = 1,
			maxpage = 5,
			weakpages = true,
			createPage = function(n)
				local anumber = boxes.pagetest.tabs[3].anumber
				boxes.pagetest.tabs[3].anumber = anumber + 1
				local tickboxtext = {"oh my gosh", "haha cool", "yeah i dunno", "not that cool", "i'm leaving"}
				local page = {
					{type = "text", content = "woahh welcome to page " .. tostring(n)},
					{
						type = "tickbox",
						content = tickboxtext[n],
						id = "cooltick" .. tostring(n)
					},
					{type = "text", content = "lol here's a number: " .. tostring(anumber)}
				}
				return page
			end,
		},
	},
	hasyesno = true,
	initvars = function(vars) end,
	onok = function(self)
	
	end
}
boxes.sisehtnysotop = {
	title = "HAHAHA",
	tabs = {
		[1] = {
			name = "main",
			elements = {
				{type = "text", content = "you said sisehtnysotop"}
			}
		}
	},
	width = 100,
	hasyesno = false
}