local E = {}
levelsymbols = {
	["  "] = {
		name = "Nothing",
		categories = {"tiles", "j1"},
		order = 1,
		tiles = E,
		objects = E,
		tooltip = "Pure, undiluted nothingness. Use with caution. (Or as an eraser.)" 
	},
	["t "] = {
		name = "Wall",
		categories = {"tiles", "j1"},
		order = 2,
		tiles = {"wall"},
		objects = E,
		tooltip = "Just a plain wall. Standard for blocking Ogmos and Ogmoey creatures." 
	},
	["t!"] = {
		name = "Backwall",
		categories = {"tiles", "j1"},
		order = 3,
		tiles = {"backwall"},
		objects = E,
		tooltip = "Painting walls light-gray makes them further away on average, studies show." 
	},
	["x "] = {
		name = "Spikeball",
		categories = {"tiles", "deadly", "j1"},
		order = 4,
		tiles = {"spike_ball"},
		objects = E,
		tooltip = "A spike so spiky it collapsed into a spherical shape." 
	},
	["M "] = {
		name = "Ogmo",
		hasplayer = true,
		categories = {"objects", "mobs", "j1"},
		order = 5,
		tiles = E,
		objects = {"ogmo"},
		tooltip = "The man. The myth. The legend. Well, maybe not a man, but Ogmo regardless." 
	},
	["M\""] = {
		name = "Ghost Block",
		categories = {"objects", "mobs", "j1"},
		order = 6,
		tiles = E,
		objects = {"ogmo|ghost"},
		tooltip = "It copies your movements, and you die if it dies." 
	},
	["M!"] = {
		name = "Blob",
		hasplayer = true,
		categories = {"objects", "mobs", "j4r"},
		order = 7,
		tiles = E,
		objects = {"blob"},
		tooltip = "A helpful, harmless blob. You can move it in 4 directions."
	},
	["O "] = {
		name = "Choice Block A",
		categories = {"objects", "j4r"},
		order = 8,
		rotations = {"O!", "O!"},
		tiles = E,
		objects = {"choiceblock"},
		tooltip = "The solidity of this block is the player's choice! It's solid only if Choice is ON." 
	},
	["O!"] = {
		name = "Choice Block B",
		categories = {"objects", "j4r"},
		order = 9,
		rotations = {"O ", "O "},
		tiles = E,
		objects = {"choiceblock|inverse"},
		tooltip = "The solidity of this block is the player's choice! It's solid only if Choice is OFF." 
	},
	[" !"] = {
		name = "Exit",
		hasexit = true,
		categories = {"objects", "invisible", "j1"},
		rotations = {" \"", " \""},
		order = 10,
		tiles = E,
		objects = {"win"},
		tooltip = "If placed on a border, leads to the bordering room. Specify any room with a Variant tag; Variant 0 brings up the win screen."
	},
	[" \""] = {
		name = "Exit (flipscreen)",
		hasexit = true,
		fluidwin = true,
		categories = {"objects", "invisible", "j4r"},
		rotations = {" !", " !"},
		order = 10.5,
		tiles = E,
		objects = {"win|alt"},
		tooltip = "doesn't save the game. if this is on a border & has an ogmo on it, the ogmo will only spawn if entering from this direction"
	},
	["t\""] = {
		name = "Cloud",
		categories = {"tiles", "decor"},
		order = 12,
		tiles = {"cloud"},
		objects = E,
		tooltip = "A cloud. Completely decorative. Tends to make more sense outside." 
	},
	["t#"] = {
		name = "Dirt",
		categories = {"tiles"},
		order = 13,
		tiles = {"dirt"},
		objects = E,
		tooltip = "It's a big ol' clump of dirt!" 
	},
	["t$"] = {
		name = "Backdirt",
		categories = {"tiles"},
		order = 14,
		tiles = {"dirtbg"},
		objects = E,
		tooltip = "A clump of dirt, much further away." 
	},
	["t%"] = {
		name = "Grass Block",
		categories = {"tiles"},
		order = 15,
		tiles = {"dirt", "grass"},
		objects = E,
		tooltip = "A grassy floor, now with 80% less ticks!" 
	},
	["t&"] = {
		name = "Black",
		categories = {"tiles", "j1"},
		order = 17,
		tiles = {"black"},
		objects = E,
		tooltip = "Blackness lies beyond the walls of the facility." 
	},
	["t'"] = {
		name = "lone grass",
		categories = {"tiles"},
		order = 18,
		tiles = {"grass"},
		objects = E,
		tooltip = "grass with no dirt. you can jump on top of it and duck through it", 
	},
	["t("] = {
		name = "reserved",
		order = 9026,
		rotations = E,
		tiles = {"outline_uldr"},
		objects = E,
		tooltip = "shouldn't be seeable",
		nevershow = true
	},
	["t)"] = {
		name = "Slab (Down)",
		categories = {"tiles"},
		rotations = {"t,", "t*"},
		order = 20,
		tiles = {"slabS"},
		objects = E,
		tooltip = "When you said these were \"half off\", I didn't know that's what you meant..." 
		--lol
	},
	["t*"] = {
		name = "Slab (Right)",
		categories = {"tiles"},
		rotations = {"t)", "t+"},
		order = 21,
		tiles = {"slabE"},
		objects = E,
		tooltip = "When you said these were \"half off\", I didn't know that's what you meant..." 
	},
	["t+"] = {
		name = "Slab (Up)",
		categories = {"tiles"},
		rotations = {"t*", "t,"},
		order = 22,
		tiles = {"slabN"},
		objects = E,
		tooltip = "When you said these were \"half off\", I didn't know that's what you meant..." 
		--lol
	},
	["t,"] = {
		name = "Slab (Left)",
		categories = {"tiles"},
		rotations = {"t+", "t)"},
		order = 23,
		tiles = {"slabW"},
		objects = E,
		tooltip = "When you said these were \"half off\", I didn't know that's what you meant..." 
	},
	["t-"] = {
		name = "Rubber",
		categories = {"tiles", "j4r"},
		order = 24,
		tiles = {"rubber"},
		objects = E,
		tooltip = "It's a block made of rubber. You bounce off of it, rather than being erased. That's good." 
	},
	["t."] = {
		name = "reserved",
		order = 9026,
		tooltip = "shouldn't be seeable",
		nevershow = true
	},
	["t/"] = {
		name = "reserved",
		order = 9026,
		tooltip = "shouldn't be seeable",
		nevershow = true
	},
	["t0"] = {
		name = "reserved",
		order = 9026,
		tooltip = "shouldn't be seeable",
		nevershow = true
	},
	["t1"] = {
		name = "reserved",
		order = 9026,
		tooltip = "shouldn't be seeable",
		nevershow = true
	},
	["t2"] = {
		name = "Slope (Down-Right)",
		categories = {"tiles"},
		rotations = {"t3", "t5"},
		order = 29,
		tiles = {"slopeSE"},
		objects = E,
		tooltip = "Spice things up with a 45-degree angle! Ogmo can't walk up it, sadly." 
	},
	["t3"] = {
		name = "Slope (Down-Left)",
		categories = {"tiles"},
		rotations = {"t4", "t2"},
		order = 30,
		tiles = {"slopeSW"},
		objects = E,
		tooltip = "Spice things up with a 45-degree angle! Ogmo can't walk up it, sadly."
	},
	["t4"] = {
		name = "Slope (Up-Left)",
		categories = {"tiles"},
		rotations = {"t5", "t3"},
		order = 31,
		tiles = {"slopeNW"},
		objects = E,
		tooltip = "Spice things up with a 45-degree angle!"
	},
	["t5"] = {
		name = "Slope (Up-Right)",
		categories = {"tiles"},
		rotations = {"t2", "t4"},
		order = 32,
		tiles = {"slopeNE"},
		objects = E,
		tooltip = "Spice things up with a 45-degree angle!"
	},
	["O\""] = {
		name = "Jump Arrow",
		categories = {"objects", "j1"},
		order = 33,
		tiles = E,
		objects = {"jumparrow"},
		tooltip = "Restores your double jump if you've used it. Takes a while to regenerate. Use a \"facing\" tag to make it move." 
	},
	["t6"] = {
		name = "Dev Wall",
		categories = {"tiles"},
		order = 34,
		tiles = {"dev_wall"},
		objects = E,
		tooltip = "A relic of a simpler era. (An era that lasted 1 month.)" 
	},
	["t7"] = {
		name = "Dev Backwall",
		categories = {"tiles"},
		order = 35,
		tiles = {"dev_backwall"},
		objects = E,
		tooltip = "A relic of a simpler era. (An era that lasted 1 month.)"
	},
	["x!"] = {
		name = "Dev Death",
		categories = {"tiles"},
		order = 36,
		tiles = {"dev_death"},
		objects = E,
		tooltip = "A relic of a simpler era. (An era that lasted 1 month.)"
	},
	["x\""] = {
		name = "Spikes (Up)",
		categories = {"tiles", "deadly", "j1"},
		rotations = {"x%", "x#"},
		order = 37,
		tiles = {"spikesS"},
		objects = E,
		tooltip = "Just pointy enough to menace Ogmo without raising a safety hazard." 
	},
	["x#"] = {
		name = "Spikes (Left)",
		categories = {"tiles", "deadly", "j1"},
		rotations = {"x\"", "x$"},
		order = 38,
		tiles = {"spikesE"},
		objects = E,
		tooltip = "Just pointy enough to menace Ogmo without raising a safety hazard."
	},
	["x$"] = {
		name = "Spikes (Down)",
		categories = {"tiles", "deadly", "j1"},
		rotations = {"x#", "x%"},
		order = 39,
		tiles = {"spikesN"},
		objects = E,
		tooltip = "Just pointy enough to menace Ogmo without raising a safety hazard."
	},
	["x%"] = {
		name = "Spikes (Right)",
		categories = {"tiles", "deadly", "j1"},
		rotations = {"x$", "x\""},
		order = 40,
		tiles = {"spikesW"},
		objects = E,
		tooltip = "Just pointy enough to menace Ogmo without raising a safety hazard."
	},
	["x&"] = {
		name = "Short Spikes (Up)",
		categories = {"tiles", "deadly"},
		rotations = {"x)", "x'"},
		order = 41,
		tiles = {"shortspikesS"},
		objects = E,
		tooltip = "Shorter, perhaps, but no less pointy and dangerous." 
	},
	["x'"] = {
		name = "Short Spikes (Left)",
		categories = {"tiles", "deadly"},
		rotations = {"x&", "x("},
		order = 42,
		tiles = {"shortspikesE"},
		objects = E,
		tooltip = "Shorter, perhaps, but no less pointy and dangerous."
	},
	["x("] = {
		name = "Short Spikes (Down)",
		categories = {"tiles", "deadly", "j2"},
		rotations = {"x'", "x)"},
		order = 43,
		tiles = {"shortspikesN"},
		objects = E,
		tooltip = "Shorter, perhaps, but no less pointy and dangerous. Ogmo can slide under this." 
	},
	["x)"] = {
		name = "Short Spikes (Right)",
		categories = {"tiles", "deadly"},
		rotations = {"x(", "x&"},
		order = 44,
		tiles = {"shortspikesW"},
		objects = E,
		tooltip = "Shorter, perhaps, but no less pointy and dangerous."
	},
	["O#"] = {
		name = "Hint Block",
		categories = {"objects", "j2"},
		order = 45,
		tiles = E,
		objects = {"hintblock"},
		tooltip = "shows you some text when you hit it from below" 
	},
	["O$"] = {
		name = "Door",
		hasexit = true,
		categories = {"objects", "j4r"},
		order = 46,
		tiles = E,
		objects = {"door"},
		tooltip = "similar to an exit, but requires interacting with it" 
	},
	["t8"] = {
		name = "Darkness",
		categories = {"tiles"},
		order = 47,
		tiles = {"dark"},
		objects = E,
		tooltip = "add a bit of dark to enhance the mood" 
	},
	["t9"] = {
		name = "Lightness",
		categories = {"tiles"},
		order = 48,
		tiles = {"light"},
		objects = E,
		tooltip = "add a bit of light to detract from the mood" 
	},
	["O%"] = {
		name = "launcher",
		categories = {"objects", "j1"},
		rotations = {"O*", "O&"},
		order = 49,
		tiles = E,
		objects = {"launcher"},
		tooltip = "launches ogmo" 
	},
	["O&"] = {
		name = "blue launcher",
		categories = {"objects", "jr"},
		rotations = {"O%", "O'"},
		order = 50,
		tiles = E,
		objects = {"launcher|variant:fast"},
		tooltip = "launches ogmo, but faster" 
	},
	["O'"] = {
		name = "yellow launcher",
		categories = {"objects", "j2e"},
		rotations = {"O&", "O("},
		order = 51,
		tiles = E,
		objects = {"launcher|variant:fragile"},
		tooltip = "launches ogmo but breaks upon use" 
	},
	["O("] = {
		name = "remote launcher",
		categories = {"objects", "j4r"},
		rotations = {"O'", "O)"},
		order = 52,
		tiles = E,
		objects = {"launcher|variant:remote"},
		tooltip = "it launches you AFTER you touch it, when you're no longer inside it. trippy!" 
	},
	["O)"] = {
		name = "twin launcher",
		categories = {"objects", "j4r"},
		rotations = {"O(", "O*"},
		order = 53,
		tiles = E,
		objects = {"launcher|variant:twin"},
		tooltip = "a launcher with two cannons. i wonder what that could mean" 
	},
	["O*"] = {
		name = "inert launcher",
		categories = {"objects", "j4r"},
		rotations = {"O)", "O%"},
		order = 54,
		tiles = E,
		objects = {"launcher|variant:inert"},
		tooltip = "a launcher with no cannon, and yet it can still send you flying." 
	},
	["O+"] = {
		name = "savepoint",
		categories = {"objects", "j4r"},
		rotations = {"Oo", "Oo"},
		order = 55,
		tiles = E,
		objects = {"checkpoint|savepoint:yes"},
		--tooltip = "after this is touched, dying respawns you at a different spawn number. specify which with a tag" 
		tooltip = "Like the checkpoint, but also saves the game."
	},
	["O,"] = {
		name = "switch pad (red/blue)",
		categories = {"objects", "j2"},
		rotations = {"O.", "O-"},
		order = 56,
		tiles = E,
		objects = {"switchpad"},
		tooltip = "ducking on this toggles the solidity of blue and red switchblocks. place 2 in a row for a wide switch pad" 
	},
	["t:"] = {
		name = "Red Switchblock",
		categories = {"tiles", "j2"},
		rotations = {"t=", "t;"},
		order = 57,
		tiles = {"redblock_on"},
		objects = E,
		tooltip = "red switchblock. starts on" 
	},
	["t;"] = {
		name = "Blue Switchblock",
		categories = {"tiles", "j2"},
		rotations = {"t:", "t<"},
		order = 58,
		tiles = {"blueblock_on"},
		objects = E,
		tooltip = "blue switchblock. starts off" 
	},
	["t<"] = {
		name = "Red Switchblock (inverse)",
		categories = {"tiles", "j4r"},
		rotations = {"t;", "t="},
		order = 61,
		tiles = {"redblock_off"},
		objects = E,
		tooltip = "red switchblock. starts off" 
	},
	["t="] = {
		name = "Blue Switchblock (inverse)",
		categories = {"tiles", "j4r"},
		rotations = {"t<", "t:"},
		order = 62,
		tiles = {"blueblock_off"},
		objects = E,
		tooltip = "blue switchblock. starts on" 
	},
	["x*"] = {
		name = "Red Switchspike",
		categories = {"tiles", "deadly", "j2"},
		rotations = {"x-", "x+"},
		order = 59,
		tiles = {"redspike_on"},
		objects = E,
		tooltip = "red switchspike. starts on" 
	},
	["x+"] = {
		name = "Blue Switchspike",
		categories = {"tiles", "deadly", "j2"},
		rotations = {"x*", "x,"},
		order = 60,
		tiles = {"bluespike_on"},
		objects = E,
		tooltip = "blue switchspike. starts off" 
	},
	["x,"] = {
		name = "Red Switchspike (inverse)",
		categories = {"tiles", "deadly", "j4r"},
		rotations = {"x+", "x-"},
		order = 63,
		tiles = {"redspike_off"},
		objects = E,
		tooltip = "red switchspike. starts off" 
	},
	["x-"] = {
		name = "Blue Switchspike (inverse)",
		categories = {"tiles", "deadly", "j4r"},
		rotations = {"x,", "x*"},
		order = 64,
		tiles = {"bluespike_off"},
		objects = E,
		tooltip = "blue switchspike. starts on" 
	},
	["O-"] = {
		name = "switch pad (singlet red)",
		categories = {"objects", "j4r"},
		rotations = {"O,", "O."},
		order = 65,
		tiles = E,
		objects = {"switchpad|singlet:red"},
		tooltip = "ducking on this toggles the solidity of red switchblocks ONLY. place 2 in a row for a wide switch pad" 
	},
	["O."] = {
		name = "switch pad (singlet blue)",
		categories = {"objects", "j4r"},
		rotations = {"O-", "O,"},
		order = 66,
		tiles = E,
		objects = {"switchpad|singlet:blue"},
		tooltip = "ducking on this toggles the solidity of blue switchblocks ONLY. place 2 in a row for a wide switch pad" 
	},
	["O/"] = {
		name = "fallblock",
		categories = {"objects", "j1"},
		rotations = {"O2", "O0"},
		order = 67,
		tiles = E,
		objects = {"fallblock"},
		tooltip = "falls soon after you land on it" 
	},
	["O0"] = {
		name = "boombox",
		categories = {"objects", "j2e"},
		rotations = {"O/", "O2"},
		order = 68,
		tiles = E,
		objects = {"fallblock|boombox:yep"},
		tooltip = "blows up shortly after you touch it" 
	},
	["t>"] = {
		name = "cracked block",
		categories = {"tiles", "j2"},
		rotations = E,
		order = 69,
		tiles = {"crackblock"},
		objects = E,
		tooltip = "wall that breaks when you walljump off of it" 
	},
	["O1"] = {
		name = "pressure pad",
		categories = {"objects", "j1"},
		rotations = E,
		order = 70,
		tiles = E,
		objects = {"pressurepad"},
		tooltip = "when all pressure pads have something on them, green gates open" 
	},
	["O2"] = {
		name = "x-block",
		categories = {"objects", "j4r"},
		rotations = {"O0", "O/"},
		order = 69.5,
		tiles = E,
		objects = {"fallblock|xbox:yep"},
		tooltip = "blows up once you stop making contact with it" 
	},
	["O3"] = {
		name = "pressure-pad gate (top)",
		categories = {"objects", "j1"},
		rotations = {"O4", "O4"},
		order = 71,
		tiles = E,
		objects = {"gate|dir:up|kind:button"},
		tooltip = "goes up while all pressure pads are held" 
	},
	["O4"] = {
		name = "pressure-pad gate (bottom)",
		categories = {"objects", "j1"},
		rotations = {"O3", "O3"},
		order = 72,
		tiles = E,
		objects = {"gate|dir:down|kind:button"},
		tooltip = "goes down while all pressure pads are held" 
	},
	["O5"] = {
		name = "arrow gate (top)",
		categories = {"objects", "jr"},
		rotations = {"O6", "O6"},
		order = 73,
		tiles = E,
		objects = {"gate|dir:up|kind:arrow"},
		tooltip = "goes up, permanently, after all arrows are inactive at once" 
	},
	["O6"] = {
		name = "arrow gate (bottom)",
		categories = {"objects", "jr"},
		rotations = {"O5", "O5"},
		order = 74,
		tiles = E,
		objects = {"gate|dir:down|kind:arrow"},
		tooltip = "goes down, permanently, after all arrows are inactive at once" 
	},
	["O7"] = {
		name = "crate (wood)",
		categories = {"objects", "mobs", "j1"},
		rotations = {"OY", "O8"},
		order = 75,
		tiles = E,
		objects = {"crate"},
		tooltip = "a crate you can push around. can hold down pressure pads" 
	},
	["O8"] = {
		name = "crate (iron)",
		categories = {"objects", "mobs", "j2e"}, --technically j2 since ogmobots were basically iron crates but with a special interaction with jump pads
		rotations = {"O7", "O9"},
		order = 76,
		tiles = E,
		objects = {"crate|kind:iron"},
		tooltip = "a crate that's too heavy to push" 
	},
	["O9"] = {
		name = "crate (turbo)",
		categories = {"objects", "mobs", "j4r"},
		rotations = {"O8", "OY"},
		order = 77,
		tiles = E,
		objects = {"crate|kind:turbo"},
		tooltip = "a crate you can push very very fast" 
	},
	["O:"] = {
		name = "jump pad (up)",
		categories = {"objects", "j1"},
		rotations = {"O;", "O="},
		order = 78,
		tiles = E,
		objects = {"jumppad"},
		tooltip = "launches you up when you touch the top side" 
	},
	["O;"] = {
		name = "jump pad (left)",
		categories = {"objects"},
		rotations = {"O<", "O:"},
		order = 79,
		tiles = E,
		objects = {"jumppad|responsedir:left"},
		tooltip = "launches you left when you touch the left side" 
	},
	["O<"] = {
		name = "jump pad (down)",
		categories = {"objects"},
		rotations = {"O=", "O;"},
		order = 80,
		tiles = E,
		objects = {"jumppad|responsedir:down"},
		tooltip = "launches you down when you touch the bottom side" 
	},
	["O="] = {
		name = "jump pad (right)",
		categories = {"objects"},
		rotations = {"O:", "O<"},
		order = 81,
		tiles = E,
		objects = {"jumppad|responsedir:right"},
		tooltip = "launches you right when you touch the right side" 
	},
	["O>"] = {
		name = "fragile jump pad (up)",
		categories = {"objects", "j1"},
		rotations = {"O?", "OA"},
		order = 82,
		tiles = E,
		objects = {"jumppad|kind:fragile"},
		tooltip = "launches you up when you touch the top side" 
	},
	["O?"] = {
		name = "fragile jump pad (left)",
		categories = {"objects"},
		rotations = {"O@", "O>"},
		order = 83,
		tiles = E,
		objects = {"jumppad|responsedir:left|kind:fragile"},
		tooltip = "launches you left when you touch the left side" 
	},
	["O@"] = {
		name = "fragile jump pad (down)",
		categories = {"objects"},
		rotations = {"OA", "O?"},
		order = 84,
		tiles = E,
		objects = {"jumppad|responsedir:down|kind:fragile"},
		tooltip = "launches you down when you touch the bottom side" 
	},
	["OA"] = {
		name = "fragile jump pad (right)",
		categories = {"objects"},
		rotations = {"O>", "O@"},
		order = 85,
		tiles = E,
		objects = {"jumppad|responsedir:right|kind:fragile"},
		tooltip = "launches you right when you touch the right side" 
	},
	["OB"] = {
		name = "crate jump pad (up)",
		categories = {"objects", "j1e"},
		rotations = {"OC", "OE"},
		order = 86,
		tiles = E,
		objects = {"jumppad|kind:crate"},
		tooltip = "launches you up when you touch the top side" 
	},
	["OC"] = {
		name = "crate jump pad (left)",
		categories = {"objects"},
		rotations = {"OD", "OB"},
		order = 87,
		tiles = E,
		objects = {"jumppad|responsedir:left|kind:crate"},
		tooltip = "launches you left when you touch the left side" 
	},
	["OD"] = {
		name = "crate jump pad (down)",
		categories = {"objects"},
		rotations = {"OE", "OC"},
		order = 88,
		tiles = E,
		objects = {"jumppad|responsedir:down|kind:crate"},
		tooltip = "launches you down when you touch the bottom side" 
	},
	["OE"] = {
		name = "crate jump pad (right)",
		categories = {"objects"},
		rotations = {"OB", "OD"},
		order = 89,
		tiles = E,
		objects = {"jumppad|responsedir:right|kind:crate"},
		tooltip = "launches you right when you touch the right side" 
	},
	["M#"] = {
		name = "fireball",
		categories = {"objects", "mobs", "deadly", "j1"},
		rotations = E,
		order = 90,
		tiles = E,
		objects = {"fireball"},
		tooltip = "watch out for this! apply a \"face\" tag to make it move in a given direction" 
	},
	["t?"] = {
		name = "reverser",
		categories = {"tiles", "j1"},
		rotations = E,
		order = 91,
		tiles = {"reverser"},
		objects = E,
		tooltip = "fireballs and moving platforms will collide with this" 
	},
	--yay cyan/yellow switch variants (tiles)
	["t@"] = {
		name = "Cyan Switchblock",
		categories = {"tiles", "j4r"},
		rotations = {"tC", "tA"},
		order = 92,
		tiles = {"cyanblock_on"},
		objects = E,
		tooltip = "cyan switchblock. starts on" 
	},
	["tA"] = {
		name = "Yellow Switchblock",
		categories = {"tiles", "j4r"},
		rotations = {"t@", "tB"},
		order = 93,
		tiles = {"yellowblock_on"},
		objects = E,
		tooltip = "yellow switchblock. starts off" 
	},
	["tB"] = {
		name = "Cyan Switchblock (inverse)",
		categories = {"tiles", "j4r"},
		rotations = {"tA", "tC"},
		order = 96,
		tiles = {"cyanblock_off"},
		objects = E,
		tooltip = "cyan switchblock. starts off" 
	},
	["tC"] = {
		name = "Yellow Switchblock (inverse)",
		categories = {"tiles", "j4r"},
		rotations = {"tB", "t@"},
		order = 97,
		tiles = {"yellowblock_off"},
		objects = E,
		tooltip = "yellow switchblock. starts on" 
	},
	["x."] = {
		name = "Cyan Switchspike",
		categories = {"tiles", "deadly", "j4r"},
		rotations = {"x1", "x/"},
		order = 94,
		tiles = {"cyanspike_on"},
		objects = E,
		tooltip = "cyan switchspike. starts on" 
	},
	["x/"] = {
		name = "Yellow Switchspike",
		categories = {"tiles", "deadly", "j4r"},
		rotations = {"x.", "x0"},
		order = 95,
		tiles = {"yellowspike_on"},
		objects = E,
		tooltip = "yellow switchspike. starts off" 
	},
	["x0"] = {
		name = "Cyan Switchspike (inverse)",
		categories = {"tiles", "deadly", "j4r"},
		rotations = {"x/", "x1"},
		order = 98,
		tiles = {"cyanspike_off"},
		objects = E,
		tooltip = "cyan switchspike. starts off" 
	},
	["x1"] = {
		name = "Yellow Switchspike (inverse)",
		categories = {"tiles", "deadly", "j4r"},
		rotations = {"x0", "x."},
		order = 99,
		tiles = {"yellowspike_off"},
		objects = E,
		tooltip = "yellow switchspike. starts on" 
	},
	--cyan/yellow switch variants (objects)
	--100TH SYMBOL OMG!!! WE'VE COME SO FAR!!! (not. order doesn't actually mean "this is the nth symbol" it just specifies how the symbols should be sorted in symboldisplay)
	["OF"] = {
		name = "switch pad (cyan/yellow)",
		categories = {"objects", "j4r"},
		rotations = {"OH", "OG"},
		order = 100,
		tiles = E,
		objects = {"switchpad|secondary:yes"},
		tooltip = "ducking on this toggles the solidity of yellow and cyan switchblocks. place 2 in a row for a wide switch pad" 
	},
	["OG"] = {
		name = "switch pad (singlet cyan)",
		categories = {"objects", "j4r"},
		rotations = {"OF", "OH"},
		order = 101,
		tiles = E,
		objects = {"switchpad|singlet:cyan"},
		tooltip = "ducking on this toggles the solidity of cyan switchblocks ONLY. place 2 in a row for a wide switch pad" 
	},
	["OH"] = {
		name = "switch pad (singlet yellow)",
		categories = {"objects", "j4r"},
		rotations = {"OG", "OF"},
		order = 102,
		tiles = E,
		objects = {"switchpad|singlet:yellow"},
		tooltip = "ducking on this toggles the solidity of yellow switchblocks ONLY. place 2 in a row for a wide switch pad" 
	},
	["OI"] = {
		name = "follower block",
		categories = {"objects", "mobs", "j1"},
		rotations = {"OJ", "OJ"},
		order = 103,
		tiles = E,
		objects = {"follower"},
		tooltip = "it follows you horizontally. if there are multiple ogmos it follows one until it dies" 
	},
	["OJ"] = {
		name = "spiky follower block",
		categories = {"objects", "mobs", "deadly", "j2"},
		rotations = {"OI", "OI"},
		order = 104,
		tiles = E,
		objects = {"follower|deathly"},
		tooltip = "it follows you horizontally. and kills you! if there are multiple ogmos it follows one until it dies" 
	},
	["OK"] = {
		name = "gravity down",
		categories = {"objects", "j1e"},
		rotations = {"OM", "OL"},
		order = 105,
		tiles = E,
		objects = {"gee|kind:down"},
		tooltip = "decreases gravity for all ogmos in the level (does not apply to ghost blocks)" 
	},
	["OL"] = {
		name = "gravity up",
		categories = {"objects", "j1e"},
		rotations = {"OK", "OM"},
		order = 106,
		tiles = E,
		objects = {"gee|kind:up"},
		tooltip = "increases gravity for all ogmos in the level (does not apply to ghost blocks)" 
	},
	["OM"] = {
		name = "gravity reset",
		categories = {"objects", "j4r"},
		rotations = {"OL", "OK"},
		order = 107,
		tiles = E,
		objects = {"gee|kind:one"},
		tooltip = "resets gravity for all ogmos in the level" 
	},
	["ON"] = {
		name = "ghost gate (top)",
		categories = {"objects", "jr"},
		rotations = {"OO", "OO"},
		order = 74.1,
		tiles = E,
		objects = {"gate|dir:up|kind:ghost"},
		tooltip = "goes up once all ghost blocks are vanished" 
	},
	["OO"] = {
		name = "ghost gate (bottom)",
		categories = {"objects", "jr"},
		rotations = {"ON", "ON"},
		order = 74.2,
		tiles = E,
		objects = {"gate|dir:down|kind:ghost"},
		tooltip = "goes down once all ghost blocks are vanished" 
	},
	["OP"] = {
		name = "gold star",
		categories = {"objects", "j1"},
		rotations = {"OR", "OQ"},
		order = 108,
		tiles = E,
		objects = {"star|kind:gold"},
		tooltip = "restores your double jump, and undoes negative effects by other stars, then disappears" 
	},
	["OQ"] = {
		name = "gray star",
		categories = {"objects", "j1"},
		rotations = {"OP", "OR"},
		order = 109,
		tiles = E,
		objects = {"star|kind:gray"},
		tooltip = "makes you unable to jump until you get a gold star" 
	},
	["OR"] = {
		name = "purple star",
		categories = {"objects", "jr"},
		rotations = {"OQ", "Ov"},
		order = 110,
		tiles = E,
		objects = {"star|kind:purple"},
		tooltip = "reverses your left and right controls until you get a gold star" 
	},
	["OS"] = {
		name = "star gate (top)",
		categories = {"objects", "j1"},
		rotations = {"OT", "OT"},
		order = 72.8,
		tiles = E,
		objects = {"gate|dir:up|kind:star"},
		tooltip = "goes up once all stars are collected" 
	},
	["OT"] = {
		name = "star gate (bottom)",
		categories = {"objects", "j1"},
		rotations = {"OS", "OS"},
		order = 72.9,
		tiles = E,
		objects = {"gate|dir:down|kind:star"},
		tooltip = "goes down once all stars are collected" 
	},
	["x2"] = {
		name = "electricity (horizontal)",
		categories = {"tiles", "deadly", "electric", "j1"},
		rotations = {"x3", "x3"},
		order = 111,
		tiles = {"electricity_h"},
		objects = E,
		tooltip = "electricity. don't touch!" 
	},
	["x3"] = {
		name = "electricity (vertical)",
		categories = {"tiles", "deadly", "electric", "j1"},
		rotations = {"x2", "x2"},
		order = 112,
		tiles = {"electricity_v"},
		objects = E,
		tooltip = "electricity. don't touch!" 
	},
	["OU"] = {
		name = "electricity switch",
		categories = {"objects", "electric", "j1"},
		rotations = E,
		order = 113,
		tiles = E,
		objects = {"elecswitch"},
		tooltip = "toggles the electricity" 
	},
	["x4"] = {
		name = "electricity (cross)",
		categories = {"tiles", "deadly", "electric", "j1"},
		rotations = E,
		order = 114,
		tiles = {"electricity_c"},
		objects = E,
		tooltip = "electricity. don't touch!" 
	},
	["x5"] = {
		name = "electricity (t, down)",
		categories = {"tiles", "deadly", "electric", "j1"},
		rotations = {"x8", "x6"},
		order = 115,
		tiles = {"electricity_d"},
		objects = E,
		tooltip = "electricity. don't touch!" 
	},
	["x6"] = {
		name = "electricity (t, right)",
		categories = {"tiles", "deadly", "electric", "j1"},
		rotations = {"x5", "x7"},
		order = 116,
		tiles = {"electricity_r"},
		objects = E,
		tooltip = "electricity. don't touch!" 
	},
	["x7"] = {
		name = "electricity (t, up)",
		categories = {"tiles", "deadly", "electric", "j1"},
		rotations = {"x6", "x8"},
		order = 117,
		tiles = {"electricity_u"},
		objects = E,
		tooltip = "electricity. don't touch!" 
	},
	["x8"] = {
		name = "electricity (t, left)",
		categories = {"tiles", "deadly", "electric", "j1"},
		rotations = {"x7", "x5"},
		order = 118,
		tiles = {"electricity_l"},
		objects = E,
		tooltip = "electricity. don't touch!" 
	},
	
	["tD"] = {
		name = "low-voltage electricity (horizontal)",
		categories = {"tiles", "electric", "j1"},
		rotations = {"tE", "tE"},
		order = 119,
		tiles = {"felectricity_h"},
		objects = E,
		tooltip = "this electricity is safe to touch and mainly decorative" 
	},
	["tE"] = {
		name = "low-voltage electricity (vertical)",
		categories = {"tiles", "electric", "j1"},
		rotations = {"tD", "tD"},
		order = 120,
		tiles = {"felectricity_v"},
		objects = E,
		tooltip = "this electricity is safe to touch and mainly decorative" 
	},
	["tF"] = { --team fortress wtf?
		name = "low-voltage electricity (cross)",
		categories = {"tiles", "electric", "j1"},
		rotations = E,
		order = 121,
		tiles = {"felectricity_c"},
		objects = E,
		tooltip = "this electricity is safe to touch and mainly decorative" 
	},
	["tG"] = {
		name = "low-voltage electricity (t, down)",
		categories = {"tiles", "electric", "j1"},
		rotations = {"tJ", "tH"},
		order = 122,
		tiles = {"felectricity_d"},
		objects = E,
		tooltip = "this electricity is safe to touch and mainly decorative" 
	},
	["tH"] = {
		name = "low-voltage electricity (t, right)",
		categories = {"tiles", "electric", "j1"},
		rotations = {"tG", "tI"},
		order = 123,
		tiles = {"felectricity_r"},
		objects = E,
		tooltip = "this electricity is safe to touch and mainly decorative" 
	},
	["tI"] = {
		name = "low-voltage electricity (t, up)",
		categories = {"tiles", "electric", "j1"},
		rotations = {"tH", "tJ"},
		order = 124,
		tiles = {"felectricity_u"},
		objects = E,
		tooltip = "this electricity is safe to touch and mainly decorative" 
	},
	["tJ"] = {
		name = "low-voltage electricity (t, left)",
		categories = {"tiles", "electric", "j1"},
		rotations = {"tI", "tG"},
		order = 125,
		tiles = {"felectricity_l"},
		objects = E,
		tooltip = "this electricity is safe to touch and mainly decorative" 
	},
	["OV"] = {
		name = "electric gate (top)",
		categories = {"objects", "j1"},
		rotations = {"OW", "OW"},
		order = 70.8,
		tiles = E,
		objects = {"gate|dir:up|kind:elec"},
		tooltip = "goes up while the electricity is on" 
	},
	["OW"] = { -- :(
		name = "electric gate (bottom)",
		categories = {"objects", "j1"},
		rotations = {"OV", "OV"},
		order = 70.9,
		tiles = E,
		objects = {"gate|dir:down|kind:elec"},
		tooltip = "goes down while the electricity is on" 
	},
	["OX"] = {
		name = "voltage switch",
		categories = {"objects", "electric", "j4r"},
		rotations = E,
		order = 126,
		tiles = E,
		objects = {"elecswitch|voltage:yeah"},
		tooltip = "toggles low-voltage (harmless) electricity and normal electricity" 
	},
	["OY"] = {
		name = "tnt",
		categories = {"objects", "mobs", "j2"},
		rotations = {"O9", "O7"},
		order = 77.1,
		tiles = E,
		objects = {"crate|kind:tnt"},
		tooltip = "pushable. if it falls, destroys whatever it lands on" 
	},
	["OZ"] = {
		name = "conveyor (right)",
		categories = {"objects", "j2"},
		rotations = E,
		order = 127,
		tiles = E,
		objects = {"conveyor|dir:right"},
		tooltip = "it conveys" 
	},
	["O["] = {
		name = "conveyor (left)",
		categories = {"objects", "j2"},
		rotations = E,
		order = 128,
		tiles = E,
		objects = {"conveyor|dir:left"},
		tooltip = "it conveys (but leftward)" 
	},
	["O\\"] = {
		name = "platform",
		categories = {"objects", "mobs", "j1"},
		rotations = E,
		order = 129,
		tiles = E,
		objects = {"platform"},
		tooltip = "it platforms. use facing tags to set direction (left or right). put 2 together for a wide platform" 
	},
	["O]"] = {
		name = "battery platform",
		categories = {"objects", "mobs", "j2e"},
		rotations = E,
		order = 130,
		tiles = E,
		objects = {"platform|battery"},
		tooltip = "this platform runs on its own battery, and can be toggled by ducking while on top of it." 
	},
	["O^"] = {
		name = "border kludge",
		categories = {"objects"},
		rotations = E,
		order = 131,
		tiles = E,
		objects = {"borderkludge"},
		tooltip = "while touching this, ogmo cannot exit the border of the level, even if an exit is there. use facing tag to select direction" 
	},
	["O_"] = {
		name = "cannon (left)",
		categories = {"objects", "j1", "deadly"},
		rotations = {"O`", "O`"},
		order = 132,
		tiles = E,
		objects = {"cannon|dir:left"},
		tooltip = "fires cannonballs that you can jump on" 
	},
	["O`"] = {
		name = "cannon (right)",
		categories = {"objects", "j1", "deadly"},
		rotations = {"O_", "O_"},
		order = 133,
		tiles = E,
		objects = {"cannon|dir:right"},
		tooltip = "fires cannonballs that you can jump on" 
	},
	["tK"] = {
		name = "outline (top-left)",
		categories = {"tiles"},
		rotations = {"tR", "tL"},
		order = 134,
		tiles = {"outline_ul"},
		objects = E,
		tooltip = "an outline for pattern tiles. only solid from the outside" 
	},
	["tL"] = {
		name = "outline (top)",
		categories = {"tiles"},
		rotations = {"tK", "tM"},
		order = 135,
		tiles = {"outline_u"},
		objects = E,
		tooltip = "an outline for pattern tiles. only solid from the outside" 
	},
	["tM"] = {
		name = "outline (top-right)",
		categories = {"tiles"},
		rotations = {"tL", "tN"},
		order = 136,
		tiles = {"outline_ur"},
		objects = E,
		tooltip = "an outline for pattern tiles. only solid from the outside" 
	},
	["tN"] = {
		name = "outline (right)",
		categories = {"tiles"},
		rotations = {"tM", "tO"},
		order = 137,
		tiles = {"outline_r"},
		objects = E,
		tooltip = "an outline for pattern tiles. only solid from the outside" 
	},
	["tO"] = {
		name = "outline (bottom-right)",
		categories = {"tiles"},
		rotations = {"tN", "tP"},
		order = 138,
		tiles = {"outline_dr"},
		objects = E,
		tooltip = "an outline for pattern tiles. only solid from the outside" 
	},
	["tP"] = {
		name = "outline (bottom)",
		categories = {"tiles"},
		rotations = {"tO", "tQ"},
		order = 139,
		tiles = {"outline_d"},
		objects = E,
		tooltip = "an outline for pattern tiles. only solid from the outside" 
	},
	["tQ"] = {
		name = "outline (bottom-left)",
		categories = {"tiles"},
		rotations = {"tP", "tR"},
		order = 140,
		tiles = {"outline_dl"},
		objects = E,
		tooltip = "an outline for pattern tiles. only solid from the outside" 
	},
	["tR"] = {
		name = "outline (left)",
		categories = {"tiles"},
		rotations = {"tQ", "tK"},
		order = 141,
		tiles = {"outline_l"},
		objects = E,
		tooltip = "an outline for pattern tiles. only solid from the outside" 
	},
	["tS"] = {
		name = "green stripes",
		categories = {"tiles"},
		rotations = {"tW", "tT"},
		order = 142,
		tiles = {"pattern1"},
		objects = E,
		tooltip = "a nice pattern" 
	},
	["tT"] = {
		name = "brown stripes",
		categories = {"tiles"},
		rotations = {"tS", "tU"},
		order = 143,
		tiles = {"pattern2"},
		objects = E,
		tooltip = "a nice pattern" 
	},
	["tU"] = {
		name = "pink stripes",
		categories = {"tiles"},
		rotations = {"tT", "tV"},
		order = 144,
		tiles = {"pattern3"},
		objects = E,
		tooltip = "a nice pattern" 
	},
	["tV"] = {
		name = "white checker",
		categories = {"tiles"},
		rotations = {"tU", "tW"},
		order = 145,
		tiles = {"pattern4"},
		objects = E,
		tooltip = "a nice pattern" 
	},
	["Oa"] = {
		name = "kitty",
		categories = {"objects"},
		rotations = E,
		order = 146,
		tiles = E,
		objects = {"kitty"},
		tooltip = "an npc that can speak multipage dialogue when interacted with" 
	},
	[" #"] = { --marker. no longer used
		name = "tag extender",
		categories = {"tiles"},
		rotations = E,
		order = 148,
		tiles = E,
		objects = E,
		tooltip = "equivalent to blank space, but can have any tag placed on it, to help with efficient tag storing",
		anytag = true --not used atm
	},
	["tW"] = {
		name = "blue zigzag",
		categories = {"tiles"},
		rotations = {"tV", "tS"},
		order = 147,
		tiles = {"pattern5"},
		objects = E,
		tooltip = "a blue pattern"
	},
	["Oc"] = {
		name = "fire cannon (left)",
		categories = {"objects", "j1", "deadly"},
		rotations = {"Od", "Od"},
		order = 149,
		tiles = E,
		objects = {"cannon|dir:left|kind:fire"},
		tooltip = "fires tiny fireballs that are deadly on touch" 
	},
	["Od"] = {
		name = "fire cannon (right)",
		categories = {"objects", "j1", "deadly"},
		rotations = {"Oc", "Oc"},
		order = 150,
		tiles = E,
		objects = {"cannon|dir:right|kind:fire"},
		tooltip = "fires tiny fireballs that are deadly on touch" 
	},
	["Oe"] = {
		name = "walky spike (cw)",
		categories = {"objects", "mobs", "deadly", "j2"},
		rotations = {"Of", "Of"},
		order = 151,
		tiles = E,
		objects = {"walkyspike|turndir:cw"},
		tooltip = "moving spike that creeps along a wall" 
	},
	["Of"] = {
		name = "walky spike (ccw)",
		categories = {"objects", "mobs", "deadly", "j2"},
		rotations = {"Oe", "Oe"},
		order = 152,
		tiles = E,
		objects = {"walkyspike|turndir:ccw"},
		tooltip = "moving spike that creeps along a wall" 
	},
	["Og"] = {
		name = "one-direction platform (left)",
		categories = {"objects", "mobs", "jr"},
		rotations = {"Oh", "Oh"},
		order = 153,
		tiles = E,
		objects = {"platform|onedir:yep|dir:left"},
		tooltip = "platform that moves in left when you step on it" 
	},
	["Oh"] = { --oh!
		name = "one-direction platform (right)",
		categories = {"objects", "mobs", "jr"},
		rotations = {"Og", "Og"},
		order = 154,
		tiles = E,
		objects = {"platform|onedir:yep|dir:right"},
		tooltip = "platform that moves right when you step on it" 
	},
	["Oi"] = {
		name = "art",
		categories = {"objects", "j4r"},
		rotations = E,
		order = 155,
		tiles = E,
		objects = {"art"},
		tooltip = "become solid after you overlap it. but is it art?" 
	},
	["tX"] = {
		name = "missing texture",
		categories = {"tiles"},
		rotations = E,
		order = 156,
		tiles = {"missingtexture"},
		objects = E,
		tooltip = "placeholder tooltip" 
	},
	["tY"] = {
		name = "object collider",
		categories = {"tiles"},
		rotations = E,
		order = 157,
		tiles = {"objectcollider"},
		objects = E,
		tooltip = "objects collide with this, but ogmo doesn't" 
	},
	["tZ"] = {
		name = "player collider",
		categories = {"tiles"},
		rotations = E,
		order = 158,
		tiles = {"playercollider"},
		objects = E,
		tooltip = "ogmo collides with this, but other objects don't" 
	},
	["Oj"] = {
		name = "ghost tile (up)",
		categories = {"objects", "j2e"},
		rotations = E,
		order = 159,
		tiles = E,
		objects = {"ghosttile|dir:up"},
		tooltip = "only solid to anything if you're above it" 
	},
	["Ok"] = {
		name = "ghost tile (down)",
		categories = {"objects", "j2e"},
		rotations = E,
		order = 160,
		tiles = E,
		objects = {"ghosttile|dir:down"},
		tooltip = "only solid to anything if you're below it" 
	},
	["Ol"] = {
		name = "ghost tile (left)",
		categories = {"objects", "j2e"},
		rotations = E,
		order = 161,
		tiles = E,
		objects = {"ghosttile|dir:left"},
		tooltip = "only solid to anything if you're to the left of it" 
	},
	["Om"] = {
		name = "ghost tile (right)",
		categories = {"objects", "j2e"},
		rotations = E,
		order = 162,
		tiles = E,
		objects = {"ghosttile|dir:right"},
		tooltip = "only solid to anything if you're to the right of it" 
	},
	["X "] = {
		name = "falling spike (down)",
		categories = {"objects", "j1e", "deadly"},
		rotations = {"X#", "X!"},
		order = 164,
		tiles = E,
		objects = {"fallyspike|dir:down"},
		tooltip = "a spike that falls when you're underneath it" 
	},
	["X!"] = {
		name = "falling spike (right)",
		categories = {"objects", "deadly"},
		rotations = {"X ", "X\""},
		order = 165,
		tiles = E,
		objects = {"fallyspike|dir:right"},
		tooltip = "a spike that falls... to the right, when you're to the right of it" 
	},
	["X\""] = {
		name = "falling spike (up)",
		categories = {"objects", "deadly"},
		rotations = {"X!", "X#"},
		order = 166,
		tiles = E,
		objects = {"fallyspike|dir:up"},
		tooltip = "a spike that falls... upward, when you're above it" 
	},
	["X#"] = {
		name = "falling spike (left)",
		categories = {"objects", "deadly"},
		rotations = {"X\"", "X "},
		order = 167,
		tiles = E,
		objects = {"fallyspike|dir:left"},
		tooltip = "a spike that falls... to the left, when you're to the left of it" 
	},
	["X$"] = {
		name = "falling spikeball",
		categories = {"objects", "deadly", "j4r", "mobs"},
		rotations = E,
		order = 168,
		tiles = E,
		objects = {"fallyspike|dir:mine"},
		tooltip = "a spikeball that \"falls\" in your direction when you're aligned with it. does not break on impact" 
	},
	["X%"] = {
		name = "sentry",
		categories = {"objects", "deadly", "j2e"},
		rotations = E,
		order = 163,
		tiles = E,
		objects = {"sentry"},
		tooltip = "shoots at ogmo, unless he's too close" 
	},
	["On"] = {
		name = "ice (up)",
		categories = {"objects", "j2"},
		rotations = {"Oy", "Ow"},
		order = 175,
		tiles = E,
		objects = {"ice"},
		tooltip = "ice itself isn't solid, but if ogmo is standing above or in it, he'll slip around"
	},
	["Oo"] = {
		name = "checkpoint",
		categories = {"objects", "j2"},
		rotations = {"O+", "O+"},
		order = 54.5,
		tiles = E,
		objects = {"checkpoint"},
		tooltip = "after this is touched, dying respawns you at a different spawn number. specify which with a tag" 
	},
	["Op"] = {
		name = "Red Teleporter",
		categories = {"objects", "j2e"},
		rotations = {"Or", "Oq"},
		order = 169,
		tiles = E,
		objects = {"tele|kind:red"},
		tooltip = "Sends you to the nearest Red Target."
	},
	["Oq"] = {
		name = "Green Teleporter",
		categories = {"objects", "j2e"},
		rotations = {"Op", "Or"},
		order = 170,
		tiles = E,
		objects = {"tele|kind:green"},
		tooltip = "Sends you to the nearest Green Target."
	},
	["Or"] = {
		name = "Blue Teleporter",
		categories = {"objects", "j2e"},
		rotations = {"Oq", "Op"},
		order = 171,
		tiles = E,
		objects = {"tele|kind:blue"},
		tooltip = "Sends you to the nearest Blue Target."
	},
	["Os"] = {
		name = "Red Target",
		categories = {"objects", "j2e"},
		rotations = {"Ou", "Ot"},
		order = 172,
		tiles = E,
		objects = {"tele_target|kind:red"},
		tooltip = "The destination of the Red Teleporter nearest to it."
	},
	["Ot"] = {
		name = "Green Target",
		categories = {"objects", "j2e"},
		rotations = {"Os", "Ou"},
		order = 173,
		tiles = E,
		objects = {"tele_target|kind:green"},
		tooltip = "The destination of the Green Teleporter nearest to it."
	},
	["Ou"] = {
		name = "Blue Target",
		categories = {"objects", "j2e"},
		rotations = {"Ot", "Os"},
		order = 174,
		tiles = E,
		objects = {"tele_target|kind:blue"},
		tooltip = "The destination of the Blue Teleporter nearest to it."
	},
	["Ov"] = {
		name = "ice star",
		categories = {"objects", "j3 demo"},
		rotations = {"OR", "OP"},
		order = 110.5,
		tiles = E,
		objects = {"star|kind:ice"},
		tooltip = "makes you slippery and unable to walljump until you get a gold star" 
		--"ice star" was never actually a thing; the equivalent item in the j3 demo is the "ice vial", which changes your character to "ice ogmo" with the same effects
	},
	["Ow"] = { --autsch!
		name = "ice (left)",
		categories = {"objects", "j2"},
		rotations = {"On", "Ox"},
		order = 176,
		tiles = E,
		objects = {"ice|dir:left"},
		tooltip = "if this is on a left-facing wall, you can't walljump from it"
	},
	["Ox"] = {
		name = "ice (right)",
		categories = {"objects", "j2"},
		rotations = {"Ow", "Oy"},
		order = 177,
		tiles = E,
		objects = {"ice|dir:right"},
		tooltip = "if this is on a right-facing wall, you can't walljump from it"
	},
	["Oy"] = {
		name = "ice (down)",
		categories = {"objects", "j4r"},
		rotations = {"Ox", "On"},
		order = 178,
		tiles = E,
		objects = {"ice|dir:down"},
		tooltip = "purely decorative... unless you have antigravity"
	},
	["O{"] = {
		name = "blue gem",
		categories = {"objects", "j2"},
		rotations = {"O|", "O|"},
		order = 179,
		tiles = E,
		objects = {"gem|kind:blue"},
		tooltip = "a permanent collectible, conventionally easier to get than the red gem."
	},
	["O|"] = {
		name = "red gem",
		categories = {"objects", "j2"},
		rotations = {"O{", "O{"},
		order = 180,
		tiles = E,
		objects = {"gem|kind:red"},
		tooltip = "a permanent collectible, conventionally harder to get than the blue gem."
	},
	["O}"] = {
		name = "reserved: jumbotron (.)",
		categories = {"objects", "j2e"},
		order = 181,
		tiles = E,
		objects = {"jumbotron|display:seconds"},
		tooltip = "shouldn't be seeable",
		nevershow = true
	},
	["O~"] = {
		name = "reserved: jumbotron (:)",
		categories = {"objects", "j2e"},
		order = 181,
		tiles = E,
		objects = {"jumbotron|display:minutes"},
		tooltip = "shouldn't be seeable",
		nevershow = true
	},
	["P "] = {
		name = "reserved: timer switch",
		order = 182,
		tooltip = "shouldn't be seeable",
		nevershow = true
	},
	["P!"] = {
		name = "reserved: particle emitter",
		order = 183,
		tooltip = "shouldn't be seeable",
		nevershow = true
	},
	["@ "] = {
		name = "fireman",
		--categories = {"objects"},
		order = 184,
		tiles = E,
		objects = {"fireman"},
		tooltip = "fireman",
		nevershow = true
	},
	["P\""] = {
		name = "lightbridge (right)",
		categories = {"objects", "j4r"},
		order = 185,
		tooltip = "spawns temporary moving platforms when ducked on. use Variant tag to determine how many it can have at once",
		tiles = E,
		objects = {"lightbridge|dir:right"},
	},
	["P#"] = {
		name = "lightbridge (left)",
		categories = {"objects", "j4r"},
		order = 185,
		tooltip = "spawns temporary moving platforms when ducked on. use Variant tag to determine how many it can have at once",
		tiles = E,
		objects = {"lightbridge|dir:left"},
	},
}

for i=1, 9 do
	levelsymbols["j" .. tostring(i)] = {
		name = "strangeslab " .. tostring(i),
		categories = {"tiles"},
		rotations = E,
		order = 156 + i,
		nevershow = true,
		tiles = {"strangeslab" .. tostring(i)},
		objects = E,
		tooltip = "a strange slab"
	}
end

for i,v in ipairs(consts.ascii_table) do
	levelsymbols["\\" .. v] = {
		name = "ascii " .. v,
		categories = {"ascii"},
		rotations = {"\\" .. (consts.ascii_table[i - 1] or "~"), "\\" .. (consts.ascii_table[i + 1] or " ")},
		order = 499 + i,
		tiles = {"ascii_" .. v},
		objects = E,
		tooltip = "the ascii character " .. v 
	}
end

levelsymbols["\\!"].rotations[1] = "\\~"
levelsymbols["\\~"].rotations[2] = "\\!"
local space = levelsymbols["\\ "]
space.name = "ascii whitespace"
space.tooltip = "the ascii character corresponding to whitespace"
space.nevershow = true

for k,v in pairs(levelsymbols) do
	if v.categories then
		v.categories_set = {}
		for i,v2 in ipairs(v.categories) do
			v.categories_set[v2] = true
		end
	end
	--[[
	if v.rotations then
		for i,v2 in ipairs(v.rotations) do
			if type(v2) == "number" then
				v.rotations[i] = 
			end
		end
	end
	]]
end

specialsymbols = {
	tagextender = " #", --no longer used
	bluegem = "O{",
	redgem = "O|",
}
for k,v in pairs(specialsymbols) do
	levelsymbols[v].special = k
end

--[[
levelsymbols_sortedkeys_byraw = {} --by raw key text. i don't think you'd ever need this but it does sort by (kind of arbitrary, probably subject to change) categories and show when things were added in each category (except when things get deleted). see legend.txt for more info about the innate categories each key uses
]]
levelsymbols_sortedkeys_byorder = {} --by corresponding values' "order" fields
for k, _ in pairs(levelsymbols) do
	--table.insert(levelsymbols_sortedkeys_byraw, k)
	table.insert(levelsymbols_sortedkeys_byorder, k)
end
--[[
table.sort(levelsymbols_sortedkeys_byraw, function(a,b)
	return a < b
end)
]]

table.sort(levelsymbols_sortedkeys_byorder, function(a,b)
	if levelsymbols[a].order == levelsymbols[b].order and a ~= b --[[a ~= b is because occasionally sort tries something against itself for some reason]] then
		--print("hm, symbols '" .. a .. "' and '" .. b .. "' share an order")
		return a < b
	end
	return levelsymbols[a].order < levelsymbols[b].order
end)
--what's great here is if e.g. the sequence goes "A, B, D, E, F, G, C, H" with each term's order being equal to its placement and i want C to display before D, i can just change C's order to 2.5 with no further effort required and nothing will break. order doesn't represent the literal placement in a table, just how the symbols should be sorted