menu_substates = {
	["title"] = {
		options = {
			[1] = {
				name = "play",
				--tooltip = "Play the game! (Levelset selection support soon!)",
				tooltip = "Select a levelset to play.",
				action = function()
					menu.changeSubstate("levelsets")
					--statemachine.setstate("game")
				end
			},
			[2] = {
				name = "ogmos",
				tooltip = "personalize thyself.",
				action = function()
					menu.changeSubstate("ogmos")
				end
			},
			[3] = {
				name = "settings",
				tooltip = "A variety of settings.",
				action = function()
					menu.changeSubstate("settings")
				end
			},
			[4] = {
				name = "editor",
				tooltip = "choose a levelset to edit",
				--tooltip = "make your own levels. some things like exits, music, and background color have to be set in the file.",
				--tooltip = "Think you have what it takes to outclass the official levels? You probably do!",
				--tooltip = "Make your own levels, just like the official levels.",
				--tooltip = "Work in progress, whoo!",
				--tooltip = "TODO! It will be awesome. Or at least usable. Awesomely usable?",
				action = function()
					menu.changeSubstate("edit")
					--statemachine.setstate("editor")
				end
			},
			[5] = {
				name = "quit",
				tooltip = "Quit ze game.",
				action = function()
					love.event.quit()
				end
			},
		},
		onLoad = function()
			if #cheat.unlockedcheats > 0 then
				table.insert(menu.options, 4, {
					name = "cheats",
					tooltip = "cheat the game (but not yourself)",
					action = function()
						menu.changeSubstate("cheats")
					end
				})
			end
		end,
		--onUpdate = donothing,
		cancheat = true,
		onCheat = function(firstunlock)
			if firstunlock then
				table.insert(menu.options, 4, {
					name = "cheats",
					tooltip = "cheat the game (but not yourself)",
					action = function()
						menu.changeSubstate("cheats")
					end
				})
				if menu.picker >= 4 then menu.movePicker("down") end
			end
		end,
		noback = true,
		showlogo = true
	},
	["paused"] = {
		options = {
			[1] = {
				name = "resume",
				tooltip = "resume the game",
				action = function()
					statemachine.clearoverlaystate()
					game.unpause()
				end
			},
			[2] = {
				name = "ogmos",
				tooltip = "personalize thyself.",
				action = function()
					menu.changeSubstate("ogmos")
				end
			},
			[3] = {
				name = "settings",
				tooltip = "A variety of settings.",
				action = function()
					menu.changeSubstate("settings")
				end
			},
			[4] = {
				getname = function()
					if not game.editormode then return "quit" end
					return "editor"
				end,
				gettooltip = function()
					if game.editormode then return "back to the editor"
					else return "quit to the main menu" end
				end,
				action = function()
					if game.editormode then
						editor.scrollVert_HoldMoveDelayCurrent = 20
						editor.scrollHori_HoldMoveDelayCurrent = 20
						statemachine.setstate("editor")
						menu.picker = 1
					else
						resizeWindow(baseWidth, baseHeight)
						statemachine.setstate("menu")
						if game.saveslot >= 1 and game.saveslot <= 3 then --just in case. i guess.
							menu.picker = game.saveslot
						else
							print("weird saveslot number... " .. tostring(game.saveslot))
						end
					end
				end,
			},
		},
		noback = true,
		showlogo = false,
		onKeyPressed = function(key)
			if key == "f" then
				menu.fact = facts[love.math.random(1, #facts)]
				menu.facttext:setf("FACT: " .. menu.fact, game.width / 2, "center")
			end
			--elseif key == "g" then
			--	menu.fact = facts[#facts]
			--	menu.facttext:setf("FACT: " .. menu.fact, game.width / 2, "center")
			--end
		end,
		--[[onLoad = function()
			if game.editormode then
				for i,v in ipairs(menu.options) do
					if v.name == "quit" then
						menu.options[i] = {
						v.name = "editor"
						v.tooltip = "back to the editor"
						v.action = function()
							editor.returningfromgame = true
							editor.scrollVert_HoldMoveDelayCurrent = 20
							editor.scrollHori_HoldMoveDelayCurrent = 20
							statemachine.setstate("editor")
							menu.picker = 1
						end
						break
					end
				end
			end
		end]]
	},
	["settings"] = {
		options = {
		--[[
			[1] = {
				name = "audio: ",
				vartoggle = "playaudio",
				tooltip = "Play audio?",
				action = function()
					if settings["playaudio"] then
						love.audio.setVolume(1)
					else
						love.audio.setVolume(0)
					end
				end
			},
		--]]
			[1] = {
				name = "sfx: ",
				vartoggle = "playsfx",
				tooltip = "Play sound effects?",
				action = function()
					if settings["playsfx"] then --this might look nonsensical but note that if vartoggle is defined, then the corresponding variable gets toggled in settings, *then* if action is defined it runs action
						audio.changesfxvolume(1)
					else
						audio.changesfxvolume(0)
					end
				end
			},
			[2] = {
				name = "music: ",
				vartoggle = "playmusic",
				tooltip = "Play the sweet music?",
				action = function()
					if settings["playmusic"] then
						audio.changemusicvolume(1)
					else
						audio.changemusicvolume(0)
					end
				end
			},
			[3] = {
				name = "rebind controls",
				tooltip = "change the ingame controls",
				action = function()
					menu.changeSubstate("controls")
				end,
			},
			[4] = {
				getname = function(self)
					return "name: " .. settings.username
				end,
				tooltip = "what's your name",
				input = true,
				action = function() menu.typedtext = settings.username; end,
				onSubmit = function(text)
					settings.username = text
				end,
				typingprefix = "name: "
			},
			[5] = {
				name = "choice: ",
				vartoggle = "choice",
				tooltip = "Subscribe to the illusion of choice?",
				--action = donothing
			},
			[6] = {
				name = "see the unseeable: ",
				vartoggle = "seetheunseeable",
				tooltip = "See invisible tiles (e.g. wintiles)?",
				--action = donothing
			},
			[7] = {
				name = "quick deaths: ",
				vartoggle = "quickdeaths",
				tooltip = "restart level once all players are dead, and not once all dead players are off-screen?",
				--action = donothing
			},
			[8] = {
				name = "pause when unfocused: ",
				vartoggle = "unfocuspause",
				tooltip = "if in-game, pause the game when the window's focus is lost?",
				--action = donothing
			},
			[9] = {
				name = "mute when unfocused: ",
				vartoggle = "unfocusmute",
				tooltip = "mute all audio while the window does not have focus?",
				--action = donothing
			},
			[10] = {
				name = "frameskip: ",
				vartoggle = "lagmakeup",
				tooltip = "make up for lag by processing extra frames simultaneously?",
				--action = donothing
			},
			[11] = {
				name = "lazy 60hz mode: ",
				vartoggle = "lazy60hz",
				tooltip = "if SDL2 reports your refresh rate as 60hz, skip all deltatime logic and just update once per frame?",
				action = function()
					idkrunsfineforme = settings.lazy60hz
				end
			},
			[12] = {
				name = "no screen wipes/fades: ",
				vartoggle = "notransit",
				tooltip = "never display screen wipes or screen fades?"
			},
			[13] = {
				getname = function(self)
					local name = "force-update help file"
					if menu.temp["helpfileupdated"] then name = name .. " (DONE)"
					elseif menu.temp["helpfilefailed"] then name = name .. " (FAILED)"
					end
					return name
				end,
				name = "force-update help file",
				tooltip = "force the external .chm to be updated with the internal .chm; should happen automatically when version is changed",
				action = function() --note that user-added menu substates - if those become a thing - should NOT have love.filesystem access; there should be some "update chm file" function instead
					print("updating help file");
					local success, message = love.filesystem.write("Jumper 4 Real.chm", love.filesystem.read("Jumper 4 Real.chm"))  --t.appendidentity
					if success then
						print("deleting old help index");
						love.filesystem.remove("Jumper 4 Real.chw")
						menu.temp["helpfileupdated"] = true
					else
						print("update failed: " .. tostring(message))
						menu.temp["helpfilefailed"] = true
					end
				end
			},
			--[[
			[5] = {
				name = "back",
				tooltip = "Exit to the title screen.",
				action = function()
					menu.changeSubstate("title")
					menu.picker = 2
				end
			}
			]]
		},
		--backtooltip = "Exit to the title screen.",
		onLoad = function()
			if not idkrunsfineforme_default then
				for i,v in ipairs(menu.options) do
					if v.vartoggle == "lazy60hz" then
						v.alpha = 0.5
						v.vartoggle = nil
						v.action = nil
						v.name = v.name .. "N/A"
					end
				end
			end
		end,
		--onUpdate = donothing,
	},
	["controls"] = {
		options = {},
		initialize = function(self)
			local options = self.options
			
			local binds = {
				{"left",		"P1LEFT"},
				{"right",		"P1RIGHT"},
				{"up",			"P1UP"},
				{"down",		"P1DOWN"},
				{"jump",		"P1JUMP"},
				{"interact",	"P1INTERACT"},
				{"restart",		"P1DIE"},
			}
			for i,v in ipairs(binds) do
				options[i] = {
					getname = function()
						return v[1] .. ": " .. controls[v[2]]:upper()
					end,
					input = true,
					action = function()
						menu.temp["bind"] = v[2]
					end,
					typingprefix = v[1] .. ": ",
					tooltip = "rebind the " .. v[1] .. " key"
				}
			end
			table.insert(options, {
				name = "reset controls",
				tooltip = "reset all controls to their defaults",
				action = function()
					controls = table.copy(defaultcontrols)
					menu.changed.controls = true
				end
			})
		end,
		onKeyPressed = function(key)
			if menu.typing then
				menu.typing = false
				menu.typedtext = ""
				menu.options[menu.picker].beingtyped = false
				menu.pickerHoldMoveDelayCurrent = 1000 --in case user pressed down or up. this is a dumb, stupid kludge.
				if key == "escape" then return true end --can't bind to escape
				controls[menu.temp["bind"]] = key
				menu.changed.controls = true
				return true
			end
		end,
		onUpdate = function()
			if menu.typing then
				love.keyboard.setKeyRepeat(false)
			end
		end,
		onBack = function()
			game.interactprompt:set(controls["P1INTERACT"])
		end,
		linedistance = 30,
		itemsperpage = 8,
	},
	["levelsets"] = {
		options = {},
		onLoad = function()
			--menu.options = {} --we have to explicitly do this or else some weird bug can pop up with table.sort somehow accessing the "back" button on subsequent visits of this menu and making it the second option... before the back button is actually loaded. pretty weird
			--i'm pretty sure whatever the situation described in the above line was was a consequence of not really getting how tables work (e.g. local a = {}; local b = a; b[1] = "blah"; print(a[1]); --> blah)
			for i,v in ipairs(game.levelsets) do
				local levelset = v
				if not levelset.invalid then
					menu.options[i] = {
						name = levelset.info.name,
						sidename = levelset.info.author or "(?)",
						tooltip = levelset.info.description,
						action = function()
							game.currentlevelset = levelset
							menu.changeSubstate("saves")
						end
						--action = function()
						--	game.loadLevelset(levelset)
						--	statemachine.setstate("game")
						--end
					}
				else
					menu.options[i] = {
						name = levelset.info.name,
						tooltip = "Hm. Either this it a standalone level (not yet supported), or a levelset with bad levelset info.",
						alpha = 0.5,
						action = donothing
					}
				end
			end
			table.sort(menu.options, function(a,b) return a.name < b.name end)
			--[[
			menu.options[i] = {
				name = "back",
				tooltip = "Exit to the title screen.",
				action = function()
					menu.changeSubstate("title")
					menu.picker = 1
				end
			}
			]]
		end,
		--backtooltip = "Exit to the title screen.",
		--onUpdate = donothing,
		linedistance = consts["levelsets_linedistance"],
		itemsperpage = consts["levelsets_itemsperpage"],
	},
	["saves"] = {
		options = {
			--first 3 options are initialized in (guess) init
			[4] = {
				getname = function()
					if not menu.temp["deletesave"] then return "delete save"
					else return "select save" end
				end,
				gettooltip = function()
					if not menu.temp["deletesave"] then return "delete a save slot"
					else return "select a save slot" end
				end,
				action = function()
					if not menu.temp["emptyall"] then
						menu.temp["deletesave"] = not menu.temp["deletesave"]
					end
				end,
				customcolor = true,
				getcolor = function()
					if menu.temp["emptyall"] then return 1, 1, 1, 0.5 end
					if not menu.temp["deletesave"] then return 1, 0, 0 end
					return 1, 1, 1
				end,
			},
		},
		initialize = function(self)
			local options = self.options
			
			local selectslot, deleteslot
			selectslot = function(no)
				game.saveslot = no
				if not game.currentlevelset.gemcounts[no] then
					game.currentlevelset.gemcounts[no] = {blue = 0, red = 0}
				end
				game.loadLevelset(game.currentlevelset)
				
				statemachine.setstate("game")
				menu.temp["empty" .. no] = false
			end
			deleteslot = function(no)
				local savename = "saves/" .. game.currentlevelset.foldername .."/slot" .. no
				love.filesystem.remove(savename .. ".txt")
				love.filesystem.remove(savename .. ".j4g")
				audio.playsfx("tnt boom")
				menu.refresh()
			end
			
			local positions = {"first", "second", "third"}
			
			for i=1,3 do
				options[i] = {
					getname = function()
						local name = "slot " .. i
						if menu.temp["empty" .. i] then name = name ..  " (empty)" end
						return name
					end,
					action = function()
						if not menu.temp["deletesave"] then selectslot(i)
						elseif not menu.temp["empty" .. i] then deleteslot(i) end
					end,
					gettooltip = function()
						if not menu.temp["deletesave"] then return "select the " .. positions[i] .. " save slot"
						else return "delete the " .. positions[i] .. " save slot" end
					end,
					customcolor = true,
					getcolor = function()
						if not menu.temp["deletesave"] then return 1, 1, 1 end
						if menu.temp["empty" .. i] then return 1, 1, 1, 0.5 end
						return 1, 0, 0
					end,
				}
			end
		end,
		onLoad = function()
			local levelset = game.currentlevelset
			if not levelset.gemcounts then levelset.gemcounts = {} end
			local savepath = "saves/" .. levelset.foldername
			for i=1,3 do
				local savename = savepath .."/slot" .. i
				if not love.filesystem.getInfo(savename .. ".txt", "file") then
					menu.temp["empty" .. i] = true
				elseif not levelset.gemcounts[i] then
					local gems = {}
					levelset.gemcounts[i] = gems
					gems["blue"], gems["red"] = gemsave.readamts(savename .. ".j4g")
				end
			end
			if not levelset.gemcounts["union"] then
				local gems = {}
				levelset.gemcounts["union"] = gems
				gems["blue"], gems["red"] = gemsave.readamts(savepath .. "/union.j4g")
			end
			if menu.temp["empty1"] and menu.temp["empty2"] and menu.temp["empty3"] then menu.temp["emptyall"] = true end
		end,
		showlogooverride = false,
		onDraw = function()
			local levelset = game.currentlevelset
			menu.bigtext:setf((levelset and levelset.info.name) or "no levelset wtf", menu.width * 0.75, "left")
			love.graphics.draw(menu.bigtext, math.floor((menu.width - menu.bigtext:getWidth()) / 2), menu.facty)
			--love.graphics.print("all-time:", 290, 300) --later after seeing if bluestr or redstr are non-nil
			local optionx
			for i=1,3 do
				if levelset.gemcounts[i] and (not menu.temp["empty" .. tostring(i)]) and (levelset.gemcounts[i]["blue"] > 0 or levelset.gemcounts[i]["red"] > 0) then
					local bluegems = levelset.gemcounts[i]["blue"]
					local redgems = levelset.gemcounts[i]["red"]
					local x = optionx or (math.floor(love.graphics.getWidth() / 2) - menu.offsetleftfromcenter) + 38
					local y = menu.offsetfromtop + (math.floor(menu.linedistance * heightscale) * (i - 1))
					local r,g,b,a = love.graphics.getColor()
					if bluegems > 0 then
						local s = tostring(bluegems)
						love.graphics.draw(graphics.load("gems"), objects["gem"].quads["inside_blue"], x, y)
						love.graphics.setColor(0.25, 0.75, 1)
						love.graphics.print(s, x + 16, y)
						x = x + love.graphics.getFont():getWidth(s) + 16 + 2
					end
					if redgems > 0 then
						love.graphics.setColor(r,g,b,a)
						local s = tostring(redgems)
						love.graphics.draw(graphics.load("gems"), objects["gem"].quads["inside_red"], x, y)
						love.graphics.setColor(1, 0.625, 0.25)
						love.graphics.print(s, x + 16, y)
						x = x + love.graphics.getFont():getWidth(s) + 16 + 2
					end
					love.graphics.setColor(r,g,b,a)
				end
			end
			local bluestr
			if tonumber(levelset.info.totalbluegems) and tonumber(levelset.info.totalbluegems) > 0 then
				bluestr = tostring(levelset.gemcounts.union.blue) .. "/" .. levelset.info.totalbluegems
			elseif levelset.gemcounts.union.blue > 0 then
				bluestr = tostring(levelset.gemcounts.union.blue)
			end
			local redstr
			if tonumber(levelset.info.totalredgems) and tonumber(levelset.info.totalredgems) > 0 then
				redstr = tostring(levelset.gemcounts.union.red) .. "/" .. levelset.info.totalredgems
			elseif levelset.gemcounts.union.red > 0 then
				redstr = tostring(levelset.gemcounts.union.red)
			end
			local x = 290
			local y = 300 + 16
			local r,g,b,a = love.graphics.getColor()
			if bluestr then
				love.graphics.draw(graphics.load("gems"), objects["gem"].quads["inside_blue"], x, y)
				--love.graphics.setColor(0/255, 127/255, 255/255)
				love.graphics.setColor(0.25, 0.75, 1)
				love.graphics.print(bluestr, x + 16, y)
				y = y + 16
			end
			if redstr then
				love.graphics.setColor(r,g,b,a)
				love.graphics.draw(graphics.load("gems"), objects["gem"].quads["inside_red"], x, y)
				--love.graphics.setColor(255/255, 63/255, 0)
				love.graphics.setColor(1, 0.625, 0.25)
				love.graphics.print(redstr, x + 16, y)
				y = y + 16
			end
			love.graphics.setColor(r,g,b,a)if bluestr or redstr then
				love.graphics.print("all-time:", 290, 300)
			end
		end,
	},
	["edit"] = {
		options = {},
		onLoad = function()
			local auto_option
			for i,v in ipairs(game.ext_levelsets) do
				local levelset = v
				menu.options[i] = {
					name = levelset.info.name,
					sidename = levelset.info.author or "(?)",
					tooltip = levelset.info.description or "[no description]",
					action = function()
						--if you change anything here also change the onSubmit part below for creating a new levelset
						game.editormode = true --placing this before editor.fetchrooms() prevents stackem from taking effect
						editor.currentlevelset = levelset.foldername
						editor.levelset = levelset
						game.currentlevelset = levelset
						game.levelsetpath = levelset.filepath
						audio.fetchcustommusic(levelset.filepath .. "/music")
						editor.roomX = 0
						editor.roomY = 0
						editor.mapview_x = 0
						editor.mapview_y = 0
						editor.fetchrooms()
						editor.entrance = false
						game.setviewport(levelset.info.viewportwidth or levelset.info.screenwidth or game.width, levelset.info.viewportheight or levelset.info.screenheight or game.height)
						game.flipscreen = (levelset.info.flipscreen == "true")
						statemachine.setstate("editor")
					end
				}
				if menu.fromeditor and not auto_option and levelset == editor.levelset then
					auto_option = menu.options[i]
				end
			end
			table.sort(menu.options, function(a,b) return a.name < b.name end)
			if auto_option then
				for i,v in ipairs(menu.options) do
					if v == auto_option then
						local ipp = consts["levelsets_itemsperpage"]
						menu.picker = i % ipp
						menu.page = math.ceil(i / ipp)
						break
					end
				end
			end
			menu.options[#menu.options + 1] = {
				getname = function(self)
					if not menu.temp["newlevelsetfailed"] then return "+ new levelset"
					else return "levelset folder name taken!" end
				end,
				tooltip = "make a new levelset",
				customcolor = true,
				getcolor = function(self)
					if not menu.temp["newlevelsetfailed"] then return 0, 1, 0
					else return 1, 0, 0 end
				end,
				input = true,
				--action = donothing,
				onSubmit = function(text)
					local lvlset = editor.newlevelset(text)
					if lvlset then
						lvlset.info.author = settings.username
						--if you change anything here also change the part above for loading a levelset from edit
						game.editormode = true
						editor.levelset = lvlset
						editor.currentlevelset = text
						game.currentlevelset = lvlset
						game.levelsetpath = lvlset.filepath
						audio.fetchcustommusic()
						game.setviewport()
						game.flipscreen = false
						editor.currentlevel = "0,0"
						editor.roomX = 0
						editor.roomY = 0
						editor.mapview_x = 0
						editor.mapview_y = 0
						editor.entrance = false
						editor.extantrooms = {[0] = {[0] = true}}
						local fulllevelpath = "ext_levelsets/" .. editor.currentlevelset .. "/levels/" .. editor.currentlevel .. ".txt"
						editor.loadLevel(fulllevelpath)
						statemachine.setstate("editor")
					else
						print("levelset by that name already exists!")
						menu.temp["newlevelsetfailed"] = true
					end
				end,
				disallowedchars = set("\\", ":", "*", "?", "\"", "<", ">", "|", "/", ".")
			}
		end,
		--onUpdate = donothing,
		onDraw = function()
			if not editor.clipboard.empty then
				love.graphics.print("NOTICE:\n\nexiting to title\nscreen clears\nyour clipboard", menu.width - 160, 160)
			end
		end,
		onBack = function()
			print("(emptying clipboard)")
			local clipboard = editor.clipboard
			clipboard.object = false
			clipboard.empty = true
			clipboard.x = false
			clipboard.y = false
		end,
		linedistance = consts["levelsets_linedistance"],
		itemsperpage = consts["levelsets_itemsperpage"],
	},
	["cheats"] = {
		options = {},
		onLoad = function()
			menu.options = {}
			local cheatlist = cheat.unlockedcheats
			local i = 0
			for k,v in ipairs(cheatlist) do
				local thischeat = cheat.cheats[v]
				if thischeat then
					i = i + 1
					if thischeat.action and not thischeat.imatoggle then
						menu.options[i] = {
							name = thischeat.name,
							tooltip = thischeat.tooltip,
							action = function()
								thischeat.action(thischeat)
							end
						}
					else
						menu.options[i] = {
							name = thischeat.name,
							getname = function(self)
								if thischeat.active then return thischeat.name .. ": YES"
								else return thischeat.name .. ": NO" end
							end,
							tooltip = thischeat.tooltip,
							action = function()
								if thischeat.action then thischeat.action(thischeat) else cheat.toggle(thischeat) end
							end
						}
					end
				end
			end
			table.sort(menu.options, function(a,b) return string.lower(a.name) < string.lower(b.name) end)
			--[[
			menu.options[#menu.options + 1] = {
				name = "back",
				tooltip = "Exit to the title screen.",
				action = function()
					menu.changeSubstate("title")
					menu.picker = 3
				end
			}
			]]
		end,
		--backtooltip = "Exit to the title screen.",
		--onCheat = function() menu.onLoad() menu.appendBackOption(nil, backtooltip) end,
		onCheat = function() menu.refresh() end,
		alwaysshowcheatamt = true,
		ischeatmenu = true,
		cancheat = true, --actually you can cheat anywhere that's not the pause menu unless cancheat is false
	},
	["ogmos"] = {
		options = {},
		onLoad = function()
			menu.options = {}
			local i = 0
			for k,ogmo in pairs(ogmos) do
				if ogmo and not ogmo.hidden then
					i = i + 1
					menu.options[i] = {
						getname = function(self)
							if game.ogmoskin == k then return ogmo.name .. " [CURRENT]"
							else return ogmo.name end
						end,
						tooltip = ogmo.description,
						order = ogmo.order,
						id = k,
						action = function()
							game.ogmoskin = k
							game.ogmosnapto = ogmo.snapto or 1
							game.ogmofakelag = ogmo.fakelag
							game.ogmohmombug = ogmo.hmombug
							_G["ogmo"].quads = ogmos[game.ogmoskin].quads
							menu.changed.ogmoskin = true
						end
					}
				end
			end
			table.sort(menu.options, function(a,b) return a.order < b.order end)
		end,
		onDraw = function()
			if menu.options[menu.picker].id then
				local skinimg = graphics.load("ogmos/" .. menu.options[menu.picker].id)
				local r, g, b, a = love.graphics.getColor()
				love.graphics.setColor(0.5, 0.5, 0.5, a)
				love.graphics.rectangle("fill",
					--42,
					(math.floor(menu.width / 2) - (menu.offsetleftfromcenter + 50)) - (skinimg:getWidth() + 16),
					math.floor((menu.height - (skinimg:getHeight() + 16)) / 2),
					skinimg:getWidth() + 16,
					skinimg:getHeight() + 16
				)
				love.graphics.setColor(r, g, b, a)
				love.graphics.draw(skinimg,
					--50,
					(math.floor(menu.width / 2) - (menu.offsetleftfromcenter + 50)) - (skinimg:getWidth() + 8),
					math.floor((menu.height - skinimg:getHeight()) / 2)
				)
			end
		end,
		--backtooltip = "Exit to the title screen.",
	},
	["rhubarbrolled"] = {
		options = {
			[1] = {
				name = "rhubarbrolled",
				tooltip = "rhubarbrolled you stupid moron",
				--action = donothing
			},
			--[[
			[2] = {
				name = "back",
				tooltip = "stop being rhubarbrolled. you're lucky to have this option",
				action = function()
					menu.changeSubstate("rhubarbsettings")
					menu.picker = 2
				end
			},
			]]
		},
		backtooltip = "stop being rhubarbrolled. you're lucky to have this option",
		onLoad = donothing,
		--onUpdate = donothing,
	},
	["rhubarb"] = {
		options = {
			[1] = {
				name = "play",
				tooltip = "Select a levelset to play.",
				action = function()
					menu.changeSubstate("levelsets")
				end
			},
			[2] = {
				name = "rhubarb",
				tooltip = "The fleshy, edible stalks of species and hybrids of Rheum in the family Polygonaceae.",
				action = function()
					menu.changeSubstate("rhubarbrolled")
				end
			},
			[3] = {
				name = "bauble",
				tooltip = "Baubles, or Christmas ornaments, are decoration items, usually to decorate Christmas trees.",
				action = function()
					menu.changeSubstate("bauble")
				end
			},
			[4] = {
				name = "back",
				tooltip = "why? are you scared of rhubarb?",
				action = function() menu.back() end
			},
			[5] = {
				name = "quit",
				tooltip = "Quit ze game.",
				action = function()
					love.event.quit()
				end
			},
			[6] = {
				name = "type here please",
				tooltip = "whee",
				customcolor = true,
				red = 0,
				green = 1,
				blue = 0,
				input = true,
				--action = donothing,
				onSubmit = function(text)
					print(text)
				end
			},
		},
		noback = true,
		--onLoad = donothing,
		--onUpdate = donothing,
	},
	["bauble"] = {
		options = {
			[1] = {
				name = "doink",
				tooltip = "yoink",
			},
			[2] = {
				name = "sploink",
				tooltip = "ploink",
				--action = donothing
			},
			[3] = {
				name = "third",
				tooltip = "yird, go to title",
				action = function() menu.changeSubstate("title") end
			},
			[4] = {
				name = "wait",
				tooltip = "bait",
				--action = donothing
			},
			[5] = {
				name = "great",
				tooltip = "mate",
				--action = donothing
			},
			[6] = {
				name = "hex",
				tooltip = "sex",
				--action = donothing
			},
			[7] = {
				name = "7 should do",
				tooltip = "7 should be the max # of items displayed before it gets separated into pages",
				--action = donothing
			},
			[8] = {
				name = "nex",
				tooltip = "gex",
				--action = donothing
			},
			[9] = {
				name = "slurp",
				tooltip = "interp",
				--action = donothing
			},
			[10] = {
				name = "car",
				tooltip = "rar",
				--action = donothing
			},
			[11] = {
				name = "blink",
				tooltip = "slink",
				--action = donothing
			},
			[12] = {
				name = "snare",
				tooltip = "flare. go to title",
				action = function() menu.changeSubstate("title") end
			},
			[13] = {
				name = "air",
				tooltip = "hair",
				--action = donothing
			},
			[14] = {
				name = "mad",
				tooltip = "glad",
				--action = donothing
			},
			[15] = {
				name = "fresh",
				tooltip = "mesh",
				--action = donothing
			},
			[16] = {
				name = "pair",
				tooltip = "dare",
				--action = donothing
			},
			[17] = {
				name = "slop",
				tooltip = "flop",
				--action = donothing
			},
			[18] = {
				name = "jort",
				tooltip = "fort, go to title again",
				action = function() menu.changeSubstate("title") end
			},
			[19] = {
				name = "shield",
				tooltip = "yield",
				--action = donothing
			},
		},
	},
}
