tiles = {
	--basictiles
	["wall"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {0, 0}}},
		["solid"] = true,
		["deathly"] = false
	},
	["backwall"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {0, 16}}},
		["solid"] = false,
		["deathly"] = false
	},
	["black"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {64, 0}}},
		["solid"] = true,
		["deathly"] = false
	},
	["slabS"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {16, 0}}},
		["solid"] = true,
		["deathly"] = false,
		["hitboxheight"] = tilesize / 2,
		["hitboxYoffset"] = tilesize / 2,
	},
	["slabE"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {16, 16}}},
		["solid"] = true,
		["deathly"] = false,
		["hitboxwidth"] = tilesize / 2,
		["hitboxXoffset"] = tilesize / 2,
	},
	["slabN"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {16, 0}, ["ingameoffset"] = {0, -8}}},
		["solid"] = true,
		["deathly"] = false,
		["hitboxheight"] = tilesize / 2,
		["hitboxYoffset"] = 0,
	},
	["slabW"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {16, 16}, ["ingameoffset"] = {-8, 0}}},
		["solid"] = true,
		["deathly"] = false,
		["hitboxwidth"] = tilesize / 2,
		["hitboxXoffset"] = 0,
	},
	["slopeNW"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {48, 16}}},
		["solid"] = true,
		["automask"] = true
	},
	["slopeNE"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {32, 16}}},
		["solid"] = true,
		["automask"] = true
	},
	["slopeSE"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {32, 0}}},
		["solid"] = true,
		["automask"] = true
	},
	["slopeSW"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {48, 0}}},
		["solid"] = true,
		["automask"] = true
	},
	
	--spikes
	["spike_ball"] = {
		["graphics"] = {{["referencename"] = "spikes", ["quad"] = {64, 0}}},
		["solid"] = false,
		["deathly"] = true
	},
	["spikesS"] = {
		["graphics"] = {{["referencename"] = "spikes", ["quad"] = {0, 0}}},
		["solid"] = false,
		["deathly"] = true,
		["automask"] = true
	},
	["spikesE"] = {
		["graphics"] = {{["referencename"] = "spikes", ["quad"] = {16, 0}}},
		["solid"] = false,
		["deathly"] = true,
		["automask"] = true
	},
	["spikesN"] = {
		["graphics"] = {{["referencename"] = "spikes", ["quad"] = {32, 0}}},
		["solid"] = false,
		["deathly"] = true,
		["automask"] = true
	},
	["spikesW"] = {
		["graphics"] = {{["referencename"] = "spikes", ["quad"] = {48, 0}}},
		["solid"] = false,
		["deathly"] = true,
		["automask"] = true
	},
	["shortspikesS"] = {
		["graphics"] = {{["referencename"] = "spikes", ["quad"] = {0, 16}}},
		["solid"] = false,
		["deathly"] = true,
		["automask"] = true
	},
	["shortspikesE"] = {
		["graphics"] = {{["referencename"] = "spikes", ["quad"] = {16, 16}}},
		["solid"] = false,
		["deathly"] = true,
		["automask"] = true
	},
	["shortspikesN"] = {
		["graphics"] = {{["referencename"] = "spikes", ["quad"] = {32, 16}}},
		["solid"] = false,
		["deathly"] = true,
		["makemask"] = function()
			local maskstring = [[
################
.######..######.
..####....####..
................
................
................
................
................
................
................
................
................
................
................
................
................]]
			return makemaskwithmultistring(maskstring, ".", "#")
		end
	},
	["shortspikesW"] = {
		["graphics"] = {{["referencename"] = "spikes", ["quad"] = {48, 16}}},
		["solid"] = false,
		["deathly"] = true,
		["automask"] = true
	},
	
	
	--outside
	["dirt"] = {
		["graphics"] = {{["referencename"] = "outsidetiles", ["quad"] = {0, 0}}},
		["solid"] = true,
		["deathly"] = false
	},
	["dirtbg"] = {
		["graphics"] = {{["referencename"] = "outsidetiles", ["quad"] = {0, 16}}},
		["solid"] = false,
		["deathly"] = false
	},
	["grass"] = {
		["graphics"] = {{["referencename"] = "outsidetiles", ["quad"] = {16, 0}}},
		["solid"] = true,
		["collsides"] = {["up"] = true},
		["duckthrough"] = true,
	},
	["snow"] = {
		["graphics"] = {{["referencename"] = "outsidetiles", ["quad"] = {32, 0}}},
		["solid"] = false,
		["deathly"] = false,
		["soft"] = true
	},
	["cloud"] = {
		["graphics"] = {{["referencename"] = "outsidetiles", ["quad"] = {16, 16}}},
		["solid"] = false,
		["deathly"] = false
	},
	
	
	["invisible"] = {
		["solid"] = true,
		["deathly"] = false,
		["invisible"] = true
	},
	["fakeblack"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {64, 0}}},
		["solid"] = true,
		["deathly"] = false
	},
	["fakewall"] = {
		["graphics"] = {{["referencename"] = "basictiles", ["quad"] = {0, 0}}},
		["solid"] = true,
		["deathly"] = false
	},
	["rubber"] = {
		["solid"] = true,
		["deathly"] = false,
		["bounce"] = true
	},
	["levelborder"] = { --this tile was created as a kludge for collision and normally is never drawn, but if you do create a levelsymbol for it and place it for whatever reason, it just acts like a normal tile but indestructible (by tnt) not walljumpable. also, the level border will always be solid, but notwalljumpable being true here is why you can't walljump from it, and indestructible is why tnt doesn't bother with trying to treat it as a real tile and destroy it. kludges, woo!
		["graphics"] = {{["referencename"] = "win", ["quad"] = {32, 0}}},
		["solid"] = true,
		["deathly"] = false,
		["notwalljumpable"] = true,
		["indestructible"] = true,
	},
	["dev_wall"] = {
		["graphics"] = {
			{
				["referencename"] = "devtiles",
				["quad"] = {16, 0}
			}
		},
		["solid"] = true
	},
	["dev_backwall"] = {
		["graphics"] = {
			{
				["referencename"] = "devtiles",
				["quad"] = {0, 0}
			}
		},
		["solid"] = false
	},
	["dev_death"] = {
		["graphics"] = {
			{
				["referencename"] = "devtiles",
				["quad"] = {32, 0}
			}
		},
		["solid"] = false,
		["deathly"] = true,
	},
	["dark"] = {
		["graphics"] = {{["referencename"] = "lighting", ["quad"] = {0, 0}}},
		["solid"] = false,
		["deathly"] = false
	},
	["light"] = {
		["graphics"] = {{["referencename"] = "lighting", ["quad"] = {0, 16}}},
		["solid"] = false,
		["deathly"] = false
	},
	["redblock_on"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {0,32}}},
		["solid"] = true,
		["color"] = "red",
		["alt"] = "redblock_off" --graphics while this color is disabled will be the graphics from this tile. every color tile is expected to have an inverse variant. which tbh is a bit stupid since they're expected to have the same solidity and deathliness and color and everything
	},
	["redblock_off"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {32,32}}},
		["solid"] = true,
		["color"] = "red",
		color_inverse = true,
		["alt"] = "redblock_on"
	},
	["blueblock_on"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {0,48}}},
		["solid"] = true,
		["color"] = "blue",
		["alt"] = "blueblock_off"
	},
	["blueblock_off"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {32,48}}},
		["solid"] = true,
		["color"] = "blue",
		color_inverse = true,
		["alt"] = "blueblock_on"
	},
	["redspike_on"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {16,32}}},
		["deathly"] = true,
		["color"] = "red",
		["alt"] = "redspike_off"
	},
	["redspike_off"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {48,32}}},
		["deathly"] = true,
		["color"] = "red",
		color_inverse = true,
		["alt"] = "redspike_on"
	},
	["bluespike_on"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {16,48}}},
		["deathly"] = true,
		["color"] = "blue",
		["alt"] = "bluespike_off"
	},
	["bluespike_off"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {48,48}}},
		["deathly"] = true,
		["color"] = "blue",
		color_inverse = true,
		["alt"] = "bluespike_on"
	},
	["crackblock"] = {
		["graphics"] = {{["referencename"] = "crackblock"}},
		["solid"] = true,
		["walljump_fragile"] = true,
	},
	["reverser"] = {
		["graphics"] = {{["referencename"] = "reverser"}},
		["solid"] = false,
		["reverser"] = true,
		["hitboxwidth"] = 6,
		["hitboxheight"] = 6,
		["hitboxXoffset"] = 5,
		["hitboxYoffset"] = 5,
	},
	["cyanblock_on"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {64 + 0,32}}},
		["solid"] = true,
		["color"] = "cyan",
		["alt"] = "cyanblock_off" --graphics while this color is disabled will be the graphics from this tile. every color tile is expected to have an inverse variant. which tbh is a bit stupid since they're expected to have the same solidity and deathliness and color and everything
	},
	["cyanblock_off"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {64 + 32,32}}},
		["solid"] = true,
		["color"] = "cyan",
		color_inverse = true,
		["alt"] = "cyanblock_on"
	},
	["yellowblock_on"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {64 + 0,48}}},
		["solid"] = true,
		["color"] = "yellow",
		["alt"] = "yellowblock_off"
	},
	["yellowblock_off"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {64 + 32,48}}},
		["solid"] = true,
		["color"] = "yellow",
		color_inverse = true,
		["alt"] = "yellowblock_on"
	},
	["cyanspike_on"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {64 + 16,32}}},
		["deathly"] = true,
		["color"] = "cyan",
		["alt"] = "cyanspike_off"
	},
	["cyanspike_off"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {64 + 48,32}}},
		["deathly"] = true,
		["color"] = "cyan",
		color_inverse = true,
		["alt"] = "cyanspike_on"
	},
	["yellowspike_on"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {64 + 16,48}}},
		["deathly"] = true,
		["color"] = "yellow",
		["alt"] = "yellowspike_off"
	},
	["yellowspike_off"] = {
		["graphics"] = {{["referencename"] = "switchstuff", ["quad"] = {64 + 48,48}}},
		["deathly"] = true,
		["color"] = "yellow",
		color_inverse = true,
		["alt"] = "yellowspike_on"
	},
	["electricity_h"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {0, 0}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {0, 16}}},
		["deathly"] = true,
		["dontkillfollowers"] = true,
		["hitboxheight"] = 8,
		["hitboxYoffset"] = 4,
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "felectricity_h"
	},
	["electricity_v"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {16, 0}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {16, 16}}},
		["deathly"] = true,
		["dontkillfollowers"] = true,
		["hitboxwidth"] = 8,
		["hitboxXoffset"] = 4,
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "felectricity_v"
	},
	--here goes
	["electricity_c"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {32, 0}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {32, 16}}},
		["deathly"] = true,
		["dontkillfollowers"] = true,
		["makemask"] = function()
			local maskstring = [[
....########....
....########....
....########....
....########....
################
################
################
################
################
################
################
################
....########....
....########....
....########....
....########....]]
			return makemaskwithmultistring(maskstring, ".", "#")
		end,
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "felectricity_c"
	},
	["electricity_d"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {0, 32}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {0, 48}}},
		["deathly"] = true,
		["dontkillfollowers"] = true,
		["makemask"] = function()
			local maskstring = [[
................
................
................
................
################
################
################
################
################
################
################
################
....########....
....########....
....########....
....########....]]
			return makemaskwithmultistring(maskstring, ".", "#")
		end,
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "felectricity_d"
	},
	["electricity_r"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {16, 32}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {16, 48}}},
		["deathly"] = true,
		["dontkillfollowers"] = true,
		["makemask"] = function()
			local maskstring = [[
....########....
....########....
....########....
....########....
....############
....############
....############
....############
....############
....############
....############
....############
....########....
....########....
....########....
....########....]]
			return makemaskwithmultistring(maskstring, ".", "#")
		end,
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "felectricity_r"
	},
	["electricity_u"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {32, 32}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {32, 48}}},
		["deathly"] = true,
		["dontkillfollowers"] = true,
		["makemask"] = function()
			local maskstring = [[
....########....
....########....
....########....
....########....
################
################
################
################
################
################
################
################
................
................
................
................]]
			return makemaskwithmultistring(maskstring, ".", "#")
		end,
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "felectricity_u"
	},
	["electricity_l"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {48, 32}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {48, 48}}},
		["deathly"] = true,
		["dontkillfollowers"] = true,
		["makemask"] = function()
			local maskstring = [[
....########....
....########....
....########....
....########....
############....
############....
############....
############....
############....
############....
############....
############....
....########....
....########....
....########....
....########....]]
			return makemaskwithmultistring(maskstring, ".", "#")
		end,
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "felectricity_l"
	},
	--ok now onto fake electricity
	["felectricity_h"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {0, 0 + 64}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {0, 16 + 64}}},
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "electricity_h"
	},
	["felectricity_v"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {16, 0 + 64}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {16, 16 + 64}}},
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "electricity_v"
	},
	["felectricity_c"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {32, 0 + 64}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {32, 16 + 64}}},
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "electricity_c"
	},
	["felectricity_d"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {0, 32 + 64}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {0, 48 + 64}}},
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "electricity_d"
	},
	["felectricity_r"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {16, 32 + 64}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {16, 48 + 64}}},
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "electricity_r"
	},
	["felectricity_u"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {32, 32 + 64}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {32, 48 + 64}}},
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "electricity_u"
	},
	["felectricity_l"] = {
		["anim"] = true,
		["graphics"] = {{["referencename"] = "electricity", ["quad"] = {48, 32 + 64}}},
		["graphics_anim"] = {{["referencename"] = "electricity", ["quad"] = {48, 48 + 64}}},
		["color"] = "electricity",
		["alt"] = consts.nographics,
		["voltageinv"] = "electricity_l"
	},
	--outlines
	["outline_ul"] = {
		["collsides"] = {["up"] = true, ["left"] = true},
		["solid"] = true,
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {0, 0}}},
	},
	["outline_u"] = {
		["collsides"] = {["up"] = true},
		["solid"] = true,
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {16, 0}}},
	},
	["outline_ur"] = {
		["collsides"] = {["up"] = true, ["right"] = true},
		["solid"] = true,
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {32, 0}}},
	},
	["outline_r"] = {
		["collsides"] = {["right"] = true},
		["solid"] = true,
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {32, 16}}},
	},
	["outline_dr"] = {
		["collsides"] = {["down"] = true, ["right"] = true},
		["solid"] = true,
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {32, 32}}},
	},
	["outline_d"] = {
		["collsides"] = {["down"] = true},
		["solid"] = true,
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {16, 32}}},
	},
	["outline_dl"] = {
		["collsides"] = {["down"] = true, ["left"] = true},
		["solid"] = true,
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {0, 32}}},
	},
	["outline_l"] = {
		["collsides"] = {["left"] = true},
		["solid"] = true,
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {0, 16}}},
	},
	--test
	["outline_uldr"] = {
		["collsides"] = {["up"] = true, ["left"] = true, ["down"] = true, ["right"] = true},
		["solid"] = true,
		["graphics"] = {
			{["referencename"] = "outlinetiles", ["quad"] = {0, 0}},
			{["referencename"] = "outlinetiles", ["quad"] = {32, 32}}
		},
	},
	
	["pattern1"] = {
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {48, 0}}},
	},
	["pattern2"] = {
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {48, 16}}},
	},
	["pattern3"] = {
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {48, 32}}},
	},
	["pattern4"] = {
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {16, 16}}},
	},
	["pattern5"] = {
		["graphics"] = {{["referencename"] = "outlinetiles", ["quad"] = {64, 0}}},
	},
	["missingtexture"] = {
		["graphics"] = {{["referencename"] = "missing_texture", ["quad"] = {0, 0}}},
	},
	
	
	
	["strangeslab1"] = {
		["graphics"] = {{["referencename"] = "strangeslab", ["quad"] = {0, 0}}},
		["solid"] = true,
		["deathly"] = false,
		["automask"] = true
	},
	["strangeslab2"] = {
		["graphics"] = {{["referencename"] = "strangeslab", ["quad"] = {16, 0}}},
		["solid"] = true,
		["deathly"] = false,
		["automask"] = true
	},
	["strangeslab3"] = {
		["graphics"] = {{["referencename"] = "strangeslab", ["quad"] = {32, 0}}},
		["solid"] = true,
		["deathly"] = false,
		["automask"] = true
	},
	["strangeslab4"] = {
		["graphics"] = {{["referencename"] = "strangeslab", ["quad"] = {0, 16}}},
		["solid"] = true,
		["deathly"] = false,
		["automask"] = true
	},
	["strangeslab5"] = {
		["graphics"] = {{["referencename"] = "strangeslab", ["quad"] = {16, 16}}},
		["solid"] = true,
		["deathly"] = false,
		["automask"] = true
	},
	["strangeslab6"] = {
		["graphics"] = {{["referencename"] = "strangeslab", ["quad"] = {32, 16}}},
		["solid"] = true,
		["deathly"] = false,
		["automask"] = true
	},
	["strangeslab7"] = {
		["graphics"] = {{["referencename"] = "strangeslab", ["quad"] = {0, 32}}},
		["solid"] = true,
		["deathly"] = false,
		["automask"] = true
	},
	["strangeslab8"] = {
		["graphics"] = {{["referencename"] = "strangeslab", ["quad"] = {16, 32}}},
		["solid"] = true,
		["deathly"] = false,
		["automask"] = true
	},
	["strangeslab9"] = {
		["graphics"] = {{["referencename"] = "strangeslab", ["quad"] = {32, 32}}},
		["solid"] = true,
		["deathly"] = false,
		["automask"] = true
	},
	["objectcollider"] = {
		["graphics"] = {{["referencename"] = "colliders", ["quad"] = {0, 0}}},
		["solid"] = true,
--		["noplayercollide"] = true, --dealt with manually by ogmo
	},
	["playercollider"] = {
		["graphics"] = {{["referencename"] = "colliders", ["quad"] = {16, 0}}},
		["solid"] = false,
--		["playercollide"] = true, --dealt with manually by ogmo
	},
}
--[[ magic numbers are no longer used
for i=0, 9 do
	tiles["magic" .. i] = {
		["graphics"] = {
			{
				["referencename"] = "ui/subscripts",
				["quad"] = { i * 16, 0}
			}
		},
		["invisible"] = true
	}
end
]]

for i,v in ipairs(consts.ascii_table) do
	tiles["ascii_" .. v] = {
		["graphics"] = {{["referencename"] = "ui/ascii", ["quad"] = {
			math.fmod(i - 1, 16) * 16,
			32 + (math.floor((i - 1) / 16) * 16)
		}}},
	}
end

for k,v in pairs(tiles) do
	v.type = k
end

--test to make sure the tables don't get shared with the above generative thing. gets annoying that there's no explicit table constructor
--print(tiles["magic1"].graphics[1].quad[1])
--print(tiles["magic5"].graphics[1].quad[1])