local selectionimg = graphics.load("ui/selections")
local toolimg = graphics.load("ui/icons_tool")
editor = {
	lmbtile = "t ",
	rmbtile = "  ",
	mmbtile = "x ",
	currenttag = "spawn1",
	mbtilekeys = {"lmbtile", "rmbtile", "mmbtile"}, --purely for reference
	lastmbtouched = 1,
	currentpage = 1,
	currenttagspage = 1,
	pages = {}, --gets contents of editor_pages on each editor begin (except when returning from testing)
	tags_pages = {},
	symbolmap = nil,
	currentsymbolmap = 5,
	tagmap = false,
	dotagchecksweep = false,
	maptileheight = 0,
	maptilewidth = 0,
	background = "#341160",
	addedheight = tilesize * 4,
	addedwidth = tilesize * 4,
	innerheight = 512,
	innerwidth = 512,
	height = 512 + (tilesize * 4),
	width = 512 + (tilesize * 4),
	visiblesymbolmaps = 9,
	defaultsymbolmap = 5,
	viewallsymbolmaps = true,
	tilebaroffset_x = tilesize * 2,
	tilebaroffset_y = tilesize,
	tagbaroffset_x = (tilesize * 16) + 8,
	tagbaroffset_y = tilesize,
	currentlevelset = "",
	currentlevel = "",
	currentpath = "",
	currenttool = "pencil",
	originalmousepress = nil,
	eyedropperused = false,
	levelpackedfortesting = nil,
	returningfromgame = false,
	transitioningtogame = false,
	mapview_x = 0,
	mapview_y = 0,
	mapview_width = 32,
	mapview_height = 32,
	
	tag_draw_x_offsets = {0, 8, 0, 8, 4}, --nth tag on a tile gets x offset #n
	tag_draw_y_offsets = {0, 0, 8, 8, 4}, --nth tag on a tile gets y offset #n
	tag_draw_alpha = 0.666,
	tag_draw_alpha_default =  0.666,
	tag_draw_alpha_tagsselected = 1,
	
	scrollVert_HoldMoveDelayResetToLong = 15, --frames
	scrollVert_HoldMoveDelayResetToShort = 5,
	scrollVert_HoldMoveDelayResetToFast = 1,
	scrollVert_HoldMoveDelayCurrent = 0,
	scrollVert_LongHoldPassed = false,
	
	scrollHori_HoldMoveDelayResetToLong = 15, --frames
	scrollHori_HoldMoveDelayResetToShort = 5,
	scrollHori_HoldMoveDelayResetToFast = 1,
	scrollHori_HoldMoveDelayCurrent = 0,
	scrollHori_LongHoldPassed = false,
	
	
	selectionquads = {
		["lmb"] = quad(0, 0, 16, 16, selectionimg),
		["mmb"] = quad(16, 0, 16, 16, selectionimg),
		["rmb"] = quad(32, 0, 16, 16, selectionimg),
		["lmb_orig"] = quad(0, 16, 16, 16, selectionimg),
		["mmb_orig"] = quad(16, 16, 16, 16, selectionimg),
		["rmb_orig"] = quad(32, 16, 16, 16, selectionimg),
		["any"] = quad(0, 32, 16, 16, selectionimg),
		["tag"] = quad(32, 32, 12, 12, selectionimg),
		["lmb_btm"] = quad(0, 8, 16, 8, selectionimg),
		["mmb_btm"] = quad(16, 8, 16, 8, selectionimg),
		["rmb_btm"] = quad(32, 8, 16, 8, selectionimg),
		["text_pre"] = quad(16, 32, 16, 16, selectionimg),
		["text"] = quad(0, 56, 16, 16, selectionimg),
		["text_orig"] = quad(16, 56, 16, 16, selectionimg),
		["newline"] = quad(32, 56, 16, 16, selectionimg),
	},
	inactiveselectionalpha = 0.5,
	
	tools = {
		"pencil",
		"eyedropper",
		"rectangle",
		"fillrectangle",
		"fill",
		"tags",
		"text",
		"tagrectangle"
	},
	toolquads = {
		["pencil"] = quad(0, 0, 16, 16, toolimg),
		["eyedropper"] = quad(16, 0, 16, 16, toolimg),
		["rectangle"] = quad(32, 0, 16, 16, toolimg),
		["fillrectangle"] = quad(48, 0, 16, 16, toolimg),
		["fill"] = quad(0, 16, 16, 16, toolimg),
		["tags"] = quad(16, 16, 16, 16, toolimg),
		["text"] = quad(32, 16, 16, 16, toolimg),
		["tagrectangle"] = quad(48, 16, 16, 16, toolimg),
	},
	toolbindings = {
		["c"] = "pencil",
		["e"] = "eyedropper",
		["r"] = "rectangle",
		["t"] = "fillrectangle",
		["f"] = "fill",
		["g"] = "tags",
		["\\"] = "text",
		["y"] = "tagrectangle",
	},
	tooltipScale = 0.75,
	tooltip = nil,
	hoveredelement = nil,
	dodebugprint = false,
	
	roomX = 0,
	roomY = 0,
	isempty = false,
	unsaved = false,
	--unsaved_notinmatrixyet = false,
	deletethis = false,
	
	unsavedrooms = {}, --matrix of levels
	unsavedroomsamt = 0,
	extantrooms = {}, --matrix of bools (true meaning exists)
	deleterooms = {}, --matrix of bools (true meaning pending deletion)
	deleteroomsamt = 0,
	
	roommap = roommap:setup(360, 62, 7, 5, "bottomleft"),
	bigroommap = roommap:setup(0, 0, 53, 40, "topleft"),
	showbigroommap = false,
	
	bigfont = love.graphics.newFont(16),
	
	clipboard = {
		empty = true,
		
		x = false,
		y = false,
		object = false,
		levelset = false,
	},
	
	entrance = false,
	
	typing = false,
	typingX = 0,
	typingY = 0,
	typing_origX = 0,
	typing_origY = 0,
	--juststoppedtyping = false,
	
	newlines = {},
	
	woahthere = false,
	
	returnfromshowbox = false,
}

function editor.stopTyping()
	editor.typing = false
	editor.newlines = {}
	love.keyboard.setKeyRepeat(false)
end

function editor.addNewline(x,y)
	editor.newlines[y] = x
end

--aux related to key shortcuts
function editor.clipboardCopy()
	local clipboard = editor.clipboard
	clipboard.levelset = editor.currentlevelset
	clipboard.x = editor.roomX
	clipboard.y = editor.roomY
	if editor.isempty and not clipboard.empty then print("(emptying clipboard)") end
	clipboard.empty = editor.isempty
	clipboard.object = false
		--clipboard.object = editor.level:clone("ctrlc")
end

function editor.clipboardPaste()
	local clipboard = editor.clipboard
	if clipboard.empty then print("clipboard's empty pal. if you wanted to delete the current room, use ctrl+del for that")
	elseif not clipboard.levelset then print("clipboard.levelset is false but clipboard isn't empty so something's probably wrong")
	else
		if editor.deletethis then
			editor.deletethis = false
			editor.deleterooms[editor.roomY][editor.roomX] = nil
			if not next(editor.deleterooms[editor.roomY]) then editor.deleterooms[editor.roomY] = nil end
			editor.deleteroomsamt = editor.deleteroomsamt - 1
		end
		if not ((not clipboard.object) and editor.roomX == clipboard.x and editor.roomY == clipboard.y and editor.currentlevelset == clipboard.levelset) then
			editor.makeunsaved(true)
			editor.notempty(true)
		else
			print("pasted an unchanged room onto itself. lol. idk maybe you changed the file externally and you're using this instead of ctrl+r for some reason?")
		end
		if clipboard.object then
			editor.loadLevel(clipboard.object, false, true)
		else
			if editor.unsavedrooms[clipboard.y] and editor.unsavedrooms[clipboard.y][clipboard.x] then
				editor.loadLevel(editor.unsavedrooms[clipboard.y][clipboard.x], false, true)
			end
			local path = table.concat({"ext_levelsets/", clipboard.levelset, "/levels/", tostring(clipboard.x), ",", tostring(clipboard.y), ".txt"}, "")
			if love.filesystem.getInfo(path) then
				editor.loadLevel(path)
			else
				print("uh-oh, clipboard path doesn't exist: " .. path)
			end
		end
	end
	editor.level.roomX = editor.roomX
	editor.level.roomY = editor.roomY
end

function editor.markDelete()
	if editor.typing then
		editor.stopTyping()
	end
	if editor.isempty then print("this room is empty you can't delete it >:(")
	elseif not editor.deletethis then
		if not editor.deleterooms[editor.roomY] then editor.deleterooms[editor.roomY] = {} end
		editor.deleterooms[editor.roomY][editor.roomX] = true
		editor.deletethis = true
		editor.deleteroomsamt = editor.deleteroomsamt + 1
	end
end

function editor.saveRoom(x, y)
	local iscurrent = (editor.roomX == x and editor.roomY == y)
	local coords = tostring(x) .. "," .. tostring(y)
	local path = table.concat({"ext_levelsets/", editor.currentlevelset, "/levels/", coords, ".txt"}, "")
	if (iscurrent and editor.deletethis) or (editor.deleterooms[y] and editor.deleterooms[y][x]) then --saving rooms marked for deletion deletes them. this is so deleting files and writing to files both requires saving, which adds a layer of confirmation, and also it just feels natural to have all filesystem stuff prompted by one key combination
		--firstly, if the room being deleted is the room currently in the clipboard, and it hasn't been converted to an object (i.e. we're still assuming this room will be here in its current state when we press ctrl+v), convert it to an object now
		local clipboard = editor.clipboard
		if clipboard.x == x and clipboard.y == y and not clipboard.object then
			local lvl
			if iscurrent then
				clipboard.object = editor.level
			elseif editor.unsavedrooms[y] and editor.unsavedrooms[y][x] then
				clipboard.object = editor.unsavedrooms[y][x]
			else
				clipboard.object = level:new(love.filesystem.read(path))
			end
		end
		local success = love.filesystem.remove(path)
		if success then
			print("deleted file " .. path)
		end
		local unsaved = editor.removeunsavedroom(x, y)
		if unsaved and not success then
			print("deleted unsaved room at " .. coords)
		end
		editor.extantrooms[y][x] = nil
		if not next(editor.extantrooms[y]) then editor.extantrooms[y] = nil end
		editor.deleterooms[y][x] = nil
		if not next(editor.deleterooms[y]) then editor.deleterooms[y] = nil end
		editor.deleteroomsamt = editor.deleteroomsamt - 1
		if iscurrent then
			editor.deletethis = false
			editor.unsaved = false
			editor.gotoRoom(x, y)
		end
	else
		if (iscurrent and editor.unsaved) or (editor.unsavedrooms[y] and editor.unsavedrooms[y][x]) then
			local lvl
			if iscurrent then lvl = editor.level
			else lvl = editor.unsavedrooms[y][x] end
			lvl.unsaved = false
			if not editor.level.name then editor.level.name = coords end
			--if editor.currentlevel == "" then error("while saving level: currentlevel is empty string, uh-oh") end
			local levelfile = editor.packLevel(lvl, false)
			--love.filesystem.write("boink.txt",levelfile)
			if not editor.currentlevelset or editor.currentlevelset == "" then
				error("you're trying to save but you're not in a levelset???")
				--[[
				pathuptoleveltemp = {"ZZZorphanedlevels", "levels"}
				fulllevelpath = "ext_levelsets/ZZZorphanedlevels/levels/" .. editor.currentlevel .. ".txt"
				print("no levelset specified, so this will be saved to ZZZorphanedlevels")
				]]
			end
			--[[
			local pathuptolevel = ""
			local pathuptoleveltemp = {editor.currentlevelset, "levels"}
			local levelandsubfolders = split(editor.currentlevel, "/")
			for i=1, #levelandsubfolders do pathuptoleveltemp[#pathuptoleveltemp + 1] = levelandsubfolders[i] end
			for i=1, #pathuptoleveltemp - 1 do
				pathuptolevel = pathuptolevel .. pathuptoleveltemp[i]
				if i ~= #pathuptoleveltemp - 1 then pathuptolevel = pathuptolevel .. "/" end
			end
			love.filesystem.createDirectory("ext_levelsets/" .. pathuptolevel)
			]]
			local success, message = love.filesystem.write(path,levelfile)
			if success then
				print("saved to " .. path .. "!")
				editor.removeunsavedroom(x, y)
			else
				print("save failed. " .. message)
			end
		else print("already saved!") end
	end
end

editor.textfields = {
	--textfield:setup(256, 528, 160, 16, "saveload", "currentpath", "The level that should be saved to with Ctrl+S, or loaded with Ctrl+L.")
	--textfield:setup(400, 51, 80, 16, "currentlevelset", "currentlevelset", "name of levelset the level is in", set("\\", "/", ":", "*", "?", "\"", "<", ">", "|"), "bottomleft"), --excluded characters set is windows-centric :/
	--textfield:setup(400, 31, 80, 16, "currentlevel", "currentlevel", "name of level, within levelset, to save/load", set("\\", ":", "*", "?", "\"", "<", ">", "|"), "bottomleft")
}

editor.sleekbuttons = {
	{
		label = "properties",
		tooltip = "edit properties for the current level. hotkey: ctrl+P",
		x = 472, y = 491,
		action = function() ih8ui.showBox(boxes.levelproperties) end
	},
	{
		label = "levelset",
		tooltip = "edit properties for the whole levelset. hotkey: ctrl+shift+P",
		x = 472, y = 517,
		action = function() ih8ui.showBox(boxes.levelsetproperties) end
	},
	{
		label = "elements",
		tooltip = "select from the full list of elements. hotkey: ` (backtick/tilde)",
		x = 552, y = 491,
		action = function() statemachine.setstate("symboldisplay") end
	},
	{
		label = "help",
		tooltip = "view the jumper 4 real help file. hotkey: f1",
		x = 552, y = 517,
		action = function() love.system.openURL("file://"..love.filesystem.getSaveDirectory().."/Jumper 4 Real.chm"); print("opening help file"); end
	}
}

for i,v in ipairs(editor.sleekbuttons) do
	v.hovered = false
	v.width = 64
	v.height = 16
	v.text = love.graphics.newText(love.graphics.getFont())
	v.text:setf(v.label, v.width, "center")
end

editor.focusedfield = nil

editor.buttons = {
	
}

local tooltips = {
	["pencil"] = "Pencil: Place a single tile at the spot you click on. Hotkey: C",
	["fill"] = "Fill: Fill a contiguous space with one type of tile. Hotkey: F",
	["eyedropper"] = "Eyedropper: Retrieve the tile at the spot you click on. Hotkey: E",
	["rectangle"] = "Rectangle: Efficiently draw a rectangular outline. Hotkey: R",
	["fillrectangle"] = "Filled rectangle: Efficiently draw a filled rectangle. Hotkey: T",
	["tags"] = "tags: use this to place \"tags\" like spawn numbers. hotkey: G",
	["text"] = "text: write text with your keyboard. hotkey: \\",
	["tagrectangle"] = "Tag rectangle: Efficiently place tags in filled rectangles. Hotkey: Y"
}

for i, v in ipairs(editor.tools) do
	table.insert(editor.buttons, button:setup(
		(16 * 2) + (16 * (1 - ((i - 1) % 2))),
		16 + (16 * (math.floor((i - 1) / 2))),
		v,
		"icons_tool",
		editor.toolquads[v],
		function(self) editor.currenttool = v end,
		function(self)
			if editor.currenttool == v then
				self.depressed = true
			else self.depressed = false end
		end,
		tooltips[v],
		false,
		"topright",
		editor.width,
		editor.height
	))
end

function editor.adjustdynamics()
	for i,v in ipairs(editor.buttons) do
		v:updateposfordimensions(editor.width, editor.height)
	end
	for i,v in ipairs(editor.textfields) do
		v:updateposfordimensions(editor.width, editor.height)
	end
	editor.roommap:updateposfordimensions(editor.width, editor.height)
end

function editor.fetchrooms()
	editor.unsavedrooms = {}
	editor.unsavedroomsamt = 0
	editor.extantrooms = {}
	editor.deleterooms = {}
	editor.deleteroomsamt = 0
	editor.unsaved = false
	editor.deletethis = false
	
	for i,v in ipairs(love.filesystem.getDirectoryItems("ext_levelsets/" .. editor.currentlevelset .. "/levels")) do
		if string.sub(v, -4) == ".txt" then
			local v = string.sub(v, 1, -5)
			local c = string.find(v, ",")
			if c then
				local x = tonumber(string.sub(v, 1,  c - 1))
				local y = tonumber(string.sub(v, c + 1, -1))
				if (x and y) and ( (math.modf(x)) == x and (math.modf(y)) == y ) then
					if not editor.extantrooms[y] then editor.extantrooms[y] = {} end
					editor.extantrooms[y][x] = true
				end
			end
		end
	end
	editor.gotoRoom(editor.roomX, editor.roomY)
end

function editor.newlevelset(name)
	if love.filesystem.getInfo("ext_levelsets/" .. name) then return false end
	love.filesystem.createDirectory("ext_levelsets/" .. name)
	love.filesystem.write("ext_levelsets/" .. name .. "/LEVELINFO.txt", table.concat({
		"===NAME===\n|",
		name,
		"\n===DESCRIPTION===\n|my awesome new levelset\n===FIRSTROOM===\n|0,0"
	}, "")
	)
	love.filesystem.createDirectory("ext_levelsets/" .. name .. "/levels")
	love.filesystem.write("ext_levelsets/" .. name .. "/levels/0,0.txt", love.filesystem.read("defaultlevel.txt"))
	local levelset = game.parseLevelset(name, true)
	table.insert(game.levelsets, levelset)
	table.insert(game.ext_levelsets, levelset)
	return levelset
end

function editor.addunsavedroom(x, y)
	if not editor.unsavedrooms[y] then editor.unsavedrooms[y] = {} end
	--[[if not editor.unsavedrooms[y][x] then 
		editor.unsavedroomsamt = editor.unsavedroomsamt + 1
	end]] --handled in makeunsaved
	editor.unsavedrooms[y][x] = editor.level
end

function editor.removeunsavedroom(x, y)
	local decroomsamt = false
	if editor.unsaved and x == editor.roomX and y == editor.roomY then
		editor.unsaved = false
		decroomsamt = true
	end
	if editor.unsavedrooms[y] and editor.unsavedrooms[y][x] then
		editor.unsavedrooms[y][x] = nil
		if not next(editor.unsavedrooms[y]) then editor.unsavedrooms[y] = nil end
		decroomsamt = true
	end
	if decroomsamt then editor.unsavedroomsamt = editor.unsavedroomsamt - 1 end
	return decroomsamt
end

function editor.makeunsaved(ignoreclipboard)
	if not ignoreclipboard then
		local clipboard = editor.clipboard
		if (not clipboard.empty) and (not clipboard.object) and clipboard.levelset == editor.currentlevelset and clipboard.x == editor.roomX and clipboard.y == editor.roomY then
			clipboard.object = editor.level:clone("ctrlc")
		end
	end
	if not editor.unsaved then
		editor.unsavedroomsamt = editor.unsavedroomsamt + 1
		editor.unsaved = true
		editor.level.unsaved = true
	end
end

function editor.gotoRoom(x, y)
	--if x == editor.roomX and y == editor.roomY then print("wentto current room, lol") end
	if editor.unsaved then
		editor.addunsavedroom(editor.roomX, editor.roomY) --editor.unsavedrooms[y][x] = editor.level except it creates y if it doesn't exist
		print(editor.unsavedrooms[editor.roomY][editor.roomX])
	end
	editor.deletethis = false
	editor.unsaved = false
	assert(type(x) == "number", "editor.gotoRoom: x isn't a number: " .. tostring(x))
	assert(type(y) == "number", "editor.gotoRoom: y isn't a number: " .. tostring(y))
	assert(x == (math.modf(x)), "editor.gotoRoom: x is noninteger: " .. tostring(x))
	assert(y == (math.modf(y)), "editor.gotoRoom: y is noninteger: " .. tostring(y))
	editor.roomX = x
	editor.roomY = y
	editor.currentlevel = tostring(x) .. "," .. tostring(y)
	--local itexists = doesitexist() --should check the matrix that defines whether each room is nonempty (which should be a thing so love.filesystem.getinfo isn't called in draw 100 times)
	local itexists = editor.extantrooms[y] and editor.extantrooms[y][x]
	local itkindaexists = editor.unsavedrooms[y] and editor.unsavedrooms[y][x]
	if itkindaexists then
		print("loading unsaved room")
		editor.unsaved = true
		editor.isempty = false
		editor.loadLevel(editor.unsavedrooms[y][x], false, true)
	elseif (not itexists) and not editor.isempty then
		print("loading blank room")
		editor.unsaved = false
		editor.isempty = true
		editor.loadLevel("", true)  --blank level
	elseif itexists then
		print("loading saved room")
		editor.unsaved = false
		editor.isempty = false
		editor.loadLevel("ext_levelsets/" .. editor.currentlevelset .. "/levels/" ..editor.currentlevel .. ".txt")
	end
	if editor.deleterooms[y] and editor.deleterooms[y][x] then editor.deletethis = true end
end

function editor.packTagmap(tagmap)
	local currentruns = {}
	local runmap = {}
	local e = {} --empty
	
	local function clear(t)
		for k,v in pairs(t) do
			currentruns[k] = nil
		end
	end
	
	local function terminateruns(t, t2, y)
		for k,v in pairs(t) do
			local run = v
			run.kind = k
			local startingx = run.x
			local merged_into_above_run = false
			if y > 1 then
				local aboveruns = runmap[y - 1][startingx]
				local i = 1
				while true do
					--print(i)
					if (not aboveruns) then break end
					if aboveruns[k] ~= "stretch" then
						break
					else
						--print("found a stretch")
					end
					
					i = i + 1
					aboveruns = runmap[y - i][startingx]
				end
				if aboveruns then
					for _,aboverun in ipairs(aboveruns) do
						if aboverun.kind == run.kind and aboverun.width == run.width then
							aboverun.height = aboverun.height + 1
							merged_into_above_run = true
							if not runmap[y][startingx] then runmap[y][startingx] = {} end
							runmap[y][startingx][k] = "stretch"
							break
						end
					end
				end
			end
			if not merged_into_above_run then
				--print("run at " .. tostring(y) .. "," .. tostring(startingx))
				local runs = runmap[y][startingx] --multiple runs can start from the same position
				if not runs then runmap[y][startingx] = {}; runs = runmap[y][startingx]; end
				runs[#runs + 1] = run
				--print(run)
				--print(runmap[y][startingx], runmap[y][startingx][#runmap[y][startingx]])
			end
			t[k] = nil
			t2[k] = nil
		end
	end
	
	--for each row, we generate horizontal "runs" and merge them into any identical runs in the above row. this is how we generate the rectangles that are used in the level format
	for y=1, #tagmap do
		runmap[y] = {}
		--if next(currentruns) then print("currentruns isn't empty!") end
		for x=1, #tagmap[y] do
			runmap[y][x] = false
			local tags = tagmap[y][x] or e
			local missing = {}
			for k,v in pairs(currentruns) do
				missing[k] = v
			end
			for _,tag in ipairs(tags) do
				if not currentruns[tag] then
					currentruns[tag] = {width = 0, height = 1, ["x"] = x}
				end
				currentruns[tag].width = currentruns[tag].width + 1
				missing[tag] = nil
			end
			terminateruns(missing, currentruns, y)
		end
		terminateruns(currentruns, currentruns, y)
	end
	
	local returnarray = {}
	
	for y=1, #runmap do
		for x=1, #runmap[y] do
			if runmap[y][x] and runmap[y][x] ~= "stretch" and #runmap[y][x] > 0 then
				--print("found anything")
				local runs = runmap[y][x]
				--stabilization
				table.sort(runs, function(a, b) return a.kind < b.kind or a.width < b.width or a.height < b.height end)
				for i,v in ipairs(runs) do
					returnarray[#returnarray + 1] = "|" .. v.kind .. ":" .. x .. "," .. y .. "-" .. x + (v.width - 1) .. "," .. y + (v.height - 1)
				end
			end
		end
	end
	
	return returnarray
end

function editor.packLevel(lvl, dontconcat)
	--levelfile = "" --previously "dontconcat" was "splitme" and instead of adding things to a table it did levelfile = levelfile .. something .. "\n" which pil told me is really inefficient due to how much memory gets moved around with creation of new strings. i take all my lua advice from public image ltd
	local levelfile = {}
	local function append(s)
		levelfile[#levelfile + 1] = s
	end
	if #lvl.comments > 0 then
		append("===COMMENTS===")
		for i=1, #lvl.comments do
			append("|" .. lvl.comments[i])
		end
	end
	local firstmap = true
	for i=1, #lvl.symbolmaps do
		if not lvl.symbolmaps[i].isempty then
			append(">len:" .. #lvl.symbolmaps[i][1])
			break
		end
	end
	for i=1, #lvl.symbolmaps do
		if not lvl.symbolmaps[i].isempty then
			append("===MAP:" .. i .. "===")
			local lastrow = {}
			local repno = 0
			for y=1, #lvl.symbolmaps[i] do
				local row = {"|"}
				local onlytile
				local sameaslastrow = true
				for x=1, #lvl.symbolmaps[i][y] do
					--this part also involved string concatting. not as serious here but with super big maps might cause noticeable delay?
					if onlytile ~= lvl.symbolmaps[i][y][x] then
						if onlytile == nil then
							onlytile = lvl.symbolmaps[i][y][x]
						else
							onlytile = false
						end
					end
					row[#row + 1] = lvl.symbolmaps[i][y][x]
					if sameaslastrow and row[#row] ~= lastrow[#row] then
						sameaslastrow = false
					end
				end
				lastrow = row
				if sameaslastrow then
					repno = repno + 1
				else
					if repno > 0 then
						append(">rep:" .. repno)
						repno = 0
					end
					if onlytile then
						append(">row:" .. onlytile)
					else
						append(table.concat(row))
					end
				end
			end
			if repno > 0 then
				append(">rep:" .. repno)
			end
			if lvl.tagmaps[i] then
				append(">tag")
				local tag_lines = editor.packTagmap(lvl.tagmaps[i])
				--print(#tag_lines)
				for _,v in ipairs(tag_lines) do append(v) end
			end
		end
	end
	if #lvl.exits > 0 then
		append("===EXITS===")
		for i=1, #lvl.exits do
			append("|" .. lvl.exits[i])
		end
	end
	if lvl.music then
		append("===MUSIC===")
		append("|" .. lvl.music)
	end
	if next(lvl.options) then
		append("===OPTIONS===")
		local optionslist = {}
		for k,v in pairs(lvl.options) do
			if v then
				optionslist[#optionslist + 1] = k
			end
		end
		--stabilization
		table.sort(optionslist, function(a, b) return a < b end)
		for i=1, #optionslist do
			if optionslist[i] ~= "" then append("|" .. optionslist[i]) end
		end
	end
	if lvl.background then
		append("===BACKGROUND===")
		append("|" .. lvl.background)
	end
	if #lvl.hints > 0 then
		append("===HINTS===")
		for i=1, #lvl.hints do
			append("|" .. lvl.hints[i])
		end
	end
	if #lvl.npcs > 0 then
		append("===NPCS===")
		for _,npc in ipairs(lvl.npcs) do
			append(">" .. npc.name)
			for _,txt in ipairs(npc.text) do
				append("|" .. txt)
			end
		end
	end
	if not dontconcat then return table.concat(levelfile, "\n")
	else return levelfile end
end

function editor.resizelevel(w, h)
	if w == editor.maptilewidth and h == editor.maptileheight then return end
	assert(w, "editor.resizelevel: width is nil")
	assert(h, "editor.resizelevel: height is nil")
	local orig_w = editor.maptilewidth
	local orig_h = editor.maptileheight
	editor.maptilewidth = w
	editor.maptileheight = h
	local lvl = editor.level
	lvl.width = tilesize * w
	lvl.height = tilesize * h
	for i,symbolmap in ipairs(editor.level.symbolmaps) do
		--if not symbolmap.isempty then
		if true then
			local tagmap = editor.level.tagmaps[i]
			if w > #symbolmap[1] then
				for _,row in ipairs(symbolmap) do
					while #row < w do
						if tagmap then tagmap[#row + 1] = false end
						row[#row + 1] = "  "
					end
				end
			elseif w < #symbolmap[1] then
				for _,row in ipairs(symbolmap) do
					while #row > w do
						if tagmap then tagmap[#row] = nil end
						row[#row] = nil
					end
				end
			end
			if h > #symbolmap then
				while #symbolmap < h do
					local new_symbolmap_row = {}
					local new_tagmap_row = {}
					for i=1, #symbolmap[1] do
						new_symbolmap_row[#new_symbolmap_row + 1] = "  "
						if tagmap then new_tagmap_row[#new_tagmap_row + 1] = false end
					end
					symbolmap[#symbolmap + 1] = new_symbolmap_row
					if tagmap then tagmap[#tagmap + 1] = new_tagmap_row end
				end
			elseif h < #symbolmap then
				while #symbolmap > h do
					if tagmap then tagmap[#symbolmap] = nil end
					symbolmap[#symbolmap] = nil
				end
			end
		end
	end
	editor.symbolmap = editor.level.symbolmaps[editor.currentsymbolmap]
	editor.tagmap = editor.level.tagmaps[editor.currentsymbolmap]
	if w < orig_w or h < orig_h then
		editor.postresizemassemptycheck()
	end
end

function editor.makeEmptySymbolMap(w, h)
	local newmap = {}
	for i=1, h do
		local newrow = {}
		for ii=1, w do
			newrow[ii] = "  "
		end
		newmap[i] = newrow
	end
	newmap.isempty = true
	return newmap
end

function editor.makeEmptyTagMap(w, h)
	local newmap = {}
	for i=1, h do
		local newrow = {}
		for ii=1, w do
			newrow[ii] = false
		end
		newmap[i] = newrow
	end
	return newmap
end

--note: use editor.loadLevel(clipboard.level, nil, true) for if clipboard has actual level, editor.loadLevel(levelfileconcattedfrompositionandshit) for if clipboard has coordinate
--uh no? why?
--everything about this confuses me and i'm 99% sure i wrote it
function editor.loadLevel(data, notapath, actualobject, dontreplace) --why dontreplace?
	editor.stopTyping()
	local newlevel
	if actualobject then
		newlevel = data
		newlevel:cleanupfromgame()
	elseif notapath then
		newlevel = level:new(data)
	else
		newlevel = level:new(love.filesystem.read(data))
	end
	if not newlevel then error("fucked up while loading level. data: " .. tostring(data), 2) end
	if not newlevel.width then newlevel.width = tilesize * editor.maptilewidth end
	if not newlevel.height then newlevel.height = tilesize * editor.maptileheight end
	local firstnonemptysymbolmap = nil
	local emptysymbolmaps = {}
	for i=1, editor.visiblesymbolmaps do
		if not newlevel.symbolmaps[i] then
			table.insert(emptysymbolmaps, i)
		elseif newlevel.symbolmaps[i] and not newlevel.symbolmaps[i].isempty then
			if not firstnonemptysymbolmap then firstnonemptysymbolmap = i end
			if not dontreplace then
				if editor.maptileheight ~= #newlevel.symbolmaps[i] then editor.maptileheight = #newlevel.symbolmaps[i] end
				if newlevel.symbolmaps[i][1] and editor.maptilewidth ~= #newlevel.symbolmaps[i][1] then editor.maptilewidth = #newlevel.symbolmaps[i][1] end
			end
		end
	end
	--print("detected maptilewidth: " .. editor.maptilewidth)
	--print("detected maptileheight: " .. editor.maptileheight)
	for i=1, #emptysymbolmaps do
		newlevel.symbolmaps[emptysymbolmaps[i]] = editor.makeEmptySymbolMap(editor.maptilewidth, editor.maptileheight)
	end
	
	--if firstnonemptysymbolmap == nil then firstnonemptysymbolmap = 1; print("all symbol maps were empty!"); end
	
	if not dontreplace then
		editor.level = newlevel
		--comment out below line since reverting to layer 5 every time room is changed is dumb
		--editor.currentsymbolmap = editor.defaultsymbolmap
		editor.symbolmap = editor.level.symbolmaps[editor.currentsymbolmap]
		editor.tagmap = editor.level.tagmaps[editor.currentsymbolmap]
	end
	
	return newlevel
end

--editor.loadLevel("defaultlevel.txt")

local numberquads = {}

for i=1, 99 do
	numberquads[i] = love.graphics.newQuad(i * 16, 0, 16, 16, graphics.load("ui/bignumbers"))
end

for i=1, editor.visiblesymbolmaps do
	--if not editor.level.symbolmaps[i] then
	--	editor.level.symbolmaps[i] = editor.makeEmptySymbolMap(editor.maptilewidth, editor.maptileheight)
	--end
	table.insert(editor.buttons, button:setup(
		16 + (16 * (2 - ((i - 1) % 3))),
		16 + (16 * (2 - (math.floor((i - 1) / 3)))),
		"layer" .. i,
		"bignumbers",
		numberquads[i],
		function(self) editor.currentsymbolmap = i end,
		function(self)
			if editor.level.symbolmaps[i].isempty then
				self.iconrgba[4] = 0.5
			else
				self.iconrgba[4] = 1
			end
			if editor.currentsymbolmap == i then
				self.depressed = true
			else self.depressed = false end
		end,
		"Click to make Layer " .. i .. " the active layer.",
		function(self)
			if editor.level.tagmaps[i] then
				love.graphics.draw(graphics.load("ui/layer_contains_tag"), self.x, self.y)
			end
		end,
		"bottomright",
		editor.width,
		editor.height
	))
end

table.insert(editor.buttons, button:setup(
	16 * 4,
	16 * 4,
	"eyes",
	"icons_misc",
	quad(0, 0, 16, 16, graphics.load("ui/icons_misc")),
	function(self) editor.viewallsymbolmaps = not editor.viewallsymbolmaps end,
	function(self)
		if editor.viewallsymbolmaps then
			self.depressed = true
		else self.depressed = false end
	end,
	"Click to toggle between viewing all layers of the map, or just the active layer.",
	false,
	"bottomright",
	editor.width,
	editor.height
))

--music button. this is after the idea of the game being freely resizable was abandoned, so the position is relative from top-left instead of top-right or bottom-right because top-left is easier to calculate
table.insert(editor.buttons, button:setup(
	648,
	296,
	"music",
	"music",
	quad(0,0,16,16,16,16),
	function(self) editor.playingamemusic = not editor.playingamemusic end,
	function(self)
		if editor.playingamemusic then
			self.depressed = true
		else self.depressed = false end
	end,
	"click to toggle whether in-game music should be played",
	false,
	"topleft",
	editor.width,
	editor.height
))

function editor.begin(previous)
	--game.editormode = true
	if editor.adjustdynamicswhenbegun then
		editor.adjustdynamicswhenbegun = false
		editor.adjustdynamics()
	end
	if editor.returningfromgame then
		editor.level:cleanupfromgame()
		if editor.playingamemusic and audio.activesong ~= "hustle thing" then
			audio.playsong("hustle thing")
		end
	end
	if (not editor.returningfromgame) and (previous ~= symboldisplay) then --i think editor.returningfromgame is basically the same as previous ~= game, except editor.returningfromgame came before the "previous" arg
		for k,v in pairs(editor_pages) do editor.pages[k] = v end
		for k,v in pairs(editor_tags_pages) do editor.tags_pages[k] = v end
		resizeWindow(menu.width + editor.addedwidth, menu.height + editor.addedheight, {minwidth = 128 + editor.addedwidth, minheight = 128 + editor.addedheight}, true)
		audio.playsong("hustle thing")
	end
	editor.returningfromgame = false
end

function editor.notempty(justroom)
	editor.level.roomX = editor.roomX
	editor.level.roomY = editor.roomY
	if not justroom then
		editor.symbolmap.isempty = false
	end
	if editor.isempty then
		if not editor.extantrooms[editor.roomY] then editor.extantrooms[editor.roomY] = {} end
		editor.extantrooms[editor.roomY][editor.roomX] = true
	end
	editor.isempty = false --  room is not empty
end

function editor.checkemptymap()
	local thismapempty = true
	for y_tiled=1, #editor.symbolmap do
		for x_tiled=1, #editor.symbolmap[y_tiled] do
			if editor.symbolmap[y_tiled][x_tiled] ~= "  " then
				thismapempty = false
				break
			end
		end
	end
	if thismapempty then editor.symbolmap.isempty = true
	else editor.symbolmap.isempty = false end
end

function editor.checkemptytagmap()
	if editor.tagmap then
		local thismapempty = true
		for y_tiled=1, #editor.symbolmap do
			for x_tiled=1, #editor.symbolmap[y_tiled] do
				if editor.tagmap[y_tiled][x_tiled] then
					thismapempty = false
					break
				end
			end
		end
		if thismapempty then
			editor.tagmap = false
			editor.level.tagmaps[editor.currentsymbolmap] = false
		end
	end
end

function editor.postresizemassemptycheck() --after resizing to make the level smaller
	local orig = editor.currentsymbolmap
	for i=1, editor.visiblesymbolmaps do
		editor.currentsymbolmap = i
		editor.symbolmap = editor.level.symbolmaps[editor.currentsymbolmap]
		editor.tagmap = editor.level.tagmaps[editor.currentsymbolmap]
		if not editor.symbolmap.isempty then --resizing doesn't change whether a symbolmap is empty
			editor.checkemptymap()
			editor.checkemptytagmap()
		end
	end
	editor.currentsymbolmap = orig
	editor.symbolmap = editor.level.symbolmaps[editor.currentsymbolmap]
	editor.tagmap = editor.level.tagmaps[editor.currentsymbolmap]
end

function editor.removeWrongTags(x1, y1, x2, y2)
	if editor.tagmap then
		local tagremoved = false
		if not x2 then x2 = x1 end
		if not y2 then y2 = y1 end
		if x1 > x2 then x1, x2 = x2, x1 end
		if y1 > y2 then y1, y2 = y2, y1 end
		for y_tiled=y1, y2 do
			if editor.tagmap[y_tiled] then
				for x_tiled=x1, x2 do
					if editor.tagmap[y_tiled][x_tiled] and editor.symbolmap[y_tiled][x_tiled] ~= specialsymbols.tagextender then
						if editor.symbolmap[y_tiled][x_tiled] == "  " then
							editor.tagmap[y_tiled][x_tiled] = false
							tagremoved = true
						else
							local symbol = editor.symbolmap[y_tiled][x_tiled]
							local i = 1
							while true do
								i = i + 1
								if i > #editor.tagmap[y_tiled][x_tiled] then break end
								local tag = editor.tagmap[y_tiled][x_tiled][i]
								if
									tags[tag].kind ~= "any" and (
										(tags[tag].kind == "object" and #levelsymbols[symbol].objects == 0) or
										(tags[tag].kind == "ogmo" and not levelsymbols[symbol].hasplayer) or
										(tags[tag].kind == "tile" and #levelsymbols[symbol].tiles == 0) or
										(tags[tag].kind == "exit" and not levelsymbols[symbol].hasexit)
									)
								then
									table.remove(editor.tagmap[y_tiled][x_tiled], i)
									i = i - 1
									if #editor.tagmap[y_tiled][x_tiled] == 0 then
										editor.tagmap[y_tiled][x_tiled] = false
										tagremoved = true
										break
									end
								end
							end
						end
					end
				end
			end
		end
		if tagremoved then editor.checkemptytagmap() end
	end
end

function editor.getSymbolTooltip(symbol)
	local tooltip = ""
	if symbol.name ~= "Ogmo" then tooltip = symbol.name .. ": " .. symbol.tooltip
	else tooltip = ogmos[game.ogmoskin].name .. ": " .. ogmos[game.ogmoskin].description end
	return tooltip
end

function editor.trySymbolRotate(dir)
	if editor.currenttool ~= "tags" and editor.currenttool ~= "tagrectangle" then
		--some tricky design here. these are the "rotate" keys, which rotate a tile, but there's also three mouse buttons available (inspired by rocks'n'diamonds, which didn't have rotating), so which do we rotate?
		--we assume the tile under the last mouse button the player touched. if that tile isn't rotatable, we check all mouse buttons for rotatable tiles in the order lmb, rmb, mmb.
		local rotatetile = nil
		local hasrotations = {false, false, false}
		for k,v in ipairs(editor.mbtilekeys) do
			hasrotations[k] = not not levelsymbols[editor[v]].rotations
		end
		
		local mbtotry = editor.lastmbtouched
		if not hasrotations[mbtotry] then
			mbtotry = 1
			local mbstried = 0
			while not hasrotations[mbtotry] do
				mbstried = mbstried + 1
				mbtotry = ((mbtotry + 1) % 3) + 1 --see if another mouse button has a rotateable tile
				if mbstried >= 3 then break end
			end
		end
		
		rotatetile = editor.mbtilekeys[mbtotry] or "lmbtile"
		
		local rotations = levelsymbols[editor[rotatetile]].rotations
		--we need to not only rotate the tile but also rotate its representation in the page it's from. this will probably be changed once multiple pages are acutally in; indicators of the tiles you currently have on the mouse buttons will be somewhere not tied to what page you're on
		--yep this was changed
		if rotations then
			if dir == "back" and rotations[1] then
				--[[
				for rownum,row in ipairs(editor.pages[editor.currentpage]) do
					for k,symbol in ipairs(row) do
						if symbol == editor[rotatetile] then
							editor.pages[editor.currentpage][rownum][k] = rotations[1]
						end
					end
				end
				]]
				editor[rotatetile] = rotations[1]
			elseif dir == "forward" and rotations[2] then
				--[[
				for rownum,row in ipairs(editor.pages[editor.currentpage]) do
					for k,symbol in ipairs(row) do
						if symbol == editor[rotatetile] then
							editor.pages[editor.currentpage][rownum][k] = rotations[2]
						end
					end
				end
				]]
				editor[rotatetile] = rotations[2]
			end
		end
	else
		--logic is a bit simpler if we're rotating a tag since (currently) there can only be one tag selected, so we don't need to try to deduce what it is beforehand
		local rotations = tags[editor.currenttag].rotations
		if rotations then
			if dir == "back" and rotations[1] then
				for rownum,row in ipairs(editor.tags_pages[editor.currenttagspage]) do
					for k,tag in ipairs(row) do
						if tag == editor.currenttag then
							editor.tags_pages[editor.currenttagspage][rownum][k] = rotations[1]
						end
					end
				end
				editor.currenttag = rotations[1]
			elseif dir == "forward" and rotations[2] then
				for rownum,row in ipairs(editor.tags_pages[editor.currenttagspage]) do
					for k,symbol in ipairs(row) do
						if symbol == editor.currenttag then
							editor.tags_pages[editor.currenttagspage][rownum][k] = rotations[2]
						end
					end
				end
				editor.currenttag = rotations[2]
			end
		end
	end
end

local function placetag(tag, x, y)
	if tag then editor.notempty() end
	if tag and not editor.tagmap then
		editor.makeunsaved()
		editor.tagmap = editor.makeEmptyTagMap(editor.maptilewidth, editor.maptileheight)
		editor.level.tagmaps[editor.currentsymbolmap] = editor.tagmap
		editor.tagmap[y][x] = {tag}
	else
		if editor.tagmap then
			if not tag then
				if editor.tagmap[y][x] then editor.makeunsaved() end
				editor.tagmap[y][x] = false
				editor.checkemptytagmap()
			else
				if not editor.tagmap[y][x] then
					editor.makeunsaved()
					editor.tagmap[y][x] = {tag}
				else
					local tagnotin = true
					for i,v in ipairs(editor.tagmap[y][x]) do
						if v == tag then
							tagnotin = false
							break
						end
					end
					if tagnotin then editor.makeunsaved(); table.insert(editor.tagmap[y][x], tag); end
				end
			end
		end
	end
end

function editor.update(dt)
	--[[if editor.currenttool == "tagrectangle" then
		print("OoooOOOoooOooo I am the ghost of Tagrectangle Yet to Come! I will bug you forever until you implement Tagrectangle! OOooOOooOOOOOOIhopeyousavedOOoOooOooOOOOalsodoshitabouttagextendersOOOOOOOOOOooOOOactuallyifyourethrowinginspecialbehaviorforcertainsymbolsmayaswelladdthealtwinthingwhileyoureatitOOO.")
	end]]
	if not love.mouse.isDown(1) then
		editor.returnfromshowbox = false
	end
	if editor.currenttool == "tags" or editor.currenttool == "tagrectangle" then
		editor.tag_draw_alpha = editor.tag_draw_alpha_tagsselected
	else
		editor.tag_draw_alpha = editor.tag_draw_alpha_default
	end
	--scrolling holdkey logic... for two dimensions
	--vertical
	if editor.scrollVert_HoldMoveDelayCurrent > 0 then
		editor.scrollVert_HoldMoveDelayCurrent = editor.scrollVert_HoldMoveDelayCurrent - 1
	end
	if editor.scrollVert_HoldMoveDelayCurrent == 0 and editor.focusedfield == nil then
		local dirheld = false
		if love.keyboard.isDown("down") then
			if not (love.keyboard.isDown("lctrl") or love.keyboard.isDown("rctrl")) then
				editor.gotoRoom(editor.roomX, editor.roomY + 1)
			else
				editor.mapview_y = editor.mapview_y + 1
			end
			dirheld = true
		elseif love.keyboard.isDown("up") then
			if not (love.keyboard.isDown("lctrl") or love.keyboard.isDown("rctrl")) then
				editor.gotoRoom(editor.roomX, editor.roomY - 1)
			else
				editor.mapview_y = editor.mapview_y - 1
			end
			dirheld = true
		end
		if dirheld then
			if love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift") then
				editor.scrollVert_HoldMoveDelayCurrent = editor.scrollVert_HoldMoveDelayResetToFast
				editor.scrollVert_LongHoldPassed = true
			else
				if not editor.scrollVert_LongHoldPassed then
					editor.scrollVert_HoldMoveDelayCurrent = editor.scrollVert_HoldMoveDelayResetToLong
					editor.scrollVert_LongHoldPassed = true
				else
					editor.scrollVert_HoldMoveDelayCurrent = editor.scrollVert_HoldMoveDelayResetToShort
				end
			end
		end
	end
	if ((not love.keyboard.isDown("down")) and (not love.keyboard.isDown("up"))) or editor.focusedfield ~= nil then
		editor.scrollVert_HoldMoveDelayCurrent = 0
		editor.scrollVert_LongHoldPassed = false
	end
	--horizontal
	if editor.scrollHori_HoldMoveDelayCurrent > 0 then
		editor.scrollHori_HoldMoveDelayCurrent = editor.scrollHori_HoldMoveDelayCurrent - 1
	end
	if editor.scrollHori_HoldMoveDelayCurrent == 0 and editor.focusedfield == nil then
		local dirheld = false
		if love.keyboard.isDown("right") then
			if not (love.keyboard.isDown("lctrl") or love.keyboard.isDown("rctrl")) then
				editor.gotoRoom(editor.roomX + 1, editor.roomY)
			else
				editor.mapview_x = editor.mapview_x + 1
			end
			dirheld = true
		elseif love.keyboard.isDown("left") then
			if not (love.keyboard.isDown("lctrl") or love.keyboard.isDown("rctrl")) then
				editor.gotoRoom(editor.roomX - 1, editor.roomY)
			else
				editor.mapview_x = editor.mapview_x - 1
			end
			dirheld = true
		end
		if dirheld then
			if love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift") then
				editor.scrollHori_HoldMoveDelayCurrent = editor.scrollHori_HoldMoveDelayResetToFast
				editor.scrollHori_LongHoldPassed = true
			else
				if not editor.scrollHori_LongHoldPassed then
					editor.scrollHori_HoldMoveDelayCurrent = editor.scrollHori_HoldMoveDelayResetToLong
					editor.scrollHori_LongHoldPassed = true
				else
					editor.scrollHori_HoldMoveDelayCurrent = editor.scrollHori_HoldMoveDelayResetToShort
				end
			end
		end
	end
	if not love.keyboard.isDown("left") and not love.keyboard.isDown("right") or editor.focusedfield ~= nil then
		editor.scrollHori_HoldMoveDelayCurrent = 0
		editor.scrollHori_LongHoldPassed = false
	end
	
	
	editor.symbolmap = editor.level.symbolmaps[editor.currentsymbolmap]
	editor.tagmap = editor.level.tagmaps[editor.currentsymbolmap]
	editor.hoveredelement = nil
	editor.tooltip = nil
	local xpos, ypos = love.mouse.getPosition()
	if ypos < editor.innerheight and xpos < editor.innerwidth and ((not editor.originalmousepress) or (editor.originalmousepress.x < editor.innerwidth and editor.originalmousepress.y < editor.innerheight)) then --last bit means if your original mouse press was outside the level zone, don't draw a tile by just having your mouse held and moving in. this is mirrored below to prevent drawing inside the level from turning into selecting tiles
		local xpos_tiled = 1 + math.floor(xpos / tilesize) + editor.mapview_x
		local ypos_tiled = 1 + math.floor(ypos / tilesize) + editor.mapview_y
		local mousedtile = editor.symbolmap[ypos_tiled] and editor.symbolmap[ypos_tiled][xpos_tiled]
		if mousedtile and not (editor.deletethis or editor.showbigroommap or editor.typing or editor.returnfromshowbox) then --can't change or eyedrop from levels marked for deletion until you unmark them
			if love.mouse.isDown(1, 2, 3) then
				
				local tile = nil
				if love.mouse.isDown(1) then tile = editor.lmbtile
				elseif love.mouse.isDown(2) then tile = editor.rmbtile
				elseif love.mouse.isDown(3) then tile = editor.mmbtile
				else tile = editor.lmbtile end
				
				local tag = editor.currenttag
				if love.mouse.isDown(2) then tag = false end
				
				
				if editor.currenttool == "text" and love.mouse.isDown(2) then
					--right-clicking while text is selected should act like delete
					local oldtile = editor.symbolmap[ypos_tiled][xpos_tiled]
					if oldtile ~= "  " then
						editor.makeunsaved()
						editor.symbolmap[ypos_tiled][xpos_tiled] = "  "
						editor.checkemptymap()
						editor.removeWrongTags(xpos_tiled, ypos_tiled)
					end
				
				
				elseif editor.currenttool == "pencil" then
					local oldtile = editor.symbolmap[ypos_tiled][xpos_tiled]
					if oldtile ~= tile then editor.makeunsaved() end
					editor.symbolmap[ypos_tiled][xpos_tiled] = tile
					if tile ~= "  " then editor.notempty()
					else editor.checkemptymap() end
					editor.removeWrongTags(xpos_tiled, ypos_tiled)
				
				
				elseif editor.currenttool == "tags" then
					if not (tag and editor.symbolmap[ypos_tiled][xpos_tiled] == "  ") then --can't tag empty space
						local istagright = true
						local symbol = editor.symbolmap[ypos_tiled][xpos_tiled]
						if symbol ~= specialsymbols.tagextender and tag and tags[tag].kind ~= "any" and (
							(tags[tag].kind == "object" and #levelsymbols[symbol].objects == 0) or
							(tags[tag].kind == "ogmo" and not levelsymbols[symbol].hasplayer) or
							(tags[tag].kind == "tile" and #levelsymbols[symbol].tiles == 0) or
							(tags[tag].kind == "exit" and not levelsymbols[symbol].hasexit)
						) then istagright = false end
						if istagright then
							placetag(tag, xpos_tiled, ypos_tiled)
						end
					end
				
				
				elseif editor.currenttool == "fill" then
					local step = 0
					local replacetile = mousedtile
					if tile ~= replacetile then
						editor.dotagchecksweep = true
						editor.symbolmap[ypos_tiled][xpos_tiled] = "fill"
						while step < 1000 do
							local nofillsdone = true
							for y_tiled=1, #editor.symbolmap do
								for x_tiled=1, #editor.symbolmap[y_tiled] do
									if editor.symbolmap[y_tiled][x_tiled] == replacetile then
										if
											(y_tiled > 1 and editor.symbolmap[y_tiled - 1][x_tiled] == "fill") or
											(y_tiled < #editor.symbolmap and editor.symbolmap[y_tiled + 1][x_tiled] == "fill") or
											(x_tiled > 1 and editor.symbolmap[y_tiled][x_tiled - 1] == "fill") or
											(x_tiled < #editor.symbolmap[y_tiled] and editor.symbolmap[y_tiled][x_tiled + 1] == "fill")
										then
											editor.symbolmap[y_tiled][x_tiled] = "fill"
											nofillsdone = false
										end
									end
								end
							end
							if nofillsdone then break end
							step = step + 1
						end
						if step == 1000 then print("fill went on too long") end
						for y_tiled=1, #editor.symbolmap do
							for x_tiled=1, #editor.symbolmap[y_tiled] do
								if editor.symbolmap[y_tiled][x_tiled] == "fill" then
									editor.makeunsaved()
									editor.symbolmap[y_tiled][x_tiled] = tile
									if tile ~= "  " then editor.notempty()
									else editor.checkemptymap() end
								end
							end
						end
					end
				end
			end
			if editor.currenttool == "eyedropper" then
				editor.tooltip = editor.getSymbolTooltip(levelsymbols[mousedtile])
				if love.mouse.isDown(1, 2, 3) then editor.eyedropperused = true end
				if love.mouse.isDown(1) then editor.lmbtile = mousedtile
				elseif love.mouse.isDown(2) then editor.rmbtile = mousedtile
				elseif love.mouse.isDown(3) then editor.mmbtile = mousedtile end
			end
		end
	elseif (not editor.originalmousepress) or not (editor.originalmousepress.x < editor.innerwidth and editor.originalmousepress.y < editor.innerheight) then --if your original mouse press was inside the level zone, don't grab a tile by just having your mouse held
		if editor.currenttool ~= "tags" and editor.currenttool ~= "tagrectangle" then
			local xpos_tiled_fortilebar = 1 + math.floor((xpos - editor.tilebaroffset_x) / tilesize)
			local ypos_tiled_fortilebar = 1 + math.floor((ypos - editor.innerheight - editor.tilebaroffset_y) / tilesize)
			
			if editor.pages[editor.currentpage][ypos_tiled_fortilebar] ~= nil then
				if editor.pages[editor.currentpage][ypos_tiled_fortilebar][xpos_tiled_fortilebar] ~= nil then
					local symbol = editor.pages[editor.currentpage][ypos_tiled_fortilebar][xpos_tiled_fortilebar]
					editor.tooltip = editor.getSymbolTooltip(levelsymbols[symbol])
					if love.mouse.isDown(1) then editor.lmbtile = symbol end
					if love.mouse.isDown(2) then editor.rmbtile = symbol end
					if love.mouse.isDown(3) then editor.mmbtile = symbol end
				end
			end
		else
			local xpos_tiled_fortagbar = 1 + math.floor((xpos - editor.tagbaroffset_x) / 12)
			local ypos_tiled_fortagbar = 1 + math.floor((ypos - editor.innerheight - editor.tagbaroffset_y) / 12)
			
			if editor.tags_pages[editor.currenttagspage][ypos_tiled_fortagbar] ~= nil then
				if editor.tags_pages[editor.currenttagspage][ypos_tiled_fortagbar][xpos_tiled_fortagbar] ~= nil then
					local tag = editor.tags_pages[editor.currenttagspage][ypos_tiled_fortagbar][xpos_tiled_fortagbar]
					editor.tooltip = tags[tag].tooltip
					if love.mouse.isDown(1) then editor.currenttag = tag end
				end
			end
		end
	end
	for i=1, #editor.buttons do
		local button = editor.buttons[i]
		if button.onUpdate then
			button:onUpdate()
		end
		if xpos >= (button.x) and xpos < (button.x + button.width) and
		   ypos >= (button.y) and ypos < (button.y + button.height) then
			editor.hoveredelement = button
			editor.tooltip = button.tooltip
		end
	end
	for i,v in ipairs(editor.sleekbuttons) do
		v.hovered = false
		if xpos >= (v.x) and xpos < (v.x + v.width) and
		   ypos >= (v.y) and ypos < (v.y + v.height) then
			v.hovered = true
			editor.tooltip = v.tooltip
		end
	end
	--there are't any textfields anymore lol (except in ih8ui boxes)
	for i=1, #editor.textfields do
		local field = editor.textfields[i]
		if xpos >= (field.x) and xpos < (field.x + field.width) and
		   ypos >= (field.y) and ypos < (field.y + field.height) then
			editor.tooltip = field.tooltip
		end
	end
	local roommap = editor.roommap
	if xpos >= (roommap.x) and xpos <= (roommap.x + roommap.width) and
	   ypos >= (roommap.y) and ypos <= (roommap.y + roommap.height) then
		editor.tooltip = roommap.tooltip
	end
end

function editor.keypressed(key, scancode)
	if editor.woahthere then
		if key == "return" then
			editor.woahthere = false
			statemachine.setstate("menu")
		else
			editor.woahthere = false
			if key == "escape" then return end
		end
	end
	if key == "f6" then love.system.openURL("file://"..love.filesystem.getSaveDirectory()); print("opening save directory"); end
	if key == "escape" then
		if editor.typing then
			editor.stopTyping()
		else
			if editor.unsavedroomsamt > 0 then
				editor.woahthere = true
			else
				statemachine.setstate("menu")
			end
		end
	end
	if editor.focusedfield == nil then
		if (love.keyboard.isDown("lctrl") or love.keyboard.isDown("rctrl")) then
			if (not (love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift"))) and key == "s" then
				editor.saveRoom(editor.roomX, editor.roomY)
			elseif (love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift")) and key == "s" then
				if next(editor.unsavedrooms) or next(editor.deleterooms) or (editor.unsaved or editor.deletethis) then print("mass save")
				else print("nothing to save/delete") end
				for y,v in pairs(editor.unsavedrooms) do
					for x,v2 in pairs(v) do
						editor.saveRoom(x, y)
					end
				end
				for y,v in pairs(editor.deleterooms) do
					for x,v2 in pairs(v) do
						editor.saveRoom(x, y)
					end
				end
				if editor.unsaved or editor.deletethis then
					editor.saveRoom(editor.roomX, editor.roomY)
				end
			--[[
			elseif (love.keyboard.isDown("lctrl") or love.keyboard.isDown("rctrl")) and key == "l" then
				local currentlevelset = editor.currentlevelset
				if currentlevelset == "" or not currentlevelset then currentlevelset = "ZZZorphanedlevels" end
				local fulllevelpath = "ext_levelsets/" .. currentlevelset .. "/levels/" .. editor.currentlevel .. ".txt"
				if love.filesystem.getInfo(fulllevelpath) == nil then print("mate you're not loading shit: " .. fulllevelpath .. " is invalid")
				else
					--editor.level.comments, editor.level.symbolmaps, editor.level.exits, editor.level.music, editor.level.options, editor.level.background, editor.level.hints = editor.loadLevel(love.filesystem.read(fulllevelpath))
					editor.loadLevel(fulllevelpath)
					print("loaded level " .. fulllevelpath .. "!")
				end
			]]
			elseif key == "c" then
				editor.clipboardCopy()
			elseif key == "x" then
				editor.clipboardCopy()
				editor.markDelete()
			elseif key == "v" then
				editor.clipboardPaste()
			elseif key == "r" then
				print("reloading room")
				if editor.unsaved then
					editor.removeunsavedroom(editor.roomX, editor.roomY)
					if not love.filesystem.getInfo("ext_levelsets/" .. editor.currentlevelset .. "/levels/" ..editor.currentlevel .. ".txt") then
						local y = editor.roomY
						local x = editor.roomX
						editor.extantrooms[y][x] = nil
						if not next(editor.extantrooms[y]) then editor.extantrooms[y] = nil end
					end
				end
				if editor.deletethis then
					editor.deletethis = false
					editor.deleterooms[editor.roomY][editor.roomX] = nil
					if not next(editor.deleterooms[editor.roomY]) then editor.deleterooms[editor.roomY] = nil end
					editor.deleteroomsamt = editor.deleteroomsamt - 1
				end
				editor.gotoRoom(editor.roomX, editor.roomY)
			elseif key == "delete" then
				editor.markDelete()
			elseif key == "z" then
				if editor.deletethis then
					editor.deletethis = false
					editor.deleterooms[editor.roomY][editor.roomX] = nil
					if not next(editor.deleterooms[editor.roomY]) then editor.deleterooms[editor.roomY] = nil end
					editor.deleteroomsamt = editor.deleteroomsamt - 1
				end
			elseif key == "o" then
				print("opening current level")
				love.system.openURL("file://"..love.filesystem.getSaveDirectory().. "/ext_levelsets/" .. editor.currentlevelset .. "/levels/" ..editor.currentlevel .. ".txt")
			elseif key == "f" then
				print("opening level folder")
				love.system.openURL("file://"..love.filesystem.getSaveDirectory().. "/ext_levelsets/" .. editor.currentlevelset)
			elseif key == "u" then
				local found = false
				for y,_ in pairs(editor.unsavedrooms) do
					for x,_ in pairs(editor.unsavedrooms[y]) do
						if x ~= editor.roomX or y ~= editor.roomY then
							print(x, editor.roomX, y, editor.roomY)
							editor.gotoRoom(x, y)
							found = true
							break
						end
					end
					if found then break end
				end
				if not found then print("no unsaved rooms") end
			elseif key == "d" then
				for y,_ in pairs(editor.deleterooms) do
					for x,_ in pairs(editor.deleterooms[y]) do
						if x ~= editor.roomX or y ~= editor.roomY then
							print(x, editor.roomX, y, editor.roomY)
							editor.gotoRoom(x, y)
							found = true
							break
						end
					end
					if found then break end
				end
				if not found then print("no marked-to-delete rooms") end
			elseif (not (love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift"))) and key == "p" then
				ih8ui.showBox(boxes.levelproperties)
			elseif (love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift")) and key == "p" then
				ih8ui.showBox(boxes.levelsetproperties)
			end
		elseif editor.typing then
			if key == "backspace" then
				local fromnewline = false
				editor.typingX = editor.typingX - 1
				if editor.typingX < editor.typing_origX then
					if editor.typingY == editor.typing_origY or editor.typingY == 1 then
						editor.stopTyping()
						return
					end
					editor.typingY = editor.typingY - 1
					local lastnewline = editor.newlines[editor.typingY]
					if not lastnewline then
						editor.typingX = #editor.symbolmap[1]
					else
						editor.typingX = lastnewline
						editor.newlines[editor.typingY] = nil
						fromnewline = true
					end
				end
				local x = editor.typingX
				local y = editor.typingY
				if not fromnewline then
					local oldtile = editor.symbolmap[y][x]
					if oldtile ~= "  " then
						editor.makeunsaved()
						editor.symbolmap[y][x] = "  "
						editor.checkemptymap()
						editor.removeWrongTags(x, y)
					end
				end
			elseif key == "return" then
				if editor.typingY <= #editor.symbolmap then
					editor.addNewline(editor.typingX, editor.typingY)
					editor.typingX = editor.typing_origX
					editor.typingY = editor.typingY + 1
				end
			end
		elseif key == "tab" then --test level
			game.editormode = true
			editor.level.roomX = editor.roomX
			editor.level.roomY = editor.roomY
			editor.level:gamify(editor.entrance or 0) --0 refers to entrance number
			editor.transitioningtogame = true
			game.levelpaths = nil
			game.templatelevels[1] = editor.level
			game.activelevels[1] = editor.level
			if editor.playingamemusic and editor.level.music ~= audio.activesong then
				if editor.level.music and editor.level.music ~= "" and editor.level.music ~= " " then
					print("from editor: playing " .. editor.level.music .. "!")
					audio.playsong(editor.level.music)
				else
					audio.playsong("none")
				end
			end
			statemachine.setstate("game")
		elseif key == "," then
			editor.trySymbolRotate("back")
		elseif key == "." then
			editor.trySymbolRotate("forward")
		elseif editor.toolbindings[key] ~= nil then
			editor.currenttool = editor.toolbindings[key]
		elseif tonumber(key) ~= nil or string.sub(key, 1, 2) == "kp" then
			local numberkey = tonumber(key)
			if not numberkey then numberkey = tonumber(string.sub(key, 3)) end
			if numberkey and (numberkey > 0 and numberkey < 10) then
				editor.currentsymbolmap = numberkey
			end
		elseif key == "d" then
			editor.debugprint = true
		--mixing scancode and key is a bad idea if a keyboard has one of the above keys mapped to the ` position for some reason (tab? idk)
		elseif scancode == "`" then
			statemachine.setstate("symboldisplay")
		elseif key == "m" then
			editor.showbigroommap = not editor.showbigroommap
		end
	else
		if key == "backspace" then
			local field = editor.focusedfield
			editor[field.textsource] = string.sub(editor[field.textsource], 1, -2)
		end
	end
end

function editor.mousepressed(x, y, button)
	editor.woahthere = false
	local wastyping = (not not editor.typing) --overly cautious?
	if wastyping then
		editor.stopTyping()
	end
	if editor.originalmousepress == nil then editor.originalmousepress = {["x"] = x, ["y"] = y} end
	if editor.focusedfield ~= nil then editor.focusedfield.focus = false end
	editor.focusedfield = nil
	love.keyboard.setKeyRepeat(false)
	if x > editor.innerwidth or y > editor.innerheight then
		if button == 1 then
			for i=1, #editor.textfields do
				local field = editor.textfields[i]
				if x >= (field.x) and x <= (field.x + field.width) and
				   y >= (field.y) and y <= (field.y + field.height) then
					editor.focusedfield = field
					field.focus = true
					love.keyboard.setKeyRepeat(true)
					break
				end
			end
			for i=1, #editor.buttons do
				local button = editor.buttons[i]
				if x >= (button.x) and x <= (button.x + button.width) and
				   y >= (button.y) and y <= (button.y + button.height) then
					button:action()
					break
				end
			end
		end
	elseif x < editor.innerwidth and y < editor.innerheight and button == 1 and not (editor.deletethis or editor.returnfromshowbox) then --the innerwidth/innerheight part should be <=, but it's not. weird. could have to do with potentially indexing out-of-bounds?
		if editor.currenttool == "text" and not wastyping then
			local xpos, ypos = love.mouse.getPosition()
			local xpos_tiled = 1 + math.floor(xpos / tilesize) + editor.mapview_x
			local ypos_tiled = 1 + math.floor(ypos / tilesize) + editor.mapview_y
			if editor.symbolmap[ypos_tiled] and editor.symbolmap[ypos_tiled][xpos_tiled] then
				editor.typing = true
				love.keyboard.setKeyRepeat(true)
				editor.typingX = xpos_tiled
				editor.typing_origX = xpos_tiled
				editor.typingY = ypos_tiled
				editor.typing_origY = ypos_tiled
			end
		end
	end
	if editor.focusedfield == nil then
		editor.lastmbtouched = button
	end
	local roommap = editor.roommap
	if editor.showbigroommap then roommap = editor.bigroommap end
	if x >= (roommap.x) and x <= (roommap.x + roommap.width) and
	   y >= (roommap.y) and y <= (roommap.y + roommap.height) then
		roommap:mousepressed(x - roommap.x, y - roommap.y)
	end
	if button == 1 then
		for i,v in ipairs(editor.sleekbuttons) do
			if x >= (v.x) and x < (v.x + v.width) and
			y >= (v.y) and y < (v.y + v.height) then
				v.action()
			end
		end
	end
end

function editor.mousereleased(x, y, button)
	if editor.returnfromshowbox then
		editor.originalmousepress = nil
		editor.returnfromshowbox = false
		return
	end
	if x < editor.innerwidth and y < editor.innerheight then
		if editor.eyedropperused and editor.currenttool == "eyedropper" and not love.mouse.isDown(1, 2, 3) then
			editor.currenttool = "pencil"
		end
	end
	if not love.mouse.isDown(1, 2, 3) then
		if not (editor.deletethis or editor.showbigroommap or editor.returnfromshowbox) then --can't edit levels pending deletion because that's a bit silly
			if(editor.currenttool == "rectangle" or editor.currenttool == "fillrectangle") and editor.originalmousepress then
				local tileplaced = false
				local mousex, mousey = love.mouse.getPosition()
				local mousex_tiled = 1 + math.floor(mousex / tilesize) + editor.mapview_x
				local origmousex_tiled = 1 + math.floor(editor.originalmousepress.x / tilesize) + editor.mapview_x
				local mousey_tiled = 1 + math.floor(mousey / tilesize) + editor.mapview_y
				local origmousey_tiled = 1 + math.floor(editor.originalmousepress.y / tilesize) + editor.mapview_y
				local tile = nil
				if button == 1 then tile = editor.lmbtile
				elseif button == 2 then tile = editor.rmbtile
				elseif button == 3 then tile = editor.mmbtile
				else tile = editor.lmbtile end
				for y_tiled=1, #editor.symbolmap do
					for x_tiled=1, #editor.symbolmap[y_tiled] do
						local rectcondition = true
						if editor.currenttool == "rectangle" then rectcondition = (
							x_tiled == mousex_tiled or
							x_tiled == origmousex_tiled or
							y_tiled == mousey_tiled or
							y_tiled == origmousey_tiled
						); end
						
						if (rectcondition)
							and not
						((x_tiled < mousex_tiled and x_tiled < origmousex_tiled) or --mouse sex
							(x_tiled > mousex_tiled and x_tiled > origmousex_tiled) or
							(y_tiled < mousey_tiled and y_tiled < origmousey_tiled) or
							(y_tiled > mousey_tiled and y_tiled > origmousey_tiled))
						then
							if editor.symbolmap[y_tiled][x_tiled] ~= tile then tileplaced = true end
							editor.symbolmap[y_tiled][x_tiled] = tile
							if tile ~= "  " then editor.notempty()
							else editor.checkemptymap() end
						end
						editor.removeWrongTags(origmousex_tiled, origmousey_tiled, mousex_tiled, mousey_tiled)
					end
				end
				if tileplaced then editor.makeunsaved() end
			elseif editor.currenttool == "tagrectangle" and editor.originalmousepress then
				local mousex, mousey = love.mouse.getPosition()
				local mousex_tiled = 1 + math.floor(mousex / tilesize) + editor.mapview_x
				local origmousex_tiled = 1 + math.floor(editor.originalmousepress.x / tilesize) + editor.mapview_x
				local mousey_tiled = 1 + math.floor(mousey / tilesize) + editor.mapview_y
				local origmousey_tiled = 1 + math.floor(editor.originalmousepress.y / tilesize) + editor.mapview_y
				local tag = editor.currenttag
				if button == 2 then tag = false end
				for y_tiled=1, #editor.symbolmap do
					for x_tiled=1, #editor.symbolmap[y_tiled] do
						if not
						((x_tiled < mousex_tiled and x_tiled < origmousex_tiled) or --mouse sex
							(x_tiled > mousex_tiled and x_tiled > origmousex_tiled) or
							(y_tiled < mousey_tiled and y_tiled < origmousey_tiled) or
							(y_tiled > mousey_tiled and y_tiled > origmousey_tiled))
						then
							placetag(tag, x_tiled, y_tiled) --unsaved is handled by placetag itself
							--placetag however does not handle checking if the tags "match" the symbols they're being placed on (e.g. normal tag tool can't place a player tag on a non-player object, or any tag on ane mpty space). tagtangle effectively lets you bypass the normal filters and place tags directly, which is fitting given how tags are stored as rectangles in the level format
						end
					end
				end
			end
		end
		editor.eyedropperused = false
		editor.originalmousepress = nil
	end
end

function editor.textinput(t)
	if editor.focusedfield ~= nil and not editor.focusedfield.forbidden[t] then
		local field = editor.focusedfield
		editor[field.textsource] = editor[field.textsource] .. t
	elseif editor.typing then
		local tile = "\\" .. t
		if not levelsymbols[tile] then tile = "\\?" end
		if tile == "\\ " then tile = "  " end
		
		local x = editor.typingX
		local y = editor.typingY
		
		local oldtile = editor.symbolmap[y][x]
		if oldtile ~= tile then editor.makeunsaved() end
		editor.symbolmap[y][x] = tile
		if tile ~= "  " then editor.notempty()
		else editor.checkemptymap() end
		editor.removeWrongTags(x, y)
		
		editor.typingX = editor.typingX + 1
		if editor.typingX > #editor.symbolmap[1] then
			if editor.typingY <= #editor.symbolmap then
				editor.typingY = editor.typingY + 1
				editor.typingX = editor.typing_origX
			else editor.typingX = editor.typingX - 1 end
		end
	end
end

function editor.filedropped(file)
	editor.makeunsaved()
	file:open("r")
	editor.notempty(true)
	editor.loadLevel(file:read(), true)
	file:close()
	if not editor.level.name then editor.level.name = justfilename(file:getFilename()) end --"If the file object originated from the love.filedropped callback, the filename will be the full platform-dependent file path."
	love.window.requestAttention()
	print("loaded dropped-in level " .. file:getFilename() .. "!")
end

function editor.wheelmoved(x, y)
	--ignoring x so that things won't be nightmarish if you have one of those mouse wheels that actually can scroll in the x direction
	if y < 0 then
		editor.trySymbolRotate("back")
	elseif y > 0 then
		editor.trySymbolRotate("forward")
	end
end

function editor.drawSymbol(realsymbol, x, y, emptyiseraser, drawselectbox, layer, inlevel)
	if realsymbol == specialsymbols.tagextender then
		if (not layer) or layer == editor.currentsymbolmap then
			love.graphics.draw(graphics.load("marker"), x, y)
		end
	elseif emptyiseraser and realsymbol == "  " then
		love.graphics.draw(graphics.load("ui/eraser"), x, y)
	else
		symbol = realsymbol
		if type(symbol) == "string" then symbol = levelsymbols[realsymbol] end
		if symbol == nil then error("\"" .. tostring(realsymbol) .. "\" isn't a symbol") end
		for i=1, #symbol.tiles do
			--make this less typing to reference later
			local tilename = symbol.tiles[i]
			--now we're actually using the tile as a key for the "tiles" array from tiles.lua, there was actually a redundant for loop here that couldn't have iterated through anything that i caught by commentating this
			local tile = tiles[tilename]
			if not tiles[tilename] then error(tostring(tilename) .. " isn't a real tile") end
			if tile.color and not game.solid_colors_default[tile.color] then
				tile = (type(tile.alt) == "string" and tiles[tile.alt]) or tile.alt
			end
			for ii,graphic in ipairs(tile.graphics) do
				love.graphics.draw(graphic.reference, graphic.quad, x + graphic.ingameoffset[1], y + graphic.ingameoffset[2])
			end
		end
		
		for i=1, #symbol.objects do
			local objectname = symbol.objects[i]
			local options = {}
			local temp = split(objectname, "|")
			if #temp >  1 then
				objectname = temp[1]
				for i=2, #temp do
					temp[i] = split(temp[i], ":")
					options[temp[i][1]] = temp[i][2] or "yes"
				end
			end
			local object = objects[objectname]
			local graphictodraw = nil
			if object.editorimg ~= nil then --kind of deprecated, just use editordraw. this was during a period where i wasn't really aware i could just be deferring more responsibility than i was
				graphictodraw = object.editorimg(options, inlevel)
				love.graphics.draw(graphictodraw, x, y)
			elseif object.editordraw ~= nil then
				object.editordraw(x, y, options, inlevel)
			else
				graphictodraw = graphics.load(objectname)
				love.graphics.draw(graphictodraw, x, y)
			end
		end
	end
	if drawselectbox then
		local selectgraphics = {} --why?
		if realsymbol == editor.lmbtile then selectgraphics[#selectgraphics + 1] = "lmb" end
		if realsymbol == editor.rmbtile then selectgraphics[#selectgraphics + 1] = "rmb" end
		if realsymbol == editor.mmbtile then selectgraphics[#selectgraphics + 1] = "mmb" end
		for iii=1, #selectgraphics do love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads[selectgraphics[iii]], x, y) end
	end
end

function editor.drawTags(tagarray, x, y)
	local r, g, b, a = love.graphics.getColor()
	love.graphics.setColor(r, g, b, editor.tag_draw_alpha)
	local tags_img = graphics.load("ui/tags")
	for i, tag in ipairs(tagarray) do
		local i2 = i
		if i2 > 5 then i2 = 5 end
		local x2 = x + editor.tag_draw_x_offsets[i2]
		local y2 = y + editor.tag_draw_y_offsets[i2]
		love.graphics.draw(tags_img, tags[tag].quad, x2, y2)
	end
	love.graphics.setColor(r, g, b, a)
end

function editor.draw()
	local r, g, b, a = love.graphics.getColor()
	love.graphics.setColor(hextocolor(editor.level.background))
	love.graphics.rectangle("fill", 0, 0, editor.width, editor.height)
	love.graphics.setColor(0, 0, 0, 0.5)
	love.graphics.rectangle("fill", 0, 0, editor.width, editor.height)
	love.graphics.setColor(hextocolor(editor.level.background))
	love.graphics.rectangle("fill", editor.mapview_x * -1 * tilesize, editor.mapview_y * -1 * tilesize, editor.maptilewidth * tilesize, editor.maptileheight * tilesize)
	--conditional for not displaying cursor
	--if	editor.mapview_x + (x_tiled - 1) >= 0 and
	--		editor.mapview_x + (x_tiled - 1) <= editor.maptilewidth and
	--		editor.mapview_y + (y_tiled - 1) >= 0 and
	--		editor.mapview_y + (y_tiled - 1) <= editor.maptileheight
	--then
	love.graphics.setColor(r, g, b, a)
	
	--determine if a rectangle tool is being used, if so set up some local variables. we'll also check rectangling again later
	local mousex, mousey
	local mousex_tiled
	local origmousex_tiled
	local mousey_tiled
	local origmousey_tiled
	local tile
	local tag
	local tagtangle
	local tags_img
	local rectangling = not (editor.deletethis or ih8ui.showingbox or editor.returnfromshowbox) and love.mouse.isDown(1, 2, 3) and editor.originalmousepress and (editor.currenttool == "rectangle" or editor.currenttool == "fillrectangle" or editor.currenttool == "tagrectangle")
	if rectangling then
		mousex, mousey = love.mouse.getPosition()
		mousex_tiled = 1 + math.floor(mousex / tilesize)
		origmousex_tiled = 1 + math.floor(editor.originalmousepress.x / tilesize)
		mousey_tiled = 1 + math.floor(mousey / tilesize)
		origmousey_tiled = 1 + math.floor(editor.originalmousepress.y / tilesize)
		if love.mouse.isDown(1) then tile = editor.lmbtile
		elseif love.mouse.isDown(2) then tile = editor.rmbtile
		elseif love.mouse.isDown(3) then tile = editor.mmbtile
		else tile = editor.lmbtile end
		tag = editor.currenttag
		if love.mouse.isDown(2) then tag = false end
		tagtangle = (editor.currenttool == "tagrectangle")
		tags_img = graphics.load("ui/tags")
	end
	--rectangling variable setup done
	
	if not editor.showbigroommap then
		local symbolmapstodraw
		if editor.viewallsymbolmaps then symbolmapstodraw = editor.level.symbolmaps
		else symbolmapstodraw = {editor.symbolmap} end
		for i, symbolmap in ipairs(symbolmapstodraw) do
			local onscreeny_tiled = 0
			for y_tiled = editor.mapview_y + 1, editor.mapview_y + editor.mapview_height do
				onscreeny_tiled = onscreeny_tiled + 1
				local onscreenx_tiled = 0
				--for each entry of the row
				if symbolmap[y_tiled] then
					for x_tiled = editor.mapview_x + 1, editor.mapview_x + editor.mapview_width do
						onscreenx_tiled = onscreenx_tiled + 1
						if symbolmap[y_tiled][x_tiled] then
							editor.drawSymbol(symbolmap[y_tiled][x_tiled], (onscreenx_tiled - 1) * tilesize, (onscreeny_tiled - 1) * tilesize, nil, nil, i, true)
							--if this is the currently selected layer, also draw tags
							if (not editor.viewallsymbolmaps or i == editor.currentsymbolmap) and editor.tagmap and editor.tagmap[y_tiled] and editor.tagmap[y_tiled][x_tiled] then
								editor.drawTags(editor.tagmap[y_tiled][x_tiled], (onscreenx_tiled - 1) * tilesize, (onscreeny_tiled - 1) * tilesize)
							end
							if rectangling then
								local rectcondition = true
								if editor.currenttool == "rectangle" then rectcondition = (
									x_tiled == mousex_tiled or
									x_tiled == origmousex_tiled or
									y_tiled == mousey_tiled or
									y_tiled == origmousey_tiled
								); end
								if (rectcondition)
									and not
								((x_tiled < mousex_tiled and x_tiled < origmousex_tiled) or
									(x_tiled > mousex_tiled and x_tiled > origmousex_tiled) or
									(y_tiled < mousey_tiled and y_tiled < origmousey_tiled) or
									(y_tiled > mousey_tiled and y_tiled > origmousey_tiled))
								then
									--for some reason rectangle is drawn in the middle of drawing all the rest of the tiles, which seems like it saves on iteration or something, except now we're calling love.graphics.setColor a LOT which results in cpu use spiking. for tagtangles this can make the fps drop to 14 on my machine
									if not tagtangle then love.graphics.setColor(1, 1, 0, 0.5) end
									if tagtangle or tile == "  " then
										love.graphics.setColor(1, 1, 0, 0.1)
										love.graphics.rectangle("fill", (x_tiled - 1) * tilesize, (y_tiled - 1) * tilesize, tilesize, tilesize)
									else
										editor.drawSymbol(tile, (x_tiled - 1) * tilesize, (y_tiled - 1) * tilesize)
									end
									love.graphics.setColor(r, g, b, a)
									if tagtangle and tag then
										love.graphics.draw(tags_img, tags[tag].quad, ((x_tiled - 1) * tilesize) + 4, ((y_tiled - 1) * tilesize) + 4)
									end
								end
							end
						end
					end
				end
			end
		end
	end
	editor.debugprint = false
	if not (editor.deletethis or editor.showbigroommap or editor.typing or editor.returnfromshowbox) then
		if (editor.currenttool == "rectangle" or editor.currenttool == "fillrectangle" or editor.currenttool == "tagrectangle") and editor.originalmousepress and editor.originalmousepress.x < editor.innerwidth and editor.originalmousepress.y < editor.innerheight then
			--the below two variables will be identical to origmousex_tiled and origmousey_tiled in the above scope, just done through a different method that came to mind first for some reason
			local origxpos_modulo = math.floor(editor.originalmousepress.x) - (math.floor(editor.originalmousepress.x) % tilesize)
			local origypos_modulo = math.floor(editor.originalmousepress.y) - (math.floor(editor.originalmousepress.y) % tilesize)
			if love.mouse.isDown(1) then love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["lmb_orig"], origxpos_modulo, origypos_modulo) end
			if love.mouse.isDown(2) then love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["rmb_orig"], origxpos_modulo, origypos_modulo) end
			if love.mouse.isDown(3) then love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["mmb_orig"], origxpos_modulo, origypos_modulo) end
		end
		local xpos, ypos = love.mouse.getPosition()
		if ypos < editor.innerheight and xpos < editor.innerwidth then
			local xpos_modulo = math.floor(xpos) - (math.floor(xpos) % tilesize)
			local ypos_modulo = math.floor(ypos) - (math.floor(ypos) % tilesize)
			--if	editor.currenttool ~= "rectangle" and editor.currenttool ~= "fillrectangle" and --why?
			if
				editor.mapview_x + (xpos_modulo / tilesize) >= 0 and
				editor.mapview_x + (xpos_modulo / tilesize) < editor.maptilewidth and
				editor.mapview_y + (ypos_modulo / tilesize) >= 0 and
				editor.mapview_y + (ypos_modulo / tilesize) < editor.maptileheight
			then
				if not love.mouse.isDown(1, 2, 3) then
					love.graphics.setColor(r, g, b, editor.inactiveselectionalpha)
					local q = "any"
					if editor.currenttool == "text" then q = "text_pre" end
					love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads[q], xpos_modulo, ypos_modulo)
				else
					--this whole block is actually equivalent to the selectgraphics stuff below (which i'm not sure why i bothered with) that occur with drawing selection graphics on items in the tilebar, but with different conditions/positioning
					if love.mouse.isDown(1) then love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["lmb"], xpos_modulo, ypos_modulo) end
					if love.mouse.isDown(2) then love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["rmb"], xpos_modulo, ypos_modulo) end
					if love.mouse.isDown(3) then love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["mmb"], xpos_modulo, ypos_modulo) end
				end
			end
		end
	end
	
	if editor.typing then
		local x = ((editor.typingX - 1) + editor.mapview_x) * tilesize
		local orig_x = ((editor.typing_origX - 1) + editor.mapview_x) * tilesize --have you noticed the underscoring isn't remotely consistent?
		local y = ((editor.typingY - 1) + editor.mapview_y) * tilesize
		local orig_y = ((editor.typing_origY - 1) + editor.mapview_y) * tilesize
		love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["text_orig"], orig_x, orig_y)
		love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["text"], x, y)
		for y_tiled = editor.mapview_y + 1, editor.mapview_y + editor.mapview_height do
			if editor.newlines[y_tiled] then
				local y = y_tiled
				y = ((y - 1) + editor.mapview_y) * tilesize
				local x = editor.newlines[y_tiled]
				x = ((x - 1) + editor.mapview_x) * tilesize
				love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["newline"], x, y)
			end
		end
	end
	
	if editor.deletethis then
		love.graphics.setColor(1, 0, 0, 0.5)
		love.graphics.rectangle("fill", 0, 0, editor.innerwidth, editor.innerheight)
		love.graphics.setColor(r, g, b, a)
		love.graphics.print([[
you're deleting this room.

saving this room (by pressing ctrl+s here or pressing ctrl+shift+s
to save all unsaved/marked rooms) will cause it to be deleted.

press ctrl+z to unmark this room if you don't want it to be deleted.
pressing ctrl+z AFTER deleting the room will do nothing!]], editor.bigfont, 16, 16)
	end
	
	love.graphics.setColor(0.2, 0.2, 0.2)
	love.graphics.rectangle("fill", 0, editor.innerheight, editor.width, editor.innerheight)
	love.graphics.rectangle("fill", editor.innerwidth, 0, editor.addedwidth, editor.innerheight)
	love.graphics.setColor(r, g, b, a)
	for i=1, #editor.pages[editor.currentpage] do
		for ii=1, #editor.pages[editor.currentpage][i] do
			local symbol = editor.pages[editor.currentpage][i][ii]
			if symbol == "  " then
				love.graphics.draw(graphics.load("ui/eraser"), ((ii - 1) * tilesize) + editor.tilebaroffset_x, ((i - 1) * tilesize) + editor.tilebaroffset_y + editor.innerheight)
			else
				editor.drawSymbol(symbol, ((ii - 1) * tilesize) + editor.tilebaroffset_x, ((i - 1) * tilesize) + editor.tilebaroffset_y + editor.innerheight)
			end
			local selectgraphics = {}
			if symbol == editor.lmbtile then selectgraphics[#selectgraphics + 1] = "lmb" end
			if symbol == editor.rmbtile then selectgraphics[#selectgraphics + 1] = "rmb" end
			if symbol == editor.mmbtile then selectgraphics[#selectgraphics + 1] = "mmb" end
			for iii=1, #selectgraphics do love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads[selectgraphics[iii]], ((ii - 1) * tilesize) + editor.tilebaroffset_x, ((i - 1) * tilesize) + editor.tilebaroffset_y + editor.innerheight) end
		end
	end
	editor.drawSymbol(editor.lmbtile, 8, editor.height - (8 + (tilesize * 3)), true)
	love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["lmb_btm"], 8, (editor.height - (8 + (tilesize * 3))) + 8)
	editor.drawSymbol(editor.mmbtile, 8, editor.height - (8 + (tilesize * 2)), true)
	love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["mmb_btm"], 8, (editor.height - (8 + (tilesize * 2))) + 8)
	editor.drawSymbol(editor.rmbtile, 8, editor.height - (8 + (tilesize * 1)), true)
	love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["rmb_btm"], 8, (editor.height - (8 + (tilesize * 1))) + 8)
	love.graphics.setColor(0.1, 0.1, 0.1, 1)
	love.graphics.rectangle("fill", editor.tagbaroffset_x, editor.tagbaroffset_y + editor.innerheight, #editor.tags_pages[editor.currentpage][1] * 12, #editor.tags_pages[editor.currentpage] * 12)
	love.graphics.setColor(r, g, b, a)
	for i=1, #editor.tags_pages[editor.currenttagspage] do
		for ii=1, #editor.tags_pages[editor.currenttagspage][i] do
			local tag = editor.tags_pages[editor.currentpage][i][ii]
			local x = ((ii - 1) * 12) + editor.tagbaroffset_x
			local y = ((i - 1) * 12) + editor.tagbaroffset_y + editor.innerheight
			love.graphics.draw(graphics.load("ui/tags"), tags[tag].quad, x + 2, y + 2)
			if tag == editor.currenttag then
				love.graphics.draw(graphics.load("ui/selections"), editor.selectionquads["tag"], x, y)
			end
		end
	end
	if editor.currenttool == "tags" or editor.currenttool == "tagrectangle" then
		love.graphics.setColor(0.5, 0.5, 0.5)
		love.graphics.print(", and . to cycle", 250, 528)
		love.graphics.setColor(r,g,b,a)
	end
	--draw explanatory text next to music button
	love.graphics.print("play\ningame\nmusic?", 648, 252)
	local musicstr = "no"
	if editor.playingamemusic then musicstr = "yes" end
	love.graphics.print(musicstr, 672, 296)
	
	for i=1, #editor.textfields do
		editor.textfields[i]:draw()
	end
	for i=1, #editor.buttons do
		editor.buttons[i]:draw()
	end
	if editor.showbigroommap then
		editor.bigroommap:draw()
	else
		editor.roommap:draw()
	end
	
	for i,v in ipairs(editor.sleekbuttons) do
		if v.hovered then
			love.graphics.setColor(0.666, 0.666, 0.666, 1)
		else
			love.graphics.setColor(0.5, 0.5, 0.5, 1)
		end
		love.graphics.rectangle("fill", v.x, v.y, v.width, v.height)
		love.graphics.setColor(r, g, b, a)
		love.graphics.draw(v.text, v.x, v.y)
	end
	
	love.graphics.setColor(0.2, 0.2, 0.2, 0.5)
	if editor.currenttool == "tags" or editor.currenttool == "tagrectangle" then
		love.graphics.rectangle("fill", 0, editor.innerheight, 224, 64)
	else
		love.graphics.rectangle("fill", 240, editor.innerheight, 118, 64)
	end
	
	--love.graphics.setColor(1, 1, 1, 0.5)
	--love.graphics.print("(press f1 for help)", 516, editor.height - 54)
	--love.graphics.print("(press ` for elements)", 508, editor.height - 34)
	
	love.graphics.setColor(r, g, b, a)
	if editor.tooltip ~= nil then
		printAsTooltip(editor.tooltip, editor.tooltipScale)
	end
	printWithOutline(editor.roomX, 0)
	printWithOutline(editor.roomY, 32)
	
	local clipboardstring = "clipboard:\n"
	local clipboard = editor.clipboard
	local coords = tostring(clipboard.x) .. "," .. tostring(clipboard.y)
	if clipboard.empty then
		clipboardstring = clipboardstring .. "(empty)"
	elseif clipboard.object then
		clipboardstring = clipboardstring .. "stored"
	elseif clipboard.levelset ~= editor.currentlevelset then
		clipboardstring = clipboardstring .. "outside"
	else
		clipboardstring = clipboardstring .. coords
	end
	love.graphics.print(clipboardstring, editor.width - 60, editor.height - 202)
	local unsavedamt = editor.unsavedroomsamt
	local deleteamt = editor.deleteroomsamt
	--if editor.unsaved and not (editor.unsavedrooms[editor.roomY] and editor.unsavedrooms[editor.roomY][editor.roomX]) then unsavedamt = unsavedamt + 1 end
	--love.graphics.print("unsaved rooms: " .. tostring(unsavedamt), 448, editor.height - 14)
	love.graphics.print("unsaved\nrooms: " .. tostring(unsavedamt), editor.width - 60, editor.height - 142)
	love.graphics.print("deleting\nrooms: " .. tostring(deleteamt), editor.width - 60, editor.height - 102)
	
	if editor.woahthere then
		love.graphics.setColor(0.25, 0.25, 0.25, 0.75)
		love.graphics.rectangle("fill", 0, 0, editor.width, editor.height)
		love.graphics.setColor(r, g, b, a)
		love.graphics.print("you have " .. unsavedamt .. " unsaved rooms, really quit?", titlefont, (16 * 3), (16 * 3))
		-- you have 9 unsaved rooms, really quit?
		love.graphics.print("press enter to REALLY QUIT, discarding your unsaved rooms.", (16 * 3), (16 * 5))
		love.graphics.print("press anything else to cancel.", (16 * 3), (16 * 6))
		--"press enter to REALLY QUIT, discarding your unsaved rooms."
		--"press anything else to cancel."
	end
end

function editor.stop(newstate)
	editor.originalmousepress = nil
	if (not editor.transitioningtogame) and (newstate ~= "symboldisplay") then
		game.editormode = false
		local clipboard = editor.clipboard
		if (not clipboard.empty) and (not clipboard.object) then
			if (clipboard.x == editor.roomX and clipboard.y == editor.roomY and editor.unsaved) or
				(editor.unsavedrooms[clipboard.y] and editor.unsavedrooms[clipboard.y][clipboard.x])
			then
				clipboard.object = editor.level:clone("ctrlc")
			end
		end
		resizeWindow(menu.width, menu.height, {minwidth = 128, minheight = 128}, false, true)
	end
	editor.transitioningtogame = false
	editor.stopTyping()
	love.keyboard.setKeyRepeat(false)
end