os["execute"] = nil
io["popen"] = nil

print("one over zero")
print(1/0)

require "errhand"
require "COMMON OVERRIDES"
require "preloader"

--print("tonumber date 12/23/22 20:47:02:")
--print(tonumber("12/23/22 20:47:02"))

--print("tonumber nil:")
--print(tonumber(nil))

--for i=1, 0 do
--	print("evil print!")
--end

--local blah = "blah"
--print(blah.blah)

--do
--	local failgraphic = love.graphics.newImage("credits.txt")
--	print(failgraphic)
--end

require "split"
require "correctnewlines"
require "sortedstringfields"

function isInSource(path) --to distinguish whether an item return by getDirectoryItems is part of the game source or not. this exists because i was imagining some script kiddie going "Hey guys! I found out how to add new objects to Jumper 4 Real! You just create a folder called "objection" in the save directory and then u put lua files in there and it will run them! Here's my first Jumper 4 Real mod :3" and then it deletes everything off your hard drive or something
	return love.filesystem.getRealDirectory(path) ~= love.filesystem.getSaveDirectory()
end

function tommss(s) --this is for a cue file i was writing
	local mins = math.floor(s / 60)
	s = s - (mins * 60)
	mins = tostring(mins)
	if #mins < 2 then mins = "0" .. mins end
	s = tostring(s)
	if #s < 2 then s = "0" .. s end
	print(mins .. ":" .. s)
end

function tommss_bulk(t)
	for i,v in ipairs(t) do
		tommss(v)
	end
end

function set(...)
	local newtable = {}
	for k,v in pairs({...}) do
		newtable[v] = true
	end
	return newtable
end

require "consts"
require "j4rdebug"

accumulator = 0 --outside the love.run loop in case we want to look at this
updatesdone = 0 --same
fpscap = 60
do
	local _, _, flags = love.window.getMode()
	_G.idkrunsfineforme = (flags.refreshrate == fpscap and flags.vsync == 1) --lol
	idkrunsfineforme_default = idkrunsfineforme
	if idkrunsfineforme then print("\"idk, it runs fine on my " .. fpscap .. "hz monitor w/ vsync enabled\"") end
end
discardable_discrepancy = 0.005
scaled_discardable_discrepancy = discardable_discrepancy * fpscap --0.3
skippedupdates = 0
doubleupdates = 0
bulkupdates = 0

function love.run()
	if love.load then love.load(love.arg.parseGameArguments(arg), arg) end

	-- We don't want the first frame's dt to include time taken by love.load.
	if love.timer then love.timer.step() end

	local dt = 0

	-- Main loop time.
	return function()
		-- Process events.
		--where should this fit into the below time kludge (e.g. handles keypresses and mousewheel movements)? does it just stay outside?
		if love.event then
			love.event.pump()
			for name, a,b,c,d,e,f in love.event.poll() do
				if name == "quit" then
					if not love.quit or not love.quit() then
						return a or 0
					end
				end
				love.handlers[name](a,b,c,d,e,f)
			end
		end

		-- Update dt, as we'll be passing it to update --no we won't
		if love.timer then dt = love.timer.step() end
		-- Call update and draw
		if idkrunsfineforme and not settings.lagmakeup then
			love.update(dt); updatesdone = 1; --ok we do pass dt to love.update but nothing uses it
			if cheat.isactive("legacy144hz") then love.update(0); updatesdone = 2; end
		else
			updatesdone = 0
			local scaleddt = dt * fpscap --dt is multiplied by fpscap to make things easier and run into floating point issues less when subtracting the accumulator (since non-ideal delta times with small enough difference from 1 are set to 1)
			--print(dt)
			
			if math.abs(scaleddt - 1) < scaled_discardable_discrepancy then scaleddt = 1 end
			
			accumulator = accumulator + scaleddt
			
			if idkrunsfineforme and accumulator < 1 then accumulator = 1 end
			while accumulator >= 1 do
				if accumulator > 30 then accumulator = 30 end --avoid lag spiral
				love.update(dt)
				updatesdone = updatesdone + 1
				if cheat.isactive("legacy144hz") then
					love.update(0) --using 0 could cause really dumb issues but this is a really dumb cheat (and, again, nothing in-game relies on dt so far)
					updatesdone = updatesdone + 1
				end
				accumulator = accumulator - 1
				if not settings.lagmakeup then break end
			end
			
			if updatesdone == 0 then skippedupdates = skippedupdates + 1
			elseif updatesdone == 2 then doubleupdates = doubleupdates + 1
			elseif updatesdone > 2 then bulkupdates = bulkupdates + 1 end
			
			while accumulator >= 1 do accumulator = accumulator - 1 end
			--]]
		end
		if love.graphics and love.graphics.isActive() then
			love.graphics.origin()
			love.graphics.clear(love.graphics.getBackgroundColor())

			if love.draw then love.draw() end

			love.graphics.present()
		end

		if love.timer then love.timer.sleep(0.001) end
	end
end

--print(love)
--^for some reason it immensely fascinated me that everything love-related was in a table. "WOW... IT'S TABLES ALL THE WAY DOWN!"
version = "0.7.1"
local lastversion = love.filesystem.read("version.txt")
if lastversion ~= version then
	love.filesystem.write("version.txt", version); print("updating version file");
	love.filesystem.write("Jumper 4 Real.chm", love.filesystem.read("Jumper 4 Real.chm")); print("updating help file");  --t.appendidentity
	love.filesystem.remove("Jumper 4 Real.chw"); print("deleting old help index");
end
tilesize = 16
scale = 1
--scale does nothing if changed; changing tilesize changes what the size of tiles is treated as in some places but there's probably a lot of areas that just use 16
allowframeadvance = false
frameadvance = false
advancingframe = false

function donothing() end

titlefont = love.graphics.newFont(16)
smallfont = love.graphics.newFont(8)
smallishfont = love.graphics.newFont(9)

--print("boop bop mother fuckers")
--print(type(nil) == nil) this one exercise in pil got me, lol. type(nil) == "nil"

weakkey = {__mode = "k"}
weakvalue = {__mode = "v"}

function tern(expression, value1, value2) --more compact than declaring and running a function, and miles less ugly than (a and b or c), but doesn't short-circuit
--my opinion on a and b or c has changed. lol. though (a and b or c) still feels too implicit and i prefer ((a and b) or c)
	if expression then return value1 else return value2 end
end

function table.copy(src, dest, overwrite) --taken from the knytt stories mod "knytt stories ex" which might have taken this from elsewhere. does not recursively copy tables
	if type(src) ~= "table" then
		error("table.copy called with src as type " .. type(src), 2)
	end
	if not dest or overwrite then
		dest = dest or {}
		for k,v in pairs(src) do
			dest[k] = v
		end
	else
		for k,v in pairs(src) do
			if dest[k] == nil then
				dest[k] = v
			end
		end
	end
	return dest
end

function getfilenamefrompath(path)
	local arrayiguess
	arrayiguess = split(path, "/")
	if #arrayiguess == 1 then
	arrayiguess = split(path, "\\") end
	return arrayiguess[#arrayiguess]
end

function stripfileextension(filename)
	local arrayagain
	arrayagain = split(filename, "%.")
	if #arrayagain == 1 then return arrayagain[1] end
	arrayagain[#arrayagain] = nil
	return table.concat(arrayagain, ".")
end

function getfileextension(filename)
	local arrayagain
	arrayagain = split(filename, "%.")
	if #arrayagain == 1 then return "" end
	return arrayagain[#arrayagain]
end

function justfilename(str)
	return stripfileextension(getfilenamefrompath(str))
end

function quad(...)
	return love.graphics.newQuad(...)
end

function printWithOutline(str, x, y)
		x = x or 0
		y = y or 0
		local r, g, b, a = love.graphics.getColor()
		love.graphics.setColor(0, 0, 0, a)
		love.graphics.print(str, x - 1, y)
		love.graphics.print(str, x + 1, y)
		love.graphics.print(str, x, y - 1)
		love.graphics.print(str, x, y + 1)
		love.graphics.setColor(r, g, b, a)
		love.graphics.print(str, x, y)
end
function drawWithOutline(todraw, x, y) --like above but for text objects
		x = x or 0
		y = y or 0
		local r, g, b, a = love.graphics.getColor()
		love.graphics.setColor(0, 0, 0, a)
		love.graphics.draw(todraw, x - 1, y)
		love.graphics.draw(todraw, x + 1, y)
		love.graphics.draw(todraw, x, y - 1)
		love.graphics.draw(todraw, x, y + 1)
		love.graphics.setColor(r, g, b, a)
		love.graphics.draw(todraw, x, y)
end
function printAsTooltip(str, scale)
	assert(str, "printAsTooltip called without string supplied")
	love.graphics.printf(
		str,
		0,
		love.graphics.getHeight() - 16,
		(love.graphics.getWidth() / (scale or 0.75)),
		"center",
		0,
		scale or 0.75
	)
end

require "writer"

require "hex2color"
require "class"

require "audio"
require "graphics"

function rotationchain(domain, t)
	for i,v in ipairs(t) do
		local prev = i - 1
		if prev == 0 then prev = #t end
		local next = i + 1
		if next > #t then next = 1 end
		domain[v].rotations = {t[prev], t[next]}
	end
end

require "datums.levelsymbols"
require "datums.boxes"
require "datums.tags"
require "datums.tiles"

--[[do
	local teststring = "mycoolstringy"
	local splitby2 = nwidesplit(teststring, 2)
	for i, v in ipairs(splitby2) do
		print(i .. ": " .. v)
	end
	local splitby3 = nwidesplit(teststring, 3)
	for i, v in ipairs(splitby3) do
		print(i .. ": " .. v)
	end
end]]

--if levelsymbols["="] ~= nil then error("ERROR: equals sign (=) cannot be a level symbol") end

function booltostr(bool)
	if(bool) then return "true" else return "false" end
end

function strtobool(str)
	if str == "true" then return true
	elseif str == "false" then return false
	else return nil end
end


settings = {
	playaudio = true,
	playsfx = true,
	playmusic = true,
	choice = nil,
	seetheunseeable = false,
	quickdeaths = false,
	unfocuspause = false,
	unfocusmute = false,
	username = "OgmoFan100",
	lagmakeup = false,
	lazy60hz = true,
	notransit = false,
}
do
	--[=[
	local settingsfile = love.filesystem.read("settings.txt")
	if settingsfile ~= nil then
		settingsfile = correctnewlines(settingsfile) --probably unnecessary
		local ustemp = split(settingsfile, "\n")
		for i=1, #settingsargs do
			settings[settingsargs[i]] = strtobool(ustemp[i])
		end
	else
		--Randomize the Choice variable the very first time the player starts the game, which should lead to some interesting results and reinforce that there is no canonical Choice value!
	--	local choicerand = math.random()
		local choicerand = love.math.random(0, 1)
		if choicerand == 0 then choicerand = false
		else choicerand = true end
		settings.choice = choicerand
		writeto("settings")
	end
	]=]
	local settingsfile = love.filesystem.read("settings.txt") or ""
	if settingsfile == "" then
		--Randomize the Choice variable the very first time the player starts the game, which should lead to some interesting results and reinforce that there is no canonical Choice value!
		local choicerand = love.math.random(0, 1)
		settings.choice = (choicerand == 1)
		--randomish username
		settings.username = "OgmoFan" .. love.math.random(0, 9999)
		writeto("settings")
	end
	
	local phase = nil
	
	settingsfile = correctnewlines(settingsfile)
	settingsfile = split(settingsfile, "\n")
	for i, row in ipairs(settingsfile) do
		if string.sub(row, 1, 3) == "===" and string.sub(row, -3, -1) == "===" then
			phase = string.sub(row, 4, -4)
		else
			if string.find(row, "|") and phase ~= nil then
				local stuff = split(row, "|", 1)
				if stuff[1] == "nil" then stuff[2] = nil
				elseif stuff[1] == "number" then stuff[2] = assert(tonumber(stuff[2]), "you told me this thing in settings is a number but it's not")
				elseif stuff[1] == "boolean" then stuff[2] = strtobool(stuff[2])
				elseif stuff[1] ~= "string" then error("unsupported type in settings file, " .. stuff[1]) end
				settings[phase] = stuff[2]
			end
		end
	end
end
if idkrunsfineforme_default and not settings.lazy60hz then idkrunsfineforme = false end

controls = {}
defaultcontrols = {}

do
	local controlsfile = love.filesystem.read("controls.txt")
	local defaultcontrolsfile = love.filesystem.read("defaultcontrols.txt")
	if controlsfile == nil then
		controlsfile = defaultcontrolsfile
		love.filesystem.write("controls.txt",controlsfile)
	end
	
	local phase = nil
	
	controlsfile = correctnewlines(controlsfile)
	controlsfile = split(controlsfile, "\n")
	defaultcontrolsfile = correctnewlines(defaultcontrolsfile)
	defaultcontrolsfile = split(defaultcontrolsfile, "\n")
	for i, row in ipairs(controlsfile) do --We Enjoy Typing
		if string.sub(row, 1, 3) == "===" and string.sub(row, -3, -1) == "===" then
			phase = string.sub(row, 4, -4)
		else
			if string.sub(row, 1, 1) == "|" then row = string.sub(row, 2, -1) end
			if phase ~= nil then controls[phase] = row end
		end
	end
	for i, row in ipairs(defaultcontrolsfile) do
		if string.sub(row, 1, 3) == "===" and string.sub(row, -3, -1) == "===" then
			phase = string.sub(row, 4, -4)
		else
			if string.sub(row, 1, 1) == "|" then row = string.sub(row, 2, -1) end
			if phase ~= nil then defaultcontrols[phase] = row end
		end
	end
end

--safeidentifierchars = set("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z")

function prepcolorfromtags(thing)
	local changecolor = false
	local changeblend = false
	if not thing.tags then return changecolor, changeblend end
	local r,g,b,a = 1,1,1,1
	if thing.tags.lowalpha then
		a = 0.5
		changecolor = true
	end
	if thing.tags.silhouette then
		r,g,b = 0,0,0
		changecolor = true
	elseif (thing.tags.r or thing.tags.g or thing.tags.b) and not (thing.tags.r and thing.tags.g and thing.tags.b) then --If some color tags are present, but not all of them, change the draw color.
		r = (thing.tags.r and 1) or 0
		g = (thing.tags.g and 1) or 0
		b = (thing.tags.b and 1) or 0
		changecolor = true
	end
	if changecolor then
		love.graphics.setColor(r,g,b,a)
	end
	
	if thing.tags.additive then
		love.graphics.setBlendMode("add")
		changeblend = true
	end
	
	return changecolor, changeblend
end
objects = {}
require "game"
require "gemsave"
require "transit"
require "statusbar"
require "dingbats"
require "youwin"
require "datums.cheat"
require "level"
require "stageselect"

require "object"
require "mob"
objects["ogmo"] = require "objection.ogmo"
require "datums.ogmos"

require "textfield"
require "textline"
require "button"
require "roommap"
require "datums.menu_substates"
require "menu"
require "datums.editor_pages"
require "editor"
require "ih8ui"
require "symboldisplay"
require "statemachine"

require "mobtools"
require "datums.particles"

game.ogmoskin = love.filesystem.read("ogmoskin.txt") or "ogmo"
if not ogmos[game.ogmoskin] then game.ogmoskin = "ogmo" end
game.ogmosnapto = ogmos[game.ogmoskin].snapto or 1
game.ogmofakelag = ogmos[game.ogmoskin].fakelag or false
game.ogmohmombug = ogmos[game.ogmoskin].hmombug or false
_G["ogmo"].quads = ogmos[game.ogmoskin].quads

--math.randomseed(os.time())

facts = love.filesystem.read("datums/facts.txt")
facts = split(correctnewlines(facts), "\n")

function math.clamp(x, a, b) --help me i went down a rabbit hole of different methods of clamping. also this was originally for makecollisionmask to determine what range it should iterate in but i found it a lot easier to just don't impose restrictions on the for loops and don't do anything if getpixel returns nil
--i think the above comment is outdated now
  return math.max(a, math.min(b, x))
end

objectfiles = love.filesystem.getDirectoryItems("objection")
for i=1, #objectfiles do
	local s = objectfiles[i]
	if s ~= "ogmo.lua" and string.sub(s, #s - 3) == ".lua" and isInSource("objection/" .. s) then
		local object = require ("objection." .. string.sub(s, 1, #s - 4)) --May be bool for unused objects that start with "do return end".
		if type(object) == "table" then objects[string.sub(s, 1, #s - 4)] = object end
	end
end

function makecomplextile(tilename, x_tiled, y_tiled, i)
	local tile = table.copy(tiles[tilename])
	tile.istile = true
	tile.type = tilename
	tile.x = ((x_tiled - 1) * tilesize) + (tile.hitboxXoffset or 0)
	tile.y = ((y_tiled - 1) * tilesize) + (tile.hitboxYoffset or 0)
	tile.x_tiled = x_tiled
	tile.y_tiled = y_tiled
	tile.i = i
	tile.hmom = 0
	tile.vmom = 0
	tile.width = tile.hitboxwidth or tilesize
	tile.height = tile.hitboxheight or tilesize
	return tile
end

function makecollisionmask(imgdata, offsetx, offsety, width, height, ingameoffsetx, ingameoffsety)
	local mask = {}
	local maskheight = height or tilesize
	local maskwidth = width or tilesize
	local masktootall = maskheight > tilesize
	local masktoowide = maskwidth > tilesize
	if masktootall then
		print("woah bud, you have a mask that's too tall: " .. maskheight)
	end
	if masktoowide then
		print("woah bud, you have a mask that's too wide: " .. maskwidth)
	end
	for i=1, maskheight do mask[i] = {} end
	if not offsetx then offsetx = 0 end
	if not offsety then offsety = 0 end
	if not ingameoffsetx then ingameoffsetx = 0 end
	if not ingameoffsety then ingameoffsety = 0 end
	local trueleftbound = offsetx
	local truerightbound = offsetx + maskwidth - 1
	local truetopbound = offsety
	local truebottombound = offsety + maskheight - 1
	for y = offsety - ingameoffsety, (maskheight - 1) + offsety - ingameoffsety do
		for x = offsetx - ingameoffsetx, (maskwidth - 1) + offsetx - ingameoffsetx do
			local value = false
			if y >= truetopbound and y <= truebottombound and x >= trueleftbound and x <= truerightbound then
				local r, g, b, a = imgdata:getPixel(x, y)
				if a ~= nil and a > 0.75 then value = true end
			end
			mask[(y - offsety) + ingameoffsety + 1][(x - offsetx) + ingameoffsetx + 1] = value
		end
	end
	
	return mask
end

function ormasks(masks) --all masks should be the same size for this to work as intended. usually they'll be 16x16 so this is fine
	local mask = masks[1]
	for y=1, #mask do
		for x=1, #mask[y] do
			if not mask[y][x] then
				local result = false
				for masknum=2, #masks do
					if masks[masknum] and masks[masknum][y][x] then
						result = true
						break
					end
				end
				mask[y][x] = result
			end
		end
	end
	return mask
end

function makemaskwithmultistring(maskstring, falsesymbol, truesymbol)
	local mask = {}
	local maskstring2 = correctnewlines(maskstring)
	local maskstringsplit = split(maskstring, "\n")
	for y=1, #maskstringsplit do
		local maskrowsplit = split(maskstringsplit[y], "")
		local newrow = {}
		for x=1, #maskrowsplit do
			if maskrowsplit[x] == truesymbol then
				newrow[x] = true
			elseif maskrowsplit[x] == falsesymbol then
				newrow[x] = false
			else
				print("unrecognized symbol in mask for makemaskwithmultistring: " .. maskrowsplit[x] .. " that was it")
			end
		end
		mask[y] = newrow
	end
	return mask
end

--[[
for tilename,tile in pairs(tiles) do
	if tile.gfxoffsets == nil then
		tile.gfxoffsets = {0, 0}
	end
	if tile.gfxoverride ~= nil and tile.gfxoverrideoffsets == nil then
		tile.gfxoverrideoffsets = {}
		for i=1, #tile.gfxoverride do
			tile.gfxoverrideoffsets[i] = {0, 0}
		end
	end
	if tile.automask then
		if tile.gfxoverride then
			local masks = {}
			for i=1, #tile.gfxoverride do
				masks[i] = makecollisionmask(love.image.newImageData("imagery/" .. tile.gfxoverride[i] .. ".png"), -1 * tile.gfxoverrideoffsets[i][1], -1 * tile.gfxoverrideoffsets[i][2])
			end
			tile.mask = ormasks(masks)
		else
			tile.mask = makecollisionmask(love.image.newImageData("imagery/" .. tilename .. ".png"), -1 * tile.gfxoffsets[1], -1 * tile.gfxoffsets[2])
		end
	end
end
]]
for tilename,tile in pairs(tiles) do
	if not tile.graphics then
		tile.graphics = {
			{}
		}
	end
	local masks = {}
	local i = 0
	local graphicses = {tile.graphics}
	if tile.graphics_anim then graphicses[2] = tile.graphics_anim end
	for _,tilegraphics in ipairs(graphicses) do
		for _,graphic in ipairs(tilegraphics) do
			--print(tilename)
			i = i + 1
			if not graphic.referencename then graphic.referencename = tilename end
			if not graphic.ingameoffset then graphic.ingameoffset = {0, 0} end
			if not graphic.quad then graphic.quad = {0, 0} end
			if tile.automask then
				if graphic.excludefromautomask then
					i = i - 1 --safe because i is only used for the masks array
					--alt approach would be just setting this index of masks to false, then tinkering with makecollisionmask a bit to ignore false masks completely (including when using the first mask supplied as the standard width and height for all masks). this would take a bit more code and would only be useful if a situation pops up where you want to know what graphic goes to what mask, specifically before the masks are orred
				else
					local referencedata = graphics.loadimagedata(graphic.referencename)
					graphic.reference = graphics.supply(graphic.referencename, referencedata)
					masks[i] = makecollisionmask(
						referencedata,
						graphic.quad[1] or 0,
						graphic.quad[2] or 0,
						graphic.quad[3] or tilesize,
						graphic.quad[4] or tilesize,
						graphic.ingameoffset[1] or 0,
						graphic.ingameoffset[2] or 0
					)
					--[[if tilename == "shortspikesS" then
						for ii=1, #masks[i] do
							local toprint = ""
							for iii=1, #masks[i][ii] do
								local toconcat = 0
								if masks[i][ii][iii] then toconcat = 1 end
								toprint = toprint .. toconcat
							end
							print(toprint)
						end
						print("====")
					end]]
					graphic.quad = love.graphics.newQuad(
						graphic.quad[1] or 0,
						graphic.quad[2] or 0,
						graphic.quad[3] or tilesize,
						graphic.quad[4] or tilesize,
						graphic.reference
					)
				end
			else
				graphic.reference = graphics.load(graphic.referencename)
				graphic.quad = love.graphics.newQuad(
					graphic.quad[1] or 0,
					graphic.quad[2] or 0,
					graphic.quad[3] or tilesize,
					graphic.quad[4] or tilesize,
					graphic.reference
				)
			end
		end
	end
	if tile.makemask then
		tile.mask = tile:makemask()
	elseif tile.maskstring then
		tile.mask = makemaskwithmultistring(tile.maskstring, ".", "#")
	end
	if #masks > 0 then tile.mask = ormasks(masks) end
end
graphics.disposeimagedata() --comment this out and make referencedata a variable of each graphic if you ever need to access imagedata after generating masks

for objectname,object in pairs(objects) do
	if type(object) ~= "table" then print(objectname,object) end
	if object.automask then
		object.mask = makecollisionmask(love.image.newImageData("imagery/" .. (object.maskimagename or objectname) .. ".png"))
	end
end

function pick(t)
	if #t == 0 then return nil end
	return t[love.math.random(1, #t)]
end

function pick_butnot(t, n1, n2)
	if n1 == nil and n2 == nil then return pick(t) end
	local t2 = table.copy(t)
	local toremove = {}
	for i,v in ipairs(t2) do
		if v == n1 or v == n2 then
			toremove[#toremove + 1] = i
		end
	end
	table.sort(toremove, function(a,b)
		return a > b
	end)
	for i,v in ipairs(toremove) do
		table.remove(t2, v)
	end
	return pick(t2)
end

function push_limited(t, v, n)
	t[#t + 1] = v
	if #t > n then table.remove(t, 1) end
end

baseHeight = 480
baseWidth = 640
heightscale = 1
widthscale = 1
--yeah these are in different case idk man

function resizeWindow(w, h, settings, foreditor, exiteditor)
	w = tonumber(w)
	h = tonumber(h)
	if not (w == love.graphics.getWidth() and h == love.graphics.getHeight() and ((not settings) or (#settings == 0))) then
		handleNewDimensions(w, h, foreditor, exiteditor)
		love.window.updateMode(w, h, settings)
	end
end

function love.resize(w, h)
	handleNewDimensions(w, h)
end

function handleNewDimensions(w, h, foreditor, exiteditor)
	widthscale = w / baseWidth
	heightscale = h / baseHeight
	
	local real_w = w
	local real_h = h
	if (statemachine.currentstate == editor or foreditor) and not exiteditor then
		w = w - editor.addedwidth
		h = h - editor.addedheight
	end
	
	game.textboxwraplimit = game.textboxwraplimit_default
	if game.textboxwraplimit + (2 * (game.textboxpadding + game.textboxedgeofscreen)) > w then
		game.textboxwraplimit = w - (2 * (game.textboxpadding + game.textboxedgeofscreen))
	end
	
	
	editor.innerwidth = w
	editor.innerheight = h
	editor.width = w + editor.addedwidth
	editor.height = h + editor.addedheight
	editor.mapview_width = math.ceil(w / tilesize)
	editor.mapview_height = math.ceil(h / tilesize)
	menu.width = w
	menu.height = h
	menu.logox = math.floor((menu.width - graphics.load(menu.logoname):getWidth()) / 2)
	menu.factx = math.floor(menu.width / 4)
	menu.facttext:setf("FACT: " .. menu.fact, game.width / 2, "center")
	
	--if game.width ~= w or game.height ~= h then --dingbats are initialized whenever a levelset is loaded and the viewport or game resolution is different
	--	game.initDingbatsMap()
	--end
	game.width = w
	game.height = h
	if game.viewport.width > game.width then game.viewport.width = game.width end
	if game.viewport.height > game.height then game.viewport.height = game.height end
	
	w = real_w
	h = real_h
	
	if statemachine.currentstate == symboldisplay then
		symboldisplay.calc_clickspots()
	else
		symboldisplay.docalcwhenbegun = true
	end
	if statemachine.currentstate == editor then
		editor.adjustdynamics()
	else
		editor.adjustdynamicswhenbegun = true
	end
end

function love.load()
	handleNewDimensions(love.graphics.getWidth(), love.graphics.getHeight())
	if not settings.playaudio then love.audio.setVolume(0) end
	if not settings.playsfx then audio.changesfxvolume(0) end
	if not settings.playmusic then audio.changemusicvolume(0) end
	local unlockedcheats = split(correctnewlines(love.filesystem.read("unlockedcheats.txt") or ""), "\n")
	for i,v in ipairs(unlockedcheats) do
		local thischeat = cheat.get(v)
		if thischeat then print("cheat is unlocked: " .. v); thischeat.unlocked = true; table.insert(cheat.unlockedcheats, v) end
	end
	
	--kludge for automatically unlocking all cheats that are active but not unlocked
	local cheatset = {}
	for i,v in ipairs(cheat.unlockedcheats) do
		cheatset[v] = true
	end
	local activecheats = split(correctnewlines(love.filesystem.read("activecheats.txt") or ""), "\n")
	local updateunlocked = false
	for i,v in ipairs(activecheats) do
		if cheat.get(v) and not cheatset[v] then
			cheatset[v] = true
			print("cheat " .. v .. " was active but not unlocked, so it's unlocked now")
			table.insert(cheat.unlockedcheats, v)
			updateunlocked = true
		end
	end
	
	if updateunlocked then writeto("unlockedcheats") end
	
	local _cheatswithvox = love.filesystem.getDirectoryItems("audial/sfx/vox/ogmosays/cheats")
	local cheatswithvox = {}
	for k,v in pairs(_cheatswithvox) do
		cheatswithvox[v] = true
	end
	
	for k,v in pairs(cheat.cheats) do
		if not v.unlocked then
			table.insert(cheat.lockedcheats, k)
			if cheatswithvox[k .. ".ogg"] then table.insert(cheat.lockedcheats_withvox, k) end
		end
	end
	
	menu.changeSubstate("title")
	statemachine.setstate("menu")
	
	for i,v in ipairs(activecheats) do
		local thischeat = cheat.get(v)
		if thischeat then print("starting with cheat: " .. v); cheat.invoke(thischeat) end
	end
	menu.changed.activecheats = false
end

function love.threaderror(thread, errorstr)
  print("Thread error!\n"..errorstr)
end

function love.quit()
	if editor.unsavedroomsamt > 0 then
		local pressedbutton = love.window.showMessageBox("unsaved changes", [[
you want to quit and that's fine but there are some
unsaved changes in this editor. what do you want to do
(btw if you click "save & quit" and you have any rooms
marked to be deleted those will also be deleted)]], {
			"save & quit",
			"just quit",
			"cancel",
			escapebutton = 3,
			enterbutton = 1,
		}, "warning")
		if pressedbutton == 1 then
			editor.saveAll()
		elseif pressedbutton == 3 then
			return true --abort quitting
		end
	end
	menu.handleWrites()
	game.trysave()
	--if statemachine.currentstate == game and (not game.editormode) and type(game.save_entrance) == "table" then
	--	print("saving")
	--	writeto("save")
	--end
	writer.thread:wait()
end

evenframe = true
showfps = false
showdecays = false

function love.update(dt)
	if ih8ui.showingbox then
		ih8ui.update(dt)
	end
	local state = statemachine.getactivestate()
	if state ~= game then frameadvance = false end
	if not (frameadvance or ih8ui.showingbox) then 
		evenframe = not evenframe
		state.update(dt)
	end
	audio.update()
end

function love.focus(f)
	if settings.unfocusmute then
		if not f then
			love.audio.setVolume(0)
		else
			if settings.playaudio then love.audio.setVolume(1) end
		end
	end
	if settings.unfocuspause and not f then
		if statemachine.getactivestate() == game and not game.pausedformenu then
			game.pause()
		end
	end
end

momentumtest = false
--drawboxtest = false

function love.keypressed(key, scancode)
	--if key == "kp0" then drawboxtest = not drawboxtest end
	if ih8ui.showingbox then
		ih8ui.keypressed(key, scancode)
		return
	end
	
	local state = statemachine.getactivestate()
	--if state == menu and key == "kp0" then ih8ui.showBox(ih8ui.easybox) end
	if state == menu and key == "kp0" then ih8ui.showBox(boxes.pagetest) end
	if state == game and key == "f" and allowframeadvance then frameadvance = not frameadvance end
	if frameadvance and key == "g" then
		to_print = {}
		markers = {}
		advancingframe = true
		evenframe = not evenframe
		state.update(dt)
	end
	state.keypressed(key, scancode)
	if key == "f1" and (state == editor or state == menu) then
		love.system.openURL("file://"..love.filesystem.getSaveDirectory().."/Jumper 4 Real.chm"); print("opening help file");
	elseif key == "kp*" then
		showfps = not showfps
	elseif key == "kp-" then
		skippedupdates = 0
		doubledupdates = 0
		bulkupdates = 0
	--elseif key == "kp/" and false then
	--	momentumtest = not momentumtest
	--	print("toggling momentumtest: " .. tostring(momentumtest))
	elseif key == "kp/" then
		showdecays = not showdecays
	end
	if (love.keyboard.isDown("lctrl") or love.keyboard.isDown("rctrl")) and (love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift")) and key == "d" then
		print("entering debug mode. if you did this by accident, type \"cont\" and press enter")
		debug.debug()
	end
	if (love.keyboard.isDown("lctrl") or love.keyboard.isDown("rctrl")) and (love.keyboard.isDown("lshift") or love.keyboard.isDown("rshift")) and key == "kp5" then
		error("example error")
	end
end

function love.mousepressed(x, y, button)
	if ih8ui.showingbox then
		ih8ui.mousepressed(x, y, button)
		return
	end
	local state = statemachine.getactivestate()
	if state.mousepressed then
		state.mousepressed(x, y, button)
	end
end

function love.mousereleased(x, y, button)
	if ih8ui.showingbox then
		ih8ui.mousereleased(x, y, button)
		return
	end
	local state = statemachine.getactivestate()
	if state.mousereleased then
		state.mousereleased(x, y, button)
	end
end

function love.mousemoved( x, y, dx, dy, istouch )
	if ih8ui.showingbox then
		ih8ui.mousemoved( x, y, dx, dy, istouch )
		return
	end
	local state = statemachine.getactivestate()
	if state.mousemoved then
		state.mousemoved( x, y, dx, dy, istouch )
	end
end

function love.textinput(t)
	if ih8ui.showingbox then
		ih8ui.textinput(t)
		return
	end
	local state = statemachine.getactivestate()
	if state.textinput then
		state.textinput(t)
	end
end

function love.keyreleased(key, scancode)
	local state = statemachine.getactivestate()
	if state.keyreleased then
		state.keyreleased(key, scancode)
	end
end

function love.filedropped(file)
	local state = statemachine.getactivestate()
	if state.filedropped then
		state.filedropped(file)
	end
end

function love.wheelmoved(x, y)
	local state = statemachine.getactivestate()
	if state.wheelmoved then
		state.wheelmoved(x, y)
	end
end

to_print = {}
function onscreenprint(arr)
	for i,v in ipairs(arr) do
		table.insert(to_print, v)
	end
end
markers = {}
graphics.load("marker")
function mark(x, y)
	table.insert(markers, {x, y})
end

savetimer = 0
savetimer_fadeat = 30
savetimer_max = 60
local saveicon = graphics.load("ui/save")
local function drawsave()
	if savetimer < savetimer_fadeat then
		love.graphics.setColor(1,1,1,savetimer / savetimer_fadeat)
	end
	love.graphics.draw(saveicon, love.graphics.getWidth() - 24, 8)
	savetimer = savetimer - 1
	love.graphics.setColor(1,1,1)
end
function showsave() savetimer = savetimer_max end
function showsave_nonthread()
	savetimer = savetimer_fadeat
	drawsave()
	love.graphics.present()
end

function love.draw()
	if not (statemachine.overlaystate and statemachine.dontdrawunderneath) then statemachine.currentstate.draw() end
	if statemachine.overlaystate then statemachine.overlaystate.draw() end
	if statemachine.currentstate == game or statemachine.currentstate == editor then
		--???
	end
	if ih8ui.showingbox then
		local r,g,b,a = love.graphics.getColor()
		love.graphics.setColor(0.5, 0.5, 0.5, 0.5)
		love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
		love.graphics.setColor(r,g,b,a)
		ih8ui.drawBox(ih8ui.box)
	end
	if showfps then
		printWithOutline("FPS " .. tostring(love.timer.getFPS()), 10, 10)
		printWithOutline("accu ", 10, 30)
		printWithOutline(tostring(accumulator), 44, 30)
		printWithOutline("updates " .. updatesdone, 10, 50)
		printWithOutline("skipped " .. skippedupdates, 10, 70)
		printWithOutline("doubled " .. doubleupdates, 10, 90)
		printWithOutline("bulk " ..bulkupdates, 10, 110)
	end
	if showdecays then
		printWithOutline("decays " .. tostring(dingbats.decaysdone), game.width - 96, 10)
	end
	for i,v in ipairs(to_print) do
		printWithOutline(v, 16, i * 16)
	end
	if not frameadvance then to_print = {} end
	for i,v in ipairs(markers) do
		love.graphics.draw(graphics.load("marker"), v[1], v[2])
	end
	if not frameadvance then markers = {} end
	advancingframe = false
	
	if savetimer > 0 then
		drawsave()
	end
end