local font = love.graphics.getFont()
menu = {
	width = 640,
	height = 480,
	substateTemplate = "",
	options = {
		[1] = {
			name = "rhubarb",
			tooltip = "The fleshy, edible stalks of species and hybrids of Rheum in the family Polygonaceae.",
			action = function() end
		}
	},
	linedistance = 35,
	offsetfromleft = 192,
	offsetleftfromcenter = 64,
	offsetfromtop = 96,
	sidenameoffset = 20,
	onUpdate = function() end,
	
	page = 1,
	numpages = 1,
	
	changed = {},
	temp = {}, --cleared whenever page is changed
	
	picker = nil,
	pickerHoldMoveDelayResetToLong = 24, --frames
	pickerHoldMoveDelayResetToShort = 6,
	pickerHoldMoveDelayCurrent = 0,
	pickerLongHoldPassed = false,
	tooltipScale = 0.75,
	showlogo = true,
	showfact = false,
	cheatcode = "",
	cheatcodetimer = 0,
	nifty = false,
	niftyimg = {},
	lastmousepos = {x = nil, y = nil},
	mousepos = {x = 0, y = 0},
	cancheat = true,
	logoname = "J4R Logo 2x",
	logox = nil,
	logoy = 10,
	logo_ogmobox = {x = 10, y = 16, width = 32, height = 26},
	onLoad = function() end,
	stack = {}, --subtate stack
	stack_old = nil, --when you open the pause menu in-game, the stacks get copied to their _old verisons and wiped, and you're sent to the "paused" substate. once the menu begins again as non-pause menu, the old stacks are restored
	pickerstack = {},
	pickerstack_old = nil,
	pagestack = {}, --i think in an ideal implementation, this would be redundant to pickerstack. and you'd just do modulo 7 stuff and assume anything past index 7 is special and the stacks don't need to be concerned with it
	pagestack_old = nil,
--	pagesstack = {}, --this is definitely stupid and only for visual purposes)
	pausemenu = false,
	multipage = false,
	pages = 1,
	page = 1,
	fulloptions = {},
	itemsperpage = 7,
	misctext = love.graphics.newText(font, ""),
	fact = "",
	facttext = love.graphics.newText(font, ""),
	factx = nil,
	facty = 25,
	bigtext = love.graphics.newText(titlefont, ""),
	glyph_height_reference = love.graphics.newText(font, "o"):getHeight(),
	
	ogmosays = love.audio.newQueueableSource(48000, 16, 1),
	ogmosays_playing = false,
	ogmosays_saidcheat = 0,
	ogmosays_musicmult = 0.25,
	ogmosays_pt1last2 = {},
	ogmosays_pt2last2 = {},
	
	typing = false,
	typedtext = "",
	disallowedchars = false, --table or false (because false is like nil but with intent)
	
	sidenametext = love.graphics.newText(font, ""),
	
	fromeditor = false,
}

menu.gradientsimg = graphics.load("gradients2")
menu.gradientsimg:setFilter("nearest")
menu.gradientsquads = {
	black_top    = quad(0, 0, 1, 32, menu.gradientsimg),
	black_bottom = quad(1, 0, 1, 32, menu.gradientsimg),
	black_left   = quad(4, 32, 32, 1, menu.gradientsimg),
	black_right  = quad(4, 33, 32, 1, menu.gradientsimg),
}

menu.logox = math.floor((menu.width - graphics.load(menu.logoname):getWidth()) / 2)
menu.logoy = 10
menu.factx = menu.width / 4
menu.facty = 25

print("o height: " .. love.graphics.newText(font, "o"):getHeight())
print("b height: " .. love.graphics.newText(font, "b"):getHeight())

function menu.begin(fromstate, overlay)
	--[[
	menu.stackreset()
	menu.picker = nil
	menu.changeSubstate("title")
	]]
	if not overlay then
		audio.flushpauses()
		if not cheat.isactive("jumper4imaginary") then --kind of hacky i guess
			--print("jumper4imaginary not active, so playing hub")
			audio.playsong("hub")
		else
			--print("jumper4imaginary active, so playing hub")
			audio.playsong("imagination")
		end
		menu.showlogo = true
		menu.showfact = false
	else
		menu.showlogo = false
		menu.showfact = true
	end
	menu.cheatcode = ""
	if overlay and not menu.pausemenu then
		print("overlay time")
		menu.pausemenu = true
		menu.stack_old = menu.stack
		menu.pickerstack_old = menu.pickerstack
		menu.picker_old = menu.picker
		menu.pagestack_old = menu.pagestack
		menu.page_old = menu.page
		menu.stack = {}
		menu.pickerstack = {}
		menu.pagestack = {}
	elseif menu.pausemenu and not overlay then
		menu.pausemenu = false
		menu.stack = menu.stack_old
		menu.pickerstack = menu.pickerstack_old
		menu.picker = menu.picker_old
		menu.pagestack = menu.pagestack_old
		menu.page = menu.page_old
		menu.stack_old = nil
		menu.pickerstack_old = nil
		menu.picker_old = nil
		menu.pagestack_old = nil
		menu.page_old = nil
		menu.refresh()
	end
	if not menu.pausemenu then --if this is the main menu
		if fromstate == editor then
			menu.fromeditor = true
		end
		menu.refresh()
	end
end

function menu.doeslogoshow()
	if menu.showlogooverride ~= nil then
		return menu.showlogooverride
	else
		return menu.showlogo
	end
end

local function mouseonogmo()
	if menu.doeslogoshow() and menu.logoname == "J4R Logo 2x" then
		local mousex = love.mouse.getX()
		local mousey = love.mouse.getY()
		if
				(mousex > (menu.logox + menu.logo_ogmobox.x) and mousex < (menu.logox + menu.logo_ogmobox.x + menu.logo_ogmobox.width))
			and (mousey > (menu.logoy + menu.logo_ogmobox.y) and mousey < (menu.logoy + menu.logo_ogmobox.y + menu.logo_ogmobox.height))
		then
			return true
		end
	end
	return false
end

function menu.playogmosays()
	if not menu.ogmosays_playing then
		menu.ogmosays_playing = true
		print(#cheat.lockedcheats_withvox)
		if #cheat.lockedcheats_withvox == 0 then menu.ogmosays_saidcheat = 2
		elseif #cheat.lockedcheats_withvox == 1 then menu.ogmosays_saidcheat = 1 end
		local part1path = "audial/sfx/vox/ogmosays/says"
		local part1pool = love.filesystem.getDirectoryItems(part1path)
		local part1name = pick_butnot(part1pool, menu.ogmosays_pt1last2[1], menu.ogmosays_pt1last2[2])
		push_limited(menu.ogmosays_pt1last2, part1name, 2)
		local part1 = love.sound.newSoundData(part1path .. "/" .. part1name)
		menu.ogmosays:queue(part1)
		local part2path
		local part2pool
		local part2name
		local part2
		if menu.ogmosays_saidcheat < 2 then --make it so clicking ogmo only says a cheat twice per session, to make it more interesting
			part2path = "audial/sfx/vox/ogmosays/cheats"
			part2pool = cheat.lockedcheats_withvox
			part2name = pick_butnot(part2pool, menu.ogmosays_pt2last2[1], menu.ogmosays_pt2last2[2])
			push_limited(menu.ogmosays_pt2last2, part2name, 2)
			part2 = love.sound.newSoundData(part2path .. "/" .. part2name .. ".ogg")
			menu.ogmosays_saidcheat = menu.ogmosays_saidcheat + 1
		else
			part2path = "audial/sfx/vox/ogmosays/misc"
			part2pool = love.filesystem.getDirectoryItems(part2path)
			part2name = pick_butnot(part2pool, menu.ogmosays_pt2last2[1], menu.ogmosays_pt2last2[2])
			push_limited(menu.ogmosays_pt2last2, part2name, 2)
			part2 = love.sound.newSoundData(part2path .. "/" .. part2name)
		end
		menu.ogmosays:queue(part2)
		local song = audio.loadedsongs[audio.activesong]
		if song then
			song:setVolume(audio.musicvolume * menu.ogmosays_musicmult)
		end
		menu.ogmosays:play()
	end
end

function menu.changelogo(logoname)
	if logoname ~= menu.logoname then
		menu.logoname = logoname
		graphics.load(menu.logoname)
		graphics.load(menu.logoname .. " blink")
		menu.blinktimer = nil
		menu.logox = math.floor((menu.width - graphics.load(menu.logoname):getWidth()) / 2)
		menu.logoy = 10
	end
end

function menu.update(dt)
	if menu.ogmosays_playing then
		if not menu.ogmosays:isPlaying() then
			local song = audio.loadedsongs[audio.activesong]
			if song then
				song:setVolume(audio.musicvolume)
			end
			menu.ogmosays_playing = false
		end
	end
	if menu.blinktimer and menu.blinktimer > 0 then menu.blinktimer = menu.blinktimer - 1 end
	if menu.blinktimer and menu.blinktimer <= 0 then menu.blinktimer = nil end
	if menu.onUpdate then menu.onUpdate() end
	--picker movement logic
	if menu.pickerHoldMoveDelayCurrent > 0 then
		menu.pickerHoldMoveDelayCurrent = menu.pickerHoldMoveDelayCurrent - 1
	end
	
	if menu.pickerHoldMoveDelayCurrent == 0 then
		if love.keyboard.isDown("down") then
			menu.movePicker("down")
			if not menu.pickerLongHoldPassed then
				menu.pickerHoldMoveDelayCurrent = menu.pickerHoldMoveDelayResetToLong
				menu.pickerLongHoldPassed = true
			else
				menu.pickerHoldMoveDelayCurrent = menu.pickerHoldMoveDelayResetToShort
			end
		elseif love.keyboard.isDown("up") then
			menu.movePicker("up")
			if not menu.pickerLongHoldPassed then
				menu.pickerHoldMoveDelayCurrent = menu.pickerHoldMoveDelayResetToLong
				menu.pickerLongHoldPassed = true
			else
				menu.pickerHoldMoveDelayCurrent = menu.pickerHoldMoveDelayResetToShort
			end
		end
	end
	if not love.keyboard.isDown("down") and not love.keyboard.isDown("up") then
		menu.pickerHoldMoveDelayCurrent = 0
		menu.pickerLongHoldPassed = false
	end
	
	
	if menu.cheatcodetimer > 0 then menu.cheatcodetimer = menu.cheatcodetimer - 1
	else menu.cheatcodetimer = 0; menu.cheatcode = ""; end
	
	
	if love.mouse.isDown(1) and mouseonogmo() then
		menu.blinktimer = 1
	end
	
	
	--oh god this entire part is just for a "scribble stuff on the menu" cheat
	if cheat.isactive("nifty") then
		local mouseisdown = love.mouse.isDown(1, 2, 3)
		menu.lastmousepos.x, menu.lastmousepos.y = menu.mousepos.x, menu.mousepos.y
		if not mouseisdown then menu.lastmousepos.x, menu.lastmousepos.y = nil, nil end
		menu.mousepos.x, menu.mousepos.y = love.mouse.getPosition()
		if mouseisdown then
			if (not (menu.lastmousepos.x and menu.lastmousepos.y)) or ((menu.lastmousepos.x == menu.mousepos.x) and (menu.lastmousepos.y == menu.mousepos.y)) then --we check if last mouse pos is nil *or* if it's the same as mouse pos, because in either case the "make a line" procedure is unnecessary and would error due to either nil values or a division by zero
				local y = menu.mousepos.y
				local x = menu.mousepos.x
				if menu.niftyimg[y + 1] ~= nil and menu.niftyimg[y + 1][x + 1] ~= nil then
					menu.niftyimg[y + 1][x + 1] = true
				end
			else
				--make a line between current mouse pos and last mouse pos
				--this is probably really inefficient and terrible but i came up with it by myself (because i'm too lazy to look it up)
				local x1, y1 = menu.mousepos.x, menu.mousepos.y
				local x2, y2 = menu.lastmousepos.x, menu.lastmousepos.y
				
				local step_x = x1
				local step_y = y1
				
				local step_x_relative = 0
				local step_y_relative = 0
				
				local x2_relative = x2 - x1
				local y2_relative = y2 - y1
				
				local larger = math.abs(x2_relative)
				if math.abs(y2_relative) > larger then larger = math.abs(y2_relative) end
				
				local stepby_x = x2_relative / larger
				local stepby_y = y2_relative / larger
				
				local stepcount = 0
				
				while math.abs(step_x_relative) <= math.abs(x2_relative) and math.abs(step_y_relative) <= math.abs(y2_relative) do
					local step_y_rounded = math.floor(step_y + .5)
					local step_x_rounded = math.floor(step_x + .5)
					if menu.niftyimg[step_y_rounded + 1] ~= nil and menu.niftyimg[step_y_rounded + 1][step_x_rounded + 1] ~= nil then
						menu.niftyimg[step_y_rounded + 1][step_x_rounded + 1] = true
					end
					step_y = step_y + stepby_y
					step_x = step_x + stepby_x
					step_y_relative = step_y_relative + stepby_y
					step_x_relative = step_x_relative + stepby_x
				end
			end
		end
	end
end

function menu.keypressed(key, scancode)
	local override = menu.onKeyPressed(key)
	if override then return end
	if key == "return" then
		local option = menu.options[menu.picker]
		if not menu.typing then
			if option.vartoggle then --vartoggle is hardcoded but could very easily be replaced with normal action() for the actual logic, and getname() for the drawing
				settings[option.vartoggle] = not settings[option.vartoggle]
				menu.changed.settings = true
			end
			if option.input then
				option.beingtyped = true
				menu.typedtext = ""
				menu.typing = true
				menu.disallowedchars = option.disallowedchars or false --or false looks stupid
				love.keyboard.setKeyRepeat(true)
			end
			if option.action then option.action() end
		else
			if menu.typedtext == "" then
				menu.typing = false
				menu.disallowedchars = false
				option.beingtyped = false
				love.keyboard.setKeyRepeat(false)
			else
				menu.typing = false
				menu.disallowedchars = false
				option.beingtyped = false
				local typedtext = menu.typedtext
				menu.typedtext = ""
				love.keyboard.setKeyRepeat(false)
				option.onSubmit(typedtext)
			end
		end
	elseif key == "backspace" then
		if not menu.typing then --not really necessary because cheating can never happen on a menu with an input option - presently, anyway
			menu.cheatcode = ""
			menu.cheatcodetimer = 0
		else
			menu.typedtext = string.sub(menu.typedtext, 1, -2)
		end
	elseif key == "escape" then
		menu.options[menu.picker].beingtyped = false
		menu.typedtext = ""
		menu.typing = false
		love.keyboard.setKeyRepeat(false)
		menu.disallowedchars = false
		if #menu.stack == 1 then
			if menu.pausemenu then
				statemachine.clearoverlaystate()
				game.unpause()
			else
				love.event.quit()
			end
		else
			menu.back()
		end
    elseif scancode == "`" and menu.cancheat and (not menu.pausemenu) then
		ih8ui.showBox(boxes.cheat)
	end
end

function menu.mousepressed(x, y, button)
	if mouseonogmo() and button == 2 then
		menu.playogmosays()
	end
end

function menu.cheat(cht)
	local cheatmenu_firstunlock = not next(cheat.unlockedcheats)
	menu.blinktimer = 8
	menu.cheatcodetimer = 0
	audio.playsfx("cheat")
	cheat.invoke(cht)
	if not cht.unlocked and not cht.hidden then
		print(menu.cheatcode .. " unlocked via typing!")
		cheat.unlock(menu.cheatcode)
		menu.changed.unlockedcheats = true
	end
	menu.cheatcode = ""
	menu.onCheat(cheatmenu_firstunlock)
end

function menu.textinput(t)
	if menu.typing then
		if (not menu.disallowedchars) or not menu.disallowedchars[t] then
			menu.typedtext = menu.typedtext .. t
		end
	elseif menu.cancheat and not menu.pausemenu then
		menu.cheatcode = menu.cheatcode .. t
		menu.cheatcodetimer = 100
		local cht = cheat.get(menu.cheatcode)
		if cht then
			menu.cheat(cht)
		end
	end
end

function menu.draw()
	if menu.pausemenu then
		love.graphics.draw(menu.gradientsimg, menu.gradientsquads["black_top"], 0, 0, 0, menu.width, 1)
		love.graphics.draw(menu.gradientsimg, menu.gradientsquads["black_left"], 0, 0, 0, 1, menu.height)
		love.graphics.draw(menu.gradientsimg, menu.gradientsquads["black_right"], menu.width - 32, 0, 0, 1, menu.height)
		love.graphics.draw(menu.gradientsimg, menu.gradientsquads["black_bottom"], 0, menu.height - 32, 0, menu.width, 1)
	end
	--love.graphics.print("welcome to hte menu Prass Enter to Play")
	local r, g, b, a = love.graphics.getColor()
	if menu.pausemenu and not (menu.pages > 1) then
		love.graphics.push()
		local options_top = menu.offsetfromtop
		local options_bottom = menu.offsetfromtop + (menu.linedistance * (#menu.options - 1)) + menu.glyph_height_reference
		local options_height = options_bottom - options_top
		local options_centred_top = math.floor((menu.height - options_height) / 2)
		love.graphics.translate(0, (options_centred_top - options_top))
	end
	for i=1, #menu.options do
		local option = menu.options[i]
		local optionname
		if option.beingtyped then
			if option.typingprefix then
				optionname = option.typingprefix .. menu.typedtext .. "|"
			else
				optionname = menu.typedtext .. "|"
			end
		else
			if menu.options[i].getname then optionname = menu.options[i]:getname() end
			if not optionname then optionname = menu.options[i].name end
			if menu.options[i].vartoggle ~= nil then
				local toggletext = "NO"
				if settings[menu.options[i].vartoggle] then toggletext = "YES" end
				optionname = optionname .. toggletext
			end
		end
		if not option.beingtyped then
			if menu.options[i].alpha then
				love.graphics.setColor(r, g, b, menu.options[i].alpha)
			end
			if menu.options[i].customcolor then
				if option.getcolor then
					love.graphics.setColor(option:getcolor())
				else
					love.graphics.setColor(option.red, option.green, option.blue, option.alpha or 1)
				end
			end
		end
		--love.graphics.print(optionname, menu.offsetfromleft, menu.offsetfromtop + (menu.linedistance * (i - 1)))
		local optionx = math.floor(love.graphics.getWidth() / 2) - menu.offsetleftfromcenter
		local optiony = menu.offsetfromtop + (math.floor(menu.linedistance * heightscale) * (i - 1))
		love.graphics.print(optionname, optionx, optiony)
		if menu.options[i].sidename then
			local r2,g2,b2,a2 = love.graphics.getColor()
			love.graphics.setColor(r2,g2,b2,a2 / 2)
			local sidename = menu.options[i].sidename
			menu.sidenametext:set(sidename)
			love.graphics.draw(menu.sidenametext, optionx - (menu.sidenametext:getWidth() + menu.sidenameoffset), optiony)
		end
		if menu.options[i].alpha or menu.options[i].customcolor or menu.options[i].sidename then love.graphics.setColor(r, g, b, a) end
	end
	--love.graphics.print(">", menu.offsetfromleft - 10, menu.offsetfromtop + (menu.linedistance * (menu.picker - 1)))
	love.graphics.print(">",
		(math.floor(love.graphics.getWidth() / 2) - menu.offsetleftfromcenter) - 10,
		menu.offsetfromtop + (math.floor(menu.linedistance * heightscale) * (menu.picker - 1))
	)
	if menu.pausemenu and not (menu.pages > 1) then love.graphics.pop() end
	menu.onDraw()
	if menu.options[menu.picker].gettooltip then
		printAsTooltip(menu.options[menu.picker].gettooltip(), menu.tooltipScale)
	else
		printAsTooltip(menu.options[menu.picker].tooltip, menu.tooltipScale)
	end
	if menu.doeslogoshow() then
		local imagetoshow
		if menu.blinktimer then imagetoshow = graphics.load(menu.logoname .. " blink") end
		if not imagetoshow then imagetoshow = graphics.load(menu.logoname) end
		love.graphics.draw(imagetoshow, menu.logox, menu.logoy)
	end
	if menu.showfact then
		love.graphics.draw(menu.facttext, menu.factx, menu.facty)
	end
	menu.misctext:setf(table.concat(menu.stack, " > "), menu.width, "left")
	love.graphics.draw(menu.misctext)
	menu.misctext:setf("v" .. version, menu.width, "left")
	love.graphics.draw(menu.misctext, menu.width - menu.misctext:getWidth(), menu.height - menu.misctext:getHeight())
	local cheatamt = 0
	if cheat.activecheats then cheatamt = #cheat.activecheats end
	if cheatamt > 0 or menu.alwaysshowcheatamt then
		menu.misctext:setf("cheats: " .. cheatamt, menu.width, "left")
		love.graphics.draw(menu.misctext, menu.width - menu.misctext:getWidth(), 0)
	end
	--love.graphics.print(table.concat(menu.pickerstack, " > "), 0, 16)
	if menu.pages > 1 then
		menu.misctext:setf("(" .. menu.page .. "/" .. menu.pages .. ")", menu.width, "center")
		love.graphics.draw(menu.misctext, 0, 72)
		--love.graphics.print("(" .. menu.page .. "/" .. menu.pages .. ")", 242, 72)
	end
	if cheat.isactive("nifty") then
		love.graphics.setColor(1, 0, 1, 1)
		for y=1, love.graphics.getHeight() do
			if menu.niftyimg[y] then
				for x=1, love.graphics.getWidth() do
					if menu.niftyimg[y][x] then love.graphics.rectangle("fill", x - 1, y - 1, 1, 1) end
				end
			end
		end
		love.graphics.setColor(r, g, b, a)
	end
end

function menu.stop()
	menu.handleWrites()
	menu.niftyimg = {}
	menu.ogmosays:stop()
end

function menu.movePicker(dir)
	menu.typing = false
	love.keyboard.setKeyRepeat(false)
	menu.disallowedchars = false
	menu.options[menu.picker].beingtyped = false
	menu.typedtext = ""
	if     dir == "up"   then menu.picker = menu.picker - 1
	elseif dir == "down" then menu.picker = menu.picker + 1 end
	if menu.picker < 1 then menu.picker = #menu.options end
	if menu.picker > #menu.options then menu.picker = 1 end
end

function menu.stackreset()
	menu.stack = {}
	menu.pickerstack = {}
end

function menu.back()
	--menul.stack (which contains substates) keeps the current substate in the stack, but menu.pickerstack and menu.pagestack don't keep the current picker position/page in the stack. not sure how it 1ended up like this. probably something to do with how stack pushes are triggered by changing substate.
	menu.onBack()
	table.remove(menu.stack)
	menu.picker = menu.pickerstack[#menu.pickerstack]
	table.remove(menu.pickerstack)
	menu.page = menu.pagestack[#menu.pagestack]
	table.remove(menu.pagestack)
	menu.fromeditor = false
	menu.changeSubstate(menu.stack[#menu.stack], true)
end

function menu.refresh()
	menu.changeSubstate(menu.stack[#menu.stack], true, true)
end

function menu.appendBackOption(name, tooltip)
	menu.options[#menu.options + 1] = {
		name = name or "back",
		tooltip = tooltip or "return to previous screen",
		action = menu.back
	}
end

function menu.pageSetup()
	menu.options = {}
	local i = 0
	for ii = (menu.itemsperpage * (menu.page - 1)) + 1, menu.itemsperpage * menu.page do
		i = i + 1
		menu.options[i] = menu.fulloptions[ii]
	end
	menu.appendChangePageOption("previous", -1, tern(menu.noback, 1, 2))
	menu.appendChangePageOption("next", 1, tern(menu.noback, 0, 1))
	if not menu.noback then
		menu.appendBackOption(menu.backname, menu.backtooltip)
	end
end

function menu.appendChangePageOption(kind, amt, offsetfrombottom)
	local newpage = menu.page + amt
	menu.options[#menu.options + 1] = {
		name = kind .. " page",
		tooltip = "go to the " .. kind .. " page",
		alpha = tern(newpage > 0 and newpage <= menu.pages, 1, 0.5),
		action = function()
			if newpage > 0 and newpage <= menu.pages then
				menu.page = newpage
				menu.pageSetup()
				if next(menu.temp) ~= nil then menu.temp = {} end
				menu.picker = #menu.options - offsetfrombottom
			end
		end
	}
end

function menu.handleWrites()
	local towrite = {}
	for k,v in pairs(menu.changed) do
		if v then
			print(k .. " changed")
			table.insert(towrite, k)
			--[[
			print(k .. " changed, writing")
			writeto(k)
			]]
		end
	end
	if #towrite > 0 then
		print("writing...")
		writeto_multi(towrite)
	end
	menu.changed = {}
end

function menu.changeSubstate(substate, neutral, ignorewriting)
	if not ignorewriting then menu.handleWrites() end
	if next(menu.temp) ~= nil then menu.temp = {} end
	menu.fulloptions = {}
	menu.multipage = false
	menu.pages = 1
	if not neutral then
		table.insert(menu.stack, substate) --again, when a substate change triggers stack pushes, the NEW substate is pushed onto the substate stack, not the old one. this is contrary to how the pickerstack and pagestack work. some day it's going to turn out i'm actually just writing gibberish on the walls inside a padded cell
		table.insert(menu.pickerstack, menu.picker)
		table.insert(menu.pagestack, menu.page)
	end
	if not neutral then menu.picker = 1 end
	if not neutral then menu.page = 1 end
	menu.substateTemplate = substate
	local ss = menu_substates[substate]
	if not ss then print(substate); debug.debug(); error(2) end
	if ss.initialize and not ss.initdone then
		ss.initialize(ss)
		ss.initdone = true
	end
	menu.options = table.copy(ss.options) --NOTE: does not copy deep enough to make the option tables themselves distinct
	menu.linedistance = ss.linedistance or 35
	menu.itemsperpage = ss.itemsperpage or 7
	menu.offsetfromleft = ss.offsetfromleft or 192
	menu.offsetleftfromcenter = ss.offsetleftfromcenter or 64
	menu.offsetfromtop = ss.offsetfromtop or 96
	menu.onUpdate = ss.onUpdate or donothing
	menu.onKeyPressed = ss.onKeyPressed or donothing
	menu.onDraw = ss.onDraw or donothing
	menu.showlogooverride = ss.showlogooverride
	menu.onCheat = ss.onCheat or donothing
	menu.onLoad = ss.onLoad or donothing
	menu.onLoad()
	menu.onBack = ss.onBack or donothing
	menu.noback = ss.noback
	menu.backname = ss.backname
	menu.backtooltip = ss.backtooltip
	--[[
	if not menu.backtooltip then
		
		if not menu.pausemenu then
			menu.backtooltip = "Exit to the title screen."
		else
			menu.backtooltip = "Exit this menu."
		end
	end
	]]
	menu.alwaysshowcheatamt = ss.alwaysshowcheatamt
	menu.ischeatmenu = ss.ischeatmenu
	--menu.cancheat = ss.cancheat or false
	menu.cancheat = (ss.cancheat ~= nil and ss.cancheat) or true
	if #menu.options > menu.itemsperpage then
		menu.pages = math.ceil(#menu.options / menu.itemsperpage)
		menu.fulloptions = table.copy(menu.options)
		menu.multipage = true
		menu.pageSetup()
	elseif not ss.noback then
		menu.appendBackOption(ss.backname, ss.backtooltip)
	end
end