art = object:new()

local img = graphics.load("art")

art.quads = {
	["unsolid"] = love.graphics.newQuad(0, 0, 16, 16, img),
	["occupied"] = love.graphics.newQuad(0, 16, 16, 16, img),
	["solid"] = love.graphics.newQuad(0, 32, 16, 16, img)
}

function art.editordraw(x, y, options)
	love.graphics.draw(graphics.load("art"), art.quads["unsolid"], x, y)
end

function art:init(x, y)
	self.type = "art"
	self.x = x
	self.y = y
	self.hmom = 0
	self.ymom = 0
	self.width = tilesize
	self.height = tilesize
	self.solid = false
	self.occupied = false
	self.just_occupied = false
end

function art:setup(x, y, options)
	return art:new(x, y)
end

function art:update()
	if self.occupied and not self.just_occupied then
		self.solid = true
		self.occupied = false
	elseif self.just_occupied then
		self.just_occupied = false
	end
end

function art:onOverlap(obj)
	if self.fake or self.solid then return end
	
	if (obj.type == "walkyspike") or (obj.type == "blob") or ((obj.type == "ogmo") and (self.occupied or obj.y <= self.y)) then
		self.occupied = true
		self.just_occupied = true
	end
end

function art:draw()
	local mystate = "unsolid"
	if self.occupied then mystate = "occupied" end
	if self.solid then mystate = "solid" end
	love.graphics.draw(graphics.load("art"), art.quads[mystate], self.x, self.y)
end

return art