borderkludge = object:new()

function borderkludge.editordraw(x, y, options)
	love.graphics.draw(graphics.load("invisible"), x, y)
end

function borderkludge:init(x, y, blockage)
	self.type = "borderkludge"
	self.x = x
	self.y = y
	self.hmom = 0
	self.vmom = 0
	self.width = tilesize
	self.height = tilesize
	self.solid = false
	self.blockage = blockage
end

function borderkludge:setup(x, y, options, level, edge, tags)
	local ins = table.insert
	local blockage = {}
	if next(tags) then
		if tags["faceup"] then ins(blockage, "up") end
		if tags["facedown"] then ins(blockage, "down") end
		if tags["faceleft"] then ins(blockage, "left") end
		if tags["faceright"] then ins(blockage, "right") end
	else
		if edge == "up" then ins(blockage, "up")
		elseif edge == "down" then ins(blockage, "down")
		elseif edge == "left" then ins(blockage, "left")
		elseif edge == "right" then ins(blockage, "right")
		end
	end
	return borderkludge:new(x, y, blockage)
end

function borderkludge:update()
end

function borderkludge:onCollide(collidee, side)
end

function borderkludge:draw()
	if settings.seetheunseeable then
		love.graphics.draw(graphics.load("invisible"), self.x, self.y)
	end
end

return borderkludge