car = mob:new()

--whilst carring your progress will not be saved
--or maybe once you car into a levelset it gains a special slot 4 displayed as "slot car" and that's the slot you play with from then on (and if you car into the levelset again it overwrites slot car)
--slot car disappears when erased
--slot car should be able to have alternative level select behavior (e.g. no level select, or level select but with different available levels) and depending on where you car in
--when carring from editor test, destination level/levelset should be loaded, but screen size should not be changed and no slotcar should be created

--car cutscene level:
--ROAD TRIP!!!
--DESTINATION: 
--[levelset name]
--[level coords, space after comma]
--ENTRANCE #[entrance]
--maybe even use the ascii tiles for this, and instead of making a car state, just put the player in a special level
--the car starts on the left edge of the screen and when it crosses the right edge the new levelset is loaded
--and if you press R while the car is carring then ogmo dies (it has the same momentum & position as the car but is invisible) and the car crossing the screen does nothing if ogmo is dead. this lets you cancel the carring
--this also lets you pause during car because why not. and spawn ogmos with clique. and stuff.
--maybe the car level could have wins on the right edge, and the special "new levelset"/slotcar behavior could be tied to winning the level instead of the car crossing the screen
--also the speed of the car would be based on the distance to the right edge of the screen

car.quads = {
	["vroom1"] = love.graphics.newQuad(0, 0, 16, 16, 32, 16),
	["vroom2"] = love.graphics.newQuad(16, 0, 16, 16, 32, 16)
}

function car.editordraw(x, y, options)
	love.graphics.draw(graphics.load("car"), car.quads["vroom1"], x, y)
end

function car:init(x, y, dest_levelset, dest_level, dest_entrance, backup_dest)
	self.type = "car"
	self.x = x
	self.y = y
	self.hmom = 0
	self.ymom = 0
	self.width = tilesize
	self.height = tilesize
	self.solid = false
	self.speed = 1.5
	self.dest_levelset = dest_levelset
	self.dest_level = dest_level
	self.dest_entrance = dest_entrance
	self.vroom = "vroom1"
	self.vroomtimer = 0
	self.vroomtimer_max = 8
end

function car:setup(x, y, options, level, edge, tags)
	local number = 1
	for i=0, 9 do
		if tags["variant" .. i] then
			number = i; break;
		end
	end
	if not number then number = 1 end
	local dest_info = self.level.cars[number]
	if not dest_info then dest_info = {"showcase", "ex-cars", "1", false} end
	local dest_levelset = dest_info[1]
	local dest_level = dest_info[2]
	local dest_entrance = tonumber(dest_info[3])
	local backup_dest = dest_info[4]
	return car:new(x, y, dest_levelset, dest_level, dest_entrance, backup_dest)
end

function car:update()
	self.vroomtimer = self.vroomtimer + 1
	if self.vroomtimer >= self.vroomtimer_max then
		if self.vroom == "vroom1" then
			self.vroom = "vroom2"
		else self.vroom = "vroom1" end
		self.vroomtimer = 0
	end
end

function car:draw()
	love.graphics.draw(graphics.load("car"), car.quads[self.vroom], self.x, self.y)
end

return car