--Unused!
do return end
checkpoint = object:new()

function checkpoint.editordraw(x, y, options)
	love.graphics.draw(graphics.load("gems"), checkpoint.quads["outline"], x, y)
	love.graphics.draw(graphics.load("gems"), checkpoint.quads["inside"], x, y)
end

checkpoint.quads = {
	["outline"] = love.graphics.newQuad(0, 32, 16, 16, graphics.load("gems")),
	["inside"] = love.graphics.newQuad(16, 32, 16, 16, graphics.load("gems"))
}

checkpoint.drawlate = true --so that ogmoscan renders on top of everything

checkpoint.ogmoscanquads = {}
print("checkpoint ogmoscanquads time")
for i=0, 31 do
	--these equations could both probably be rearranged to be more consistent with each other. i think the 4 * appearing twice in y's equation is equivalent to the 16 * at the start of x's equation?
	local x = (16 * (i % 4)) + (4 * (i - (i % 16)))
	local y = (4 * (i - (i % 4))) - (4 * (i - (i % 16)))
	
	checkpoint.ogmoscanquads[i + 1] = quad(x, y, 16, 16, graphics.load("ogmoscan"))
	--yes i mental algebra'd this instead of just writing a bunch of coordinates manually. i'm not sure why
	--print("frame " .. i + 1 .. ": x offset " .. tostring(x) .. ", y offset " .. tostring(y))
end

function checkpoint:init(x, y, spawnnum, entrance, spawns)
	self.type = "checkpoint"
	self.x = x
	self.y = y
	self.hmom = 0
	self.ymom = 0
	self.width = tilesize
	self.height = tilesize
	self.solid = false
	self.spawnnum = spawnnum
	self.invalid = false
	--[[if not spawns[spawnnum] then
		self.invalid = true
	end]]
	self.passive = false
	self.used = false --setting this to "used" is handled in late_init and clone_init. this can be handled within the current init function, as seen below, but this will fail when cloning the object during level:clone() anyway. late_init and clone_init are made one function because both a baselevel and a clone level need to assess whether an ogmo spawn exists for its spawn number AFTER all ogmos are placed, so having them be the same function eliminates some code redundancy.
	
	--[[
	--print("ent: " .. tostring(entrance))
	--print("spawnnum: " .. tostring(spawnnum))
	if entrance == spawnnum then --this won't be accurate if the checkpoint is created via a level being cloned, since spawnnum and entrance will be nil so it will just be if nil == nil. that's why clone_init exists below
		self.used = true
	end
	]]
	self.scan_anim_timer = 0
end

function checkpoint:late_init() --checkpoint isn't going to know whether it's valid or not until all ogmos have been placed
	--print("ent (again): " .. tostring(self.level.entrance.number))
	--print("spawnnum (again): " .. tostring(self.spawnnum))
	if (self.level.entrance.id == self.spawnnum) or (game.templatelevels[1] and game.templatelevels[1].filepath == self.level.filepath and game.templatelevels[1].entrance.id == self.spawnnum) then
		self.used = true
	else
		self.used = false
	end
	if not self.level.ogmo_spawns[self.spawnnum] then
		self.invalid = true
	else
		self.invalid = false
	end
end

--checkpoint.clone_init = checkpoint.late_init

function checkpoint:setup(x, y, options, level, edge, tags)
	local spawnnum = 1
	for i=0, 9 do
		if tags["variant" .. i] then
			spawnnum = i; break;
		end
	end
	return checkpoint:new(x, y, spawnnum, level.entrance.id)
end

function checkpoint:update()
	if self.scan_anim_timer > 0 then
		self.scan_anim_timer = self.scan_anim_timer - 1
	end
end

function checkpoint:onOverlap(obj)
	if (not self.used) and (not self.invalid) and obj.player then
		local entrance = {
			--number = self.exitno or 1,
			id = self.spawnnum,
			careening = obj.careening,
			jumpsleft = obj.jumps,
			hmom = obj.hmom,
			vmom = obj.vmom,
			gray = (obj.starstate and obj.starstate.gray),
			purple = (obj.starstate and obj.starstate.purple),
		}
		local lvl = game.activelevels[1]
		if not game.editormode then game.save_entrance = entrance end
		if game.levelpaths then --we try to just load the level file because having the pre-gamified level with symbolmaps and tagmaps fully filled out beforehand to save a little time in exchange for memory is probably not a good tradeoff. optimize this later with some "load level" thread if need be, then delay resetting the level if the player dies until the level is fully loaded
			game.templatelevels[1] = level:new(love.filesystem.read(game.levelpaths[1]..".txt"), game.levelpaths[1], self.level.roomX, self.level.roomY):gamify(entrance, true) --replace 1 with metaepth in the future. actually i have no idea how meta blocks should handle checkpoints, if at all (e.g. maybe just make self.used always equal to true if in a metalevel)
			game.templatelevels[1].name = lvl.name
		elseif game.editormode and lvl.unsaved then
		--elseif game.editormode then --of course, if we're in the editor, then we already *have* the pre-gamified level in memory, so just use that
			if not (editor.unsavedrooms[lvl.roomY] and editor.unsavedrooms[lvl.roomY][lvl.roomX]) then
				error("checkpointing in an unsaved level, but there's no corresponding unsaved room in the editor?! (" .. lvl.roomX .. "," .. lvl.roomY .. ")")
			end
			game.templatelevels[1] = editor.unsavedrooms[lvl.roomY][lvl.roomX]:gamify(entrance, false)
			--game.templatelevels[1] = editor.level:clone(true):gamify(entrance, true)
			--why is it cloning it just so it can discard the templates when gamifying it, when gamify already has a "don't discard the templates" option??
		else
			error("checkpoint asked for the pre-gamified level, but game.levelpaths is nil, and there's no corresponding unsaved level in the editor. we can't find it!")
		end
		game.save_in_different_level = false
		for k,v in pairs(game.solid_colors) do
			game.solid_colors_checkpoint[k] = game.solid_colors[k]
		end
		game.switchpadstate_checkpoint = game.switchpadstate
		game.switchpad2state_checkpoint = game.switchpad2state
		self.used = true
		self.scan_anim_timer = 32
		audio.playsfx("gem collect")
	end
end

function checkpoint:draw()
	love.graphics.draw(graphics.load("gems"), checkpoint.quads["outline"], self.x, self.y)
	if (not self.used) and (not self.invalid) then love.graphics.draw(graphics.load("gems"), checkpoint.quads["inside"], self.x, self.y) end
	if self.scan_anim_timer > 0 then
		for i,v in ipairs(self.level.ogmo_spawns[self.spawnnum]) do
			love.graphics.draw(graphics.load("ogmoscan"), checkpoint.ogmoscanquads[33 - self.scan_anim_timer], v[1], v[2])
		end
	end
end

return checkpoint