gee = object:new()

gee.automask = true
gee.maskimagename = "gees"

local img = graphics.load("gees") --geez

gee.quads = {
	["down"] = love.graphics.newQuad(0, 0, 16, 16, img),
	["up"] = love.graphics.newQuad(16, 0, 16, 16, img),
	["one"] = love.graphics.newQuad(32, 0, 16, 16, img)
}

function gee.editordraw(x, y, options)
	love.graphics.draw(graphics.load("gees"), gee.quads[options.kind or "one"], x, y)
end

function gee:init(x, y, kind)
	self.type = "gee"
	self.x = x
	self.y = y
	self.hmom = 0
	self.ymom = 0
	self.width = tilesize
	self.height = tilesize
	self.solid = false
	self.irrelevant = false
	self.kind = kind
end

function gee:setup(x, y, options, level, edge, tags)
	return gee:new(x, y, options.kind)
end

function gee:update()
end

function gee:onOverlap(obj)
	if(obj.type == "ogmo") then
		if self.kind == "down" then
			self.level.gravity = self.level.gravity - 0.2
			self:playsfx("gravity down")
		elseif self.kind == "up" then
			self.level.gravity = self.level.gravity + 0.2
			self:playsfx("gravity up")
		else
			self.level.gravity = 1
			self:playsfx("gravity one")
		end
		self.irrelevant = true
	end
end

function gee:draw()
	love.graphics.draw(graphics.load("gees"), self.quads[self.kind or "one"], self.x, self.y)
end

return gee