hintblock = object:new()

function hintblock.editordraw(x, y, options)
	love.graphics.draw(graphics.load("hintblock"), x, y)
end

function hintblock:init(x, y, text, deep)
	self.type = "hintblock"
	self.x = x
	self.y = y
	self.hmom = 0
	self.vmom = 0
	self.width = tilesize
	self.height = tilesize
	self.solid = true
	self.text = text
	self.deep = deep
end

function hintblock:setup(x, y, options, level, edge, tags)
	local number = 1
	for i=0, 9 do
		if tags["variant" .. i] then
			number = i; break;
		end
	end
	if not number then number = 1 end
	local text = "This is a hint."
	local deep = false
	if level.hints[number] and level.hints[number] ~= "" then text = level.hints[number] end
	--if level.options["deephint" .. number] then deep = true end
	if tags["facerandom"] then deep = true end
	text = string.gsub(text, "\\n", "\n")
	return hintblock:new(x, y, text, deep)
end

function hintblock:update()
end

function hintblock:onCollide(collidee, side)
	if not game.pausedfortextbox and side == "up" and collidee.player and not collidee.ghost then
		if not self.deep then self:playsfx("hint")
		else self:playsfx("hint deep") end
		game.showtextbox(self.text)
	end
end

function hintblock:draw()
	if not self.deep then
		love.graphics.draw(graphics.load("hintblock"), self.x, self.y)
	else
		love.graphics.draw(graphics.load("hintblock - Copy"), self.x, self.y)
	end
end

return hintblock