-- to friggin do!
-- add coyote time
-- add walljump coyote time (thx xelu)
ogmo = mob:new()
-- ogmo (he/it)

--[[
  **QUADS**
1. idle
2. idle, blinking
3. ducking
4. ducking, blinking
5-8. walking right
9-12.walking left
13-16. jumping
17-20. jumping right
21-24. jumping left
25. falling
26. falling right
27. falling left
28. looking up
29. ded
30. ded right
31. ded left
32. looking up, blinking
33. ghost block
-]]

ogmo.quads = {}
ogmo.quaddefs = {
	"idle",
	"idleblink",
	"duck",
	"duckblink",
	"walkright1",
	"walkright2",
	"walkright3",
	"walkright4",
	"walkleft1",
	"walkleft2",
	"walkleft3",
	"walkleft4",
	"jump1",
	"jump2",
	"jump3",
	"jump4",
	"jumpright1",
	"jumpright2",
	"jumpright3",
	"jumpright4",
	"jumpleft1",
	"jumpleft2",
	"jumpleft3",
	"jumpleft4",
	"fall",
	"fallright",
	"fallleft",
	"lookup",
	"ded",
	"dedright",
	"dedleft",
	"lookupblink",
	"ghost"
}
ogmo.canblinkquads = {
	["idle"] = "idleblink",
	["duck"] = "duckblink",
	["lookup"] = "lookupblink"
} 
ogmo.blinkingquads = {
	["idleblink"] = "idle",
	["duckblink"] = "duck",
	["lookupblink"] = "lookup"
} 

--[=[ --this is done in ogmos.lua now, per-skin, using each skin image's width/height respectively instead of always just being 64 and 160
for i=0, 32 do --32 instead of 31. yes, we're starting at 0 and for loop syntax is inclusive in lua, so starting at 0 and iterating to 32 means we get 33 elements, but there is a 33rd element! ghost block, an object that acts like an additional ogmo and causes another ogmo to die when it dies
	--table.insert(ogmo.quads, love.graphics.newQuad((i % 4) * 16, math.floor(i / 4) * 16, 16, 16, 64, 160))
	ogmo.quads[ogmo.quaddefs[i + 1]] = love.graphics.newQuad((i % 4) * 16, math.floor(i / 4) * 16, 16, 16, 64, 160)
end
]=]

function ogmo.editordraw(x, y, options)
	local ghost = options["ghost"]
	local quadtodraw = "idle"
	if ghost then quadtodraw = "ghost" end
	love.graphics.draw(graphics.load("ogmos/" .. game.ogmoskin), ogmo.quads[quadtodraw], x, y)
end

local function ogmo_collisioncondition(self, collidee, axis)
	if collidee == "levelborder" then
		if self.cutscenemovement then return false end
		if (not self.ghost) then
			local exiting = false
			if self.overlappingwin then exiting = true
			elseif game.flipscreen then
				if axis == "horizontal" then
					if 		self.hmom < 0 and self.level.validexits.left then exiting = true
					elseif	self.hmom > 0 and self.level.validexits.right then exiting = true
					end
				elseif axis == "vertical" then
					if 		self.vmom < 0 and self.level.validexits.up then exiting = true
					elseif	self.vmom > 0 and self.level.validexits.down then exiting = true
					end
				end
			end
			if exiting then
				if next(self.bk_blockage) then --borderkludge blockage
					if axis == "horizontal" then
						if 		self.hmom < 0 and self.bk_blockage.left then return true
						elseif	self.hmom > 0 and self.bk_blockage.right then return true
						end
					elseif axis == "vertical" then
						if 		self.vmom < 0 and self.bk_blockage.up then return true
						elseif	self.vmom > 0 and self.bk_blockage.down then return true
						end
					end
				end
				return false
			end
		end
	end
	if collidee.type == "ogmo" and ((not not collidee.ghost) ~= (not not self.ghost)) then return false end --"not not x" converts x to bool. honestly i don't remember why i did this. i think in the case that self.ghost is false but collidee.ghost is nil
	--actually i think it might be if ghost has a string argument. because the levelsymbols setup variable system is dumb and only lets you supply string values
	if collidee.type == "objectcollider" then return false end
	return true
end

function ogmo:init(x, y, width, height, ghost, playerno, edge, docutscene, hmom, vmom, jumps, careening, gray, purple, icestar)
	--NOTE: in j2e, gravity does not seem to apply to ogmo on the first frame that he's jumping, resulting in his ground jump being slightly higher than his double jump
	
	self.irrelevant = false --"irrelevant" means "don't care about this when iterating through shit, and remove this from the level asap"
	
	self.edge = edge
	self.docutsceneinit = docutscene
	if game.do_cutscene_movement_after_respawn then self.docutsceneinit = true end
	--self.cutscene_firstfreemovement = false --this refers to the first frame after initialization if you're in a cutscene movement. this is a kludge that gets checked so that you can't jump while you're out of bounds and hit your face on the outer wall, or move onto the ceiling if you start the level while falling. this isn't necessary for starting the level jumping since in that case your vertical momentum 
	-- the above no longer matters because you don't start out of bounds anymore when on an edge and doing cutscenemovement (you start 1 pixel in-bounds)
	
	self.type = "ogmo"
	self.player = true
	self.playerno = playerno
	self.x = x
	self.y = y
	self.width = width
	self.height = height
	self.id = false --just ego and superego here folks
	self.ghost = ghost
	self.solid = true
	--if self.ghost and self.solid then self.solid = false end
	self.alive = true
	self.x_clamped = x
	self.y_clamped = y
	self.y_clamped_last = y
	self.hmom = hmom
	self.hmom_min = -999
	self.hmom_max = 999
	self.maxspeed = 4 --natural cap on speed
	self.maxfallspeed = 6 --natural cap on fall speed
	self.tempmaxspeed = false
	self.vmom = vmom
	self.vmom_min = -999
	self.vmom_max = 999
	self.acceleration = 0.175 --self.acceleration is added to ogmo's speed while he's holding an arrow key in the direction he's moving
	self.friction = 0.6 --self.friction is a weird opposite of self.acceleration: it's subtracted from ogmo's speed while his speed is greater than 0 but he's not holding an arrow key in the direction he's moving
	--friction refers to how long it should take ogmo to come to a stop, and has no effect on his speed while he's moving in the direction he wants to go, which probably means "friction" and "acceleration" are weird misnomers here
	--this does mean that jumper 2-esque ice has to be implemented 
	
	if cheat.isactive("oldskoolbutlikewithak") then
		self.acceleration = 999
		self.friction = 999
	end
	
	self.gravity = 0.2
	self.defaultjumps = 2
	self.jumps = jumps
	self.jumpforce = 5.1
	self.skidjumpextraforce = 1.25
	self.corpseforce = 3
	self.jumpzaniness = 0 --the extent to which jumps should inherit current velocity, meaning doublejumping twice in a row lets you jump way higher. i thought i was so clever when i came up with this
	self.walljumpforce = 4
	self.walljumpspeed = 5
	self.tempfriction = false --temp friction results from doing a walljump and is lower than normal friction; it's main purpose is to disallow you from walljumping back onto the same wall quick enough to get further up
	self.oldtempfriction = false
	self.walljumptempfriction = 0.1 --what your tempfriction should be after doing a walljump
	self.tempfrictiontimer = 0
	self.walljumptempfrictionframes = 16
	self.tempfrictionphaseouttimer = 12
	self.cutscenemovement = false --"right", "left", "up", or "down"
	self.verticaled = "none"
	self.verticaledby = {}
	self.grounded = false
	self.walled = "none"
	self.walledby = {}
	self.overlaps = {}
	self.overlappingwin = false
	self.do_check_overlappingwin_early = true
	
	self.collidewith = {["playercollider"] = true}
	self.collisioncondition = ogmo_collisioncondition
	self.skidding = "none"
	self.skiddingframes = 12
	self.skiddingtimer = 0
	self.skiddingspeed = 2.5
	self.startskiddingframes = 4
	self.startskiddingtimer = 0
	self.ducking = false
	self.duckingthrough = false --kludge for duck-through
	self.lookingup = false
	
	self.careening = careening
	self.attachedtolauncher = false --"attached to launcher" just means "ignore a jump command if we issue it". if we were just doing normal launchers with nothing extra then this could be identical to careening (and in fact the player already does enter careening state when they enter normal launchers, and jump is already prevented while careening), but i find the notion of a launcher that doesn't actually suck you in and just gives you a momentum boost in a particular direction the next time you press jump really interesting
	--there's also an additional kludge so that you don't jump immediately after being launched by a remote. when that happens, attachedtolauncher gets set to 2, then counts down by 1 each update until it reaches 0, at which point it's set to false again.
	self.physicallyinsidelauncher = false --yeah this is stupid. attachedtolauncher will be true if you activate a remote launcher, physicallyinsidelauncher will only be true if you're actually inside a launcher. this is so that if ogmo touches two launchers at the same time, one of the launchers will know the other one is claimed
	
	self.extraverticalbits = {}
	self.extrahorizontalbits = {}
	self.justjumped = false
	
	self.gfxoffsets = {0, 0}
	
	--QUAD TIME
	self.currentquad = "idle"
	self.fakelagquad = "idle"
	
	self.animtimer = 128
	self.animframestoblink = 128
	self.animframestounblink = 8
	self.animframestostep = 6
	self.animframestotumble = 3
	
	self.corpse = false
	self.corpse_camera_leniency = 256
	
	self.stuckleft = false
	self.stuckdown = false
	self.stuckright = false
	self.stuckup = false
	
	self.was_stuckdown = false
	self.was_stuckup = false
	
	self.mustdie = false
	
	self.insolid = false
	
	self.iced = false
	self.icewalled = {["left"] = false, ["right"] = false, ["none"] = false}
	self.ice_acceleration_divisor = 1.5
	self.ice_friction_divisor = 16
	
	local gray = gray
	local purple = purple
	if self.starstate then
		if not gray then gray = self.starstate.gray end
		if not purple then purple = self.starstate.purple end
		if not icestar then icestar = self.starstate.ice end
	end
	self.starstate = {}
	self.starstate.gray = gray
	self.starstate.purple = purple
	self.starstate.ice = icestar
	
	if self.starstate.ice then self.iced = true end
	
	self.canride = true
	
	self.bk_blockage = {} --borderkludge blockage
	
	self.frame1done = false --for fakelag stuff. this originally had the comment "fixes fakelag ogmo being drawn at the wrong position for one frame" but this variable was never used anywhere until i used it for fakelag animation stuff
	
	self.touchedsolid = false --for the tag that makes ogmo not movable until he touches something solid (e.g. cutscene fall)
	
	self.walljumpleniencytimer = 0
	self.walljumpleniencyframes = 2 --amount of frames you have to walljump after letting go of the wall. jumper in general does not have lenient features; this exists solely because jumper 2 runs at 30fps and this runs at 60fps. furthermore, this only applies while you're vertically aligned with the original wall, so even with the extra leniency cheat below, you can't do zany knytt stories-esque corner jumps where you walljump off of thin air.
	self.walljumpleniencyframes_extra = 10
	self.wjl_max_xdiff = (tilesize / 2)
	self.lastwalled = "none"
	self.lastwalledby = {}
	self.lasticewalled = {["left"] = false, ["right"] = false, ["none"] = false}
	
	--todo
	self.walking = false
	self.walkmaxspeed = 2
end

function ogmo:setup(x, y, options, level, edge, tags)
	if not tags then tags = {} end
	local ghost = options["ghost"]
	if ghost then level:incMax("ghostsgone") end
	if (not ghost) and (not tags["ignoreplayeramt"]) then level.playeramt = level.playeramt + 1 end
	--if edge and not ghost then --this would disallow ghosts from doing cutscenemovement which is annoying for levels where the ghosts' movement is supposed to be synced with yours or symmetrical (with purple stars)
	if edge then
		if edge == "left" then
			x = x - 15
		elseif edge == "right" then
			x = x + 15
		elseif edge == "up" then
			y = y - 15
		elseif edge == "down" then
			y = y + 15
		end
	end
	if tags["fluid"] then
		tags["nocutscenemovement"] = true
		tags["momentum"] = true
		tags["winoffset"] = true
		tags["preservejumpstate"] = true
		tags["preservecareen"] = true
		tags["preservestars"] = true
	end
	local docutscene = true
	local hmom = 0
	local vmom = 0
	local jumps = 1 --in case ogmo spawns in midair
	local careening = false
	local gray = false
	local purple = false
	local icestar = false
	if tags["nocutscenemovement"] then docutscene = false end
	if tags["momentum"] then
		hmom = level.entrance.hmom
		vmom = level.entrance.vmom
	end
	if tags["winoffset"] then
		if level.entrance.xoffset then x = x + level.entrance.xoffset end
		if level.entrance.yoffset then y = y + level.entrance.yoffset end
	end
	if tags["preservejumpstate"] then jumps = level.entrance.jumpsleft end
	if tags["preservecareen"] then
		careening = level.entrance.careening
		if careening then
			hmom = level.entrance.hmom
			vmom = level.entrance.vmom
		end
	end
	if tags["preservestars"] then
		if level.entrance.gray then gray = true end
		if level.entrance.purple then purple = true end
		if level.entrance.icestar then icestar = true end
	end
	--blahblahblah
	return ogmo:new(x, y, tilesize, tilesize, ghost, 1, edge, docutscene, hmom, vmom, jumps, careening, gray, purple, icestar)
end

function ogmo:late_init()
	if self.x < -15 then self.x = -15 end
	if self.y < -15 then self.y = -15 end
	if self.x > self.level.width - 1 then self.x = self.level.width - 1 end
	if self.y > self.level.height - 1 then self.y = self.level.height - 1 end
end

function ogmo:keyDown(key, direct, ignorepurple)
	if self.tags and self.tags.nomoveuntilcollide and not self.touchedsolid then return false end
	local realkey = key
	if (not ignorepurple) and self.starstate.purple then
		if key == "left" then key = "right"
		elseif key == "right" then key = "left"
		end
	end
	if direct then
		return love.keyboard.isDown(controls["P" .. self.playerno .. key:upper()])
	elseif not self.alive then return false
	else
		if     realkey == "right" and self.cutscenemovement == "right" then return true
		elseif realkey == "left" and self.cutscenemovement == "left" then return true
		elseif self.cutscenemovement == "right" or self.cutscenemovement == "left" then return false
		end
		--elseif self.cutscene_firstfreemovement and (self.cutscenemovement == "down" or self.cutscenemovement == "up") then return false end
		
		--testing
		--if momentumtest and self.hmom < 0 and key == "right" then return false end
		--if momentumtest and self.hmom > 0 and key == "left" then return false end
		
		return love.keyboard.isDown(controls["P" .. self.playerno .. key:upper()])
	end
end

function ogmo:canUnduck(dir)
	if not dir then dir = "up" end
	local testvmom = -3
	if dir == "down" then testvmom = 3 end
	if self.insolid and dir == "up" then return true end
	local oldvmom = self.vmom
	self.vmom = testvmom
	local collisionresult
	collisionresult = mobtools.doCollisionScan("vertical", self, true)
	self.vmom = oldvmom
	if collisionresult == "none" then return true else return false end
end

function ogmo:update()
	if not self.level then print("OGMO SEZ: I'M IN A NIL LEVEL SO I'M GONNA BE ANGRY ABOUT IT AND FLOOD THE CONSOLE!") end --only the most professional error messages will do in this state-of-the-art video game
	self:keychecks()
	if self.alive then
		if cheat.isactive("jumparound") then self:jump() end
		self:movement()
		if not self.alive then return end
		
		--saves writing a bunch of booleans in keyDown
		local oldpurple = self.starstate.purple
		self.starstate.purple = false
		if oldpurple and (self.cutscenemovent == "left" or self.cutscenemovement == "right") then self.starstate.purple = true end --kludge aaaa
		
		--major, game-breaking glitch in the following code: if you time your ducks or unducks frame perfectly, you can avoid blinking ever while idling/ducking, thus making you a monster depriving ogmo of sleep
		if self.animtimer > 0 then self.animtimer = self.animtimer - 1 end
		
		if self.careening or self.vmom < 0 or (self.vmom == 0 and not self.grounded) then
			if string.sub(self.currentquad, 1, 4) ~= "jump" then
				self.currentquad = "jump1"
				self.animtimer = self.animframestotumble
			end
			jumpnum = tonumber(string.sub(self.currentquad, -1, -1))
			if self.careening then
				if self.hmom > 0 then self.currentquad = "jumpright" .. jumpnum
				elseif self.hmom < 0 then self.currentquad = "jumpleft" .. jumpnum
				else self.currentquad = "jump" .. jumpnum end
			else
				if not (self:keyDown("right") and self:keyDown("left")) then
					if self:keyDown("right") then self.currentquad = "jumpright" .. jumpnum
					elseif self:keyDown("left") then self.currentquad = "jumpleft" .. jumpnum
					else self.currentquad = "jump" .. jumpnum end
				end
			end
			--if self.animtimer <= 0 and not(jumpnum == 1 and (self.vmom > -0.5 and not self.careening)) then
			-- checking if self.vmom > -0.5 before exiting jump1 was a clever detail to make it so ogmo wouldn't exit jump1 once he reaches the peak of his jump, so jumps would transition from jump1 (ogmo is upright) to fall (ogmo is upright). unfortunately this causes issues with things like negative gravity against a ceiling where the jump animation SHOULD happen even though ogmo doesn't have sufficient momentum
			if self.animtimer <= 0 then
				local jump = string.sub(self.currentquad, 1, -2)
				jumpnum = jumpnum + 1
				if jumpnum > 4 then jumpnum = 1 end
				self.currentquad = jump .. tostring(jumpnum)
				self.animtimer = self.animframestotumble
			end
		elseif self.vmom > 0 and not self.grounded then --note: does not check for whether ogmo can actually fall by a full pixel this frame
			self.currentquad = "fall"
			if not (self:keyDown("right") and self:keyDown("left")) then
				if self:keyDown("right") then self.currentquad = "fallright"
				elseif self:keyDown("left") then self.currentquad = "fallleft" end
			end
		else
			if self.ducking and string.sub(self.currentquad, 1, 4) ~= "duck" then
				if not (self.canblinkquads[self.currentquad] or self.blinkingquads[self.currentquad]) then
					self.animtimer = self.animframestoblink
					self.currentquad = "duck"
				else
					if self.canblinkquads[self.currentquad] then self.currentquad = "duck"
					else self.currentquad = "duckblink" end
				end
				
			end
			
			if not self.ducking and not (self:keyDown("right") and self:keyDown("left")) then
				if self:keyDown("right") and string.sub(self.currentquad, 1, -2) ~= "walkright" then
					self.currentquad = "walkright1"
					self.animtimer = self.animframestostep
				elseif self:keyDown("left") and string.sub(self.currentquad, 1, -2) ~= "walkleft" then
					self.currentquad = "walkleft1"
					self.animtimer = self.animframestostep
				end
			end
			
			if string.sub(self.currentquad, 1, 4) ~= "idle" and string.sub(self.currentquad, 1, 6) ~= "lookup" and not self.ducking and ((self:keyDown("right") and self:keyDown("left")) or not (self:keyDown("right") or self:keyDown("left"))) then
				if not (self.canblinkquads[self.currentquad] or self.blinkingquads[self.currentquad]) then
					self.animtimer = self.animframestoblink
					self.currentquad = "idle"
				else
					if self.canblinkquads[self.currentquad] then self.currentquad = "idle"
					else self.currentquad = "idleblink" end
				end
			end
			
			if string.sub(self.currentquad, 1, 4) == "idle" and self.lookingup then 
				if self.blinkingquads[self.currentquad] then self.currentquad = "lookupblink"
				elseif self.canblinkquads[self.currentquad] then self.currentquad = "lookup" end
			elseif string.sub(self.currentquad, 1, 6) == "lookup" and not self.lookingup then 
				if self.blinkingquads[self.currentquad] then self.currentquad = "idleblink"
				elseif self.canblinkquads[self.currentquad] then self.currentquad = "idle" end
			end
			
			if self.animtimer <= 0 then
				if self.canblinkquads[self.currentquad] then
					self.currentquad = self.canblinkquads[self.currentquad] --blink
					self.animtimer = self.animframestounblink
				elseif self.blinkingquads[self.currentquad] then
					self.currentquad = self.blinkingquads[self.currentquad] --unblink
					self.animtimer = self.animframestoblink
				elseif string.sub(self.currentquad, 1, -2) == "walkright" or string.sub(self.currentquad, 1, -2) == "walkleft" then
					local walk = string.sub(self.currentquad, 1, -2)
					local walknum = tonumber(string.sub(self.currentquad, -1, -1))
					walknum = walknum + 1
					if walknum > 4 then walknum = 1 end
					self.currentquad = walk .. tostring(walknum)
					self.animtimer = self.animframestostep
				end
			end
		end
		self.starstate.purple = oldpurple
	elseif self.corpse then
		self.currentquad = "ded"
		if self:keyDown("left", true, true) and not self:keyDown("right", true, true) then
			self.currentquad = "dedleft"
		elseif self:keyDown("right", true, true) and not self:keyDown("left", true, true) then
			self.currentquad = "dedright"
		end
		
		self.y = self.y + self.vmom
		self.x = self.x + self.hmom
		self.vmom = self.vmom + self.gravity
		
		self:handleclamping(dt)
		
		if (
			self.y > self.level.height or
			self.x > self.level.width or
			self.x + self.width < 0 or
			self.y + self.height < self.level.cameraY - ((self.level.liveplayeramt ~= 0 and self.corpse_camera_leniency) or 0) or
			self.x + self.width < self.level.cameraX - ((self.level.liveplayeramt ~= 0 and self.corpse_camera_leniency) or 0) or
			self.y > (self.level.cameraY + game.viewport.height) + ((self.level.liveplayeramt ~= 0 and self.corpse_camera_leniency) or 0) or
			self.x > (self.level.cameraX + game.viewport.width) + ((self.level.liveplayeramt ~= 0 and self.corpse_camera_leniency) or 0)
		) then
			for i,v in ipairs(game.corpses) do
				if v == self then
					table.remove(game.corpses, i)
					break
				end
			end
		end
	end
	if game.ogmofakelag and (evenframe or not self.frame1done) then --if ogmo is at fake 30fps, don't change his current animation frame on an odd frame
		self.fakelagquad = self.currentquad
	end
	self.frame1done = true
end

function ogmo:notWalkingRight()
	if ((self.ducking) or
		(not self:keyDown("right")) or
		(self:keyDown("left") and self:keyDown("right")))
	then
		return true
	end
	return false
end

function ogmo:notWalkingLeft()
	if ((self.ducking) or
		(not self:keyDown("left")) or
		(self:keyDown("left") and self:keyDown("right")))
	then
		return true
	end
	return false
end

function ogmo:handleclamping(dt)
	if (not game.ogmofakelag) or evenframe then
		if game.ogmosnapto ~= 1 then
			--[[
			local newx_pt1 = math.floor(self.x + .5)
			local remainder = newx_pt1 % game.ogmosnapto
			if remainder > (game.ogmosnapto / 2) then
				self.x_clamped = newx_pt1 + (game.ogmosnapto - remainder)
			else
				self.x_clamped = newx_pt1 - remainder
			end
			
			local newy_pt1 = math.floor(self.y + .5)
			local remainder = newy_pt1 % game.ogmosnapto
			if remainder > (game.ogmosnapto / 2) then
				self.y_clamped = newy_pt1 + (game.ogmosnapto - remainder)
			else
				self.y_clamped = newy_pt1 - remainder
			end
			]]
			
			self.x_clamped = math.floor((self.x / game.ogmosnapto) + .5) * game.ogmosnapto
		else
			self.x_clamped = math.floor(self.x + .5)
		end
	else
		self.noxclampattempt = true
	end
	self.y_clamped_last = self.y_clamped
	self.y_clamped = math.floor(self.y + .5)
	
	if self.hmom ~= 0 then self.noxclampattempt = true end
	if self.vmom ~= 0 then self.noyclampattempt = true end
	
	--if math.abs(self.hmom) < 0.1 then
	if self.hmom == 0 and self.noxclampattempt and self.x > (-16 + game.ogmosnapto) and self.x < (self.level.width - game.ogmosnapto) then
		local oldhmom = self.hmom
		self.hmom = self.x_clamped - self.x
		if self.corpse then self.x = self.x_clamped
		else
			local collisionresult, suggestedposition
			collisionresult, suggestedposition = mobtools.doCollisionScan("horizontal", self)
			self.hmom = oldhmom
			if collisionresult == "none" then self.x = self.x_clamped
			else self.x = suggestedposition end
		end
		self.noxclampattempt = false
	end
	if self.vmom == 0 and self.noyclampattempt then
		local oldvmom = self.vmom
		self.vmom = self.y_clamped - self.y
		if self.corpse then self.y = self.y_clamped
		else
			local collisionresult, suggestedposition
			collisionresult, suggestedposition = mobtools.doCollisionScan("vertical", self)
			self.vmom = oldvmom
			if collisionresult == "none" then self.y = self.y_clamped
			else self.y = suggestedposition end
		end
		self.noyclampattempt = false
	end
end

function ogmo:touchsolid()
	if not self.touchedsolid then
		self.touchedsolid = true
		if self.tags and self.tags.nomoveuntilcollide then
			self.tags.nomoveuntilcollide = false
		end
	end
end

ogmo.collisionfunctions = {
	horizontal = function(self)
		local newposition
		local newwalled
		local newwalledby
		
		newwalled, newposition, newwalledby = mobtools.doCollisionScan("horizontal", self)
		
		self.walled = newwalled
		self.walledby = newwalledby
		
		if newposition == nil then
			self.x = self.x + self.hmom
		else
			self:touchsolid()
			self.careening = false
			local bounce = false
			local oldhmom = self.hmom
			for _,collider in ipairs(self.walledby) do
				if collider.bounce then
					bounce = true
					break
				end
			end
			if bounce or cheat.isactive("youreglue") then --why do i keep nerd sniping myself into implementing will-never-be-used shit like rubber instead of the basics of jumper
				self.hmom = -self.hmom
				if math.abs(self.hmom) < 1 then self.hmom = 0 end --no subpixel bouncing
				local frictiondivisor = math.abs(self.hmom) * 2
				if frictiondivisor < 1 then frictiondivisor = 1
				elseif frictiondivisor > 6 then frictiondivisor = 6 end
				self.tempfriction = self.friction / (frictiondivisor)
				self.tempfrictiontimer = self.walljumptempfrictionframes
			else
				if (not game.ogmofakelag) or evenframe then
					self.hmom = 0
				end
			end
			self.x = newposition
			local notdead = (#self.walledby == 0)
			for _,collider in ipairs(self.walledby) do
				if not collider.deathly then
					notdead = true
				end
				if collider.onCollide then
					collider:onCollide(self, self.walled)
				end
			end
			if bounce and self.hmom ~= 0 then self.walled = false; self.walledby = {} end
			if (not notdead) and not cheat.isactive("agodami") then
				self.hmom = oldhmom
				self.mustdie = true
			end
		end
	end,
	
	vertical = function(self)
		local newposition
		local newverticaled
		local newverticaledby
		
		newverticaled, newposition, newverticaledby = mobtools.doCollisionScan("vertical", self)
		
		self.verticaled = newverticaled
		self.verticaledby = newverticaledby
		
		if newposition == nil then
			self.y = self.y + self.vmom
		else
			self:touchsolid()
			self.careening = false
			local bounce = false
			local oldvmom = self.vmom
			for _,collider in ipairs(self.verticaledby) do
				if collider.bounce then
					bounce = true
					break
				end
			end
			if bounce or cheat.isactive("youreglue") then
				if math.abs(self.vmom) < 5 then --bounces have a general trend of losing more and more momentum (probably due to not considering subframe distance traveled before hitting the rubber), but this sometimes comes at a stop around very small bounces for whatever reason, which just go on forever. if the player's bounce would result in having less than 5 units of momentum (slightly less than ogmo's normal jump), very subtly nudge the momentum down with each bounce.
					if self.vmom < 0 then self.vmom = self.vmom + (1/32) else self.vmom = self.vmom - (1/32) end
				end
				self.vmom = -self.vmom
				if math.abs(self.vmom) < 1 then self.vmom = 0 end
			else
				if game.ogmohmombug and
					(not (self.was_stuckdown or self.was_stuckup)) and
					((self.vmom < 0) or (self.vmom > (self.gravity * (self.ghost and 1 or self.level.gravity)))) and
					(not (self.iced and (self.verticaled == "down")))
				then
					local onlyborder = true
					for i,v in ipairs(self.verticaledby) do
						if v.type ~= "levelborder" then onlyborder = false; break; end
					end
					if not onlyborder then
						self.hmom = 0
						self.skiddingtimer = 0
						self.startskiddingtimer = 0
						self.skidding = "none"
					end
				end
				self.vmom = 0
			end
			self.y = newposition
			if self.verticaled == "down" and not (bounce and self.vmom ~= 0) then
				self.jumps = self.defaultjumps
				if self.level.camerafocus == self then statusbar.update("jump") end
				self.tempfriction = false
				self.tempmaxspeed = false
				self.walljumpleniencytimer = 0
				if self.lastwalled ~= "none" then
					self.lastwalled = "none"
					self.lastwalledby = {}
					self.lasticewalled.left = false
					self.lasticewalled.right = false
				end
			end
			local notdead = (#self.verticaledby == 0)
			for _,collider in ipairs(self.verticaledby) do
				if not collider.deathly then
					notdead = true
				end
				if collider.onCollide then
					collider:onCollide(self, self.verticaled)
				end
			end
			if bounce and self.vmom ~= 0 then self.verticaled = false; self.verticaled = {} end
			if self.verticaled == "down" or (not self.ghost and self.gravity * (self.level.gravity) < 0 and self.verticaled == "up") then
				if self.starstate.ice then
					self.iced = true
				else
					self.iced = false
				end
			end
			if (not notdead) and not cheat.isactive("agodami") then
				self.vmom = oldvmom
				self.mustdie = true
			end
		end
	end
}

function ogmo:onCollide(collider, side)
	if collider.deathly then
		self:die()
	else
		if side == "down" and (not self.ghost) and self.ducking and self.grounded and collider.crushduckingogmo then --kill ogmo if it's ducking and gets trapped by a crate (or similar). doesn't apply to ghost blocks because their height doesn't change when they "duck"
			--for absolute j2e accuracy ogmo should be crushed by fallblocks regardless of whether he's ducking, but that's a very rare situation and was probably never used in custom levels since the only way to get below an active fallblock in j2e is to activate it yourself and then teleport below it
			self.vmom = collider.vmom
			self:die()
		end
	end
end

function ogmo:onBoom()
	self:die()
end

function ogmo:skidparticles(amt)
	self.level:includeparticle("skid")
	if self.hmom > 0 then
		particles["skid"]:setDirection(math.rad(-20))
	else
		particles["skid"]:setDirection(math.rad(180 + 20))
	end
	particles["skid"]:setSpeed(math.abs(self.hmom * 0.5), math.abs(self.hmom * 1.5))
	local gravitytoapply = self.gravity
	if not self.ghost then gravitytoapply = self.gravity * (self.level.gravity or 1) end --ghosts ignore level gravity
	particles["skid"]:setLinearAcceleration(0, gravitytoapply / 2)
	if self.hmom > 0 then
		particles["skid"]:setPosition(self.x_clamped + self.width, self.y_clamped + self.height)
	else
		particles["skid"]:setPosition(self.x_clamped, self.y_clamped + self.height)
	end
	particles["skid"]:emit(amt)
end

function ogmo:movement(dt)
	if self.do_check_overlappingwin_early then
		local overlaps = mobtools.doOverlapScan(self)
		--for i,v in ipairs(self.level.objects) do
		for i,v in ipairs(overlaps) do
			if v.type == "win" then
				self.overlappingwin = true
				break
			end
		end
		self.do_check_overlappingwin_early = false
	end
	if type(self.attachedtolauncher) == "number" then
		self.attachedtolauncher = self.attachedtolauncher - 1
		if self.attachedtolauncher <= 0 then self.attachedtolauncher = false end
	end
	--maddy thorson has an antipattern of counteracting the player trying to move against their current momentum but forgetting to apply the same harshness to the player not holding any directional buttons at all. this results in, among other things, neutraljumping being possible in celeste and jumper 2. this is not present in j4r.
	if self.cutscenemovement == "up" and not self.level.options.bottombordersolid then
		self.cutscenemovement = false --if you jump into the level, you should only be counted as doing cutscenemovement for the minimum amount of time for things to work as they should
	end
	
	if self.docutsceneinit then
		if self.edge == "left" then
			self.cutscenemovement = "right"
		elseif self.edge == "right" then
			self.cutscenemovement = "left"
		elseif self.edge == "up" then
			self.cutscenemovement = "down"
		elseif self.edge == "down" then
			self.cutscenemovement = "up"
			self.vmom = -1 * self.jumpforce --+ self.cutscenejumpextra
		end
		self.docutsceneinit = false
	end
	
	--============
	--TIMERS======
	--============
	
	if self.cutscenemovement and self.x >= 0 and self.x + self.width <= self.level.width and self.y >= 0 and self.y + self.height <= self.level.height then
		self.cutscenemovement = false
	end
	
	if self.tempfrictiontimer ~= 0 and not self.tempfriction then
		self.tempfrictiontimer = 0
	end
	if self.tempfrictiontimer > 0 then
		self.tempfrictiontimer = self.tempfrictiontimer - 1
	end
	
	if self.verticaled ~= "down" then
		self.skiddingtimer = 0
		self.startskiddingtimer = 0
		self.skidding = "none"
	end
	if self.skiddingtimer > 0 then
		self.skiddingtimer = self.skiddingtimer - 1
	end
	if self.skiddingtimer == 0 then
		self.skidding = "none"
	end
	
	if self.startskiddingtimer > 0 then
		self.startskiddingtimer = self.startskiddingtimer - 1
	end
	if self.tempfriction and self.tempfrictiontimer == 0 then 
		self.oldtempfriction = self.tempfriction
		self.tempfriction = self.tempfriction + (math.abs(self.friction - self.oldtempfriction) / self.tempfrictionphaseouttimer) --gradually phase out the temp friction
	end
	
	if self.tempfriction == self.friction then
		self.oldtempfriction = false
		self.tempfriction = false
	end
	
	if math.abs(self.hmom) >= self.skiddingspeed then
		self.startskiddingtimer = self.startskiddingframes
	end
	
	if self.walljumpleniencytimer > 0 then
		self.walljumpleniencytimer = self.walljumpleniencytimer - 1
	end
	if self.walljumpleniencytimer == 0 and self.lastwalled ~= "none" then
		self.lastwalled = "none"
		self.lastwalledby = {}
		self.lasticewalled.left = false
		self.lasticewalled.right = false
	end
	
	--============
	--ok timers over
	--============
	
	if self.tempmaxspeed and self.tempmaxspeed < self.maxspeed then
		self.tempmaxspeed = false
	end
	
	local maxspeed = self.tempmaxspeed or self.maxspeed
	if not self.ducking and not self.careening then
		if self.verticaled == "down" and not self.iced then
			if self:keyDown("right") and self.hmom < 0 and self.startskiddingtimer > 0 then
				self.skiddingtimer = self.skiddingframes
				local particleamt = 3
				if self.skidding == "right" then particleamt = 1 end
				self:skidparticles(particleamt)
				self.skidding = "right"
			end
			if self:keyDown("left") and self.hmom > 0 and self.startskiddingtimer > 0 then
				self.skiddingtimer = self.skiddingframes
				local particleamt = 3
				if self.skidding == "left" then particleamt = 1 end
				self:skidparticles(particleamt)
				self.skidding = "left"
			end
		end
		if not (self:keyDown("right") and self:keyDown("left")) then
			if self:keyDown("right") and self.hmom < maxspeed then
				local oldhmom = self.hmom
				local accelerationcapped = self.acceleration
				if self.iced then accelerationcapped = accelerationcapped / self.ice_acceleration_divisor end
				if (self.hmom > 0 or momentumtest) and math.abs(self.hmom) + accelerationcapped > maxspeed then --previously self.hmom > 0 was missing (and self.hmom < 0 from the equivalent below) which meant the player's movement in the direction opposite to their momentum would have no effect if they were going faster than maximum speed. this requires readjusting walljump friction
					local accelerationspillover = (math.abs(self.hmom) + accelerationcapped) - maxspeed
					accelerationcapped = accelerationcapped - accelerationspillover
					if accelerationcapped < 0 then accelerationcapped = 0 end --don't reset player's speed if they try to move while going faster than maxspeed (due to external circumstances)
				end
				self.hmom = self.hmom + accelerationcapped
				if oldhmom * self.hmom <= 0 then
					self.tempfriction = false
					self.tempmaxspeed = false
				end
			elseif self:keyDown("left") and (-1 * self.hmom) < maxspeed then
				local oldhmom = self.hmom
				local accelerationcapped = self.acceleration
				if self.iced then accelerationcapped = accelerationcapped / self.ice_acceleration_divisor end
				if (self.hmom < 0 or momentumtest) and math.abs(self.hmom) + accelerationcapped > maxspeed then
					local accelerationspillover = (math.abs(self.hmom) + accelerationcapped) - maxspeed
					accelerationcapped = accelerationcapped - accelerationspillover
					if accelerationcapped < 0 then accelerationcapped = 0 end --don't reset player's speed if they try to move while going faster than maxspeed (due to external circumstances)
				end
				self.hmom = self.hmom - accelerationcapped
				if oldhmom * self.hmom <= 0 then
					self.tempfriction = false
					self.tempmaxspeed = false
				end
			end
		end
	end
	
	local friction = self.friction
	if self.tempfriction then friction = self.tempfriction end
	if self.iced then friction = friction / self.ice_friction_divisor end
	
	if not self.careening then --ignore friction while careening
		if (self:notWalkingRight() and self.hmom > 0) or self.hmom > maxspeed then --apply friction if player is not moving OR if player is going faster than their normally attainable speed
			if self:keyDown("right") and self.hmom > maxspeed and (self.hmom - friction) <= maxspeed then
				self.hmom = maxspeed
			else
				self.hmom = self.hmom - friction
			end
			
			if self.hmom <= 0 then
				self.tempfriction = false
				self.tempmaxspeed = false
				self.hmom = 0
			end
		elseif (self:notWalkingLeft() and self.hmom < 0) or (self.hmom * -1) > maxspeed then --ditto
			if self:keyDown("left") and (self.hmom * -1) > maxspeed and ((self.hmom * -1) - friction) <= maxspeed then
				self.hmom = maxspeed * -1
			else
				self.hmom = self.hmom + friction
			end
			
			if self.hmom >= 0 then
				self.tempfriction = false
				self.tempmaxspeed = false
				self.hmom = 0
			end
		end
	end
	
	if self.hmom > self.hmom_max then
		self.hmom = self.hmom_max
	elseif self.hmom < self.hmom_min then
		self.hmom = self.hmom_min
	end
	
	if not self.careening then
		local gravitytoapply = self.gravity
		if not self.ghost then gravitytoapply = self.gravity * (self.level.gravity or 1) end --ghosts ignore level gravity
		--if self.vmom < self.maxfallspeed and (self.vmom + gravitytoapply > self.maxfallspeed) then
		if self.vmom > self.maxfallspeed and gravitytoapply > 0 then
			gravitytoapply = 0
		elseif self.vmom + gravitytoapply > self.maxfallspeed and self.vmom < self.maxfallspeed then
			local previousgravity = gravitytoapply
			gravitytoapply = self.maxfallspeed - self.vmom
		end
		self.vmom = self.vmom + gravitytoapply
	end
	
	if self.vmom > self.vmom_max then
		self.vmom = self.vmom_max
	elseif self.vmom < self.vmom_min then
		self.vmom = self.vmom_min
	end
	
	local applyhfirst = true
	if math.abs(self.vmom) > math.abs(self.hmom) then
		applyhfirst = false
	end
	
	local oldverticaledtemp = self.verticaled
	
	if self.stuckright and self.hmom <= 0 then self.hmom = 1
	elseif self.stuckleft and self.hmom >= 0 then self.hmom = -1
	elseif self.stuckdown and self.vmom <= 0 then self.vmom = 1
	elseif self.stuckup and self.vmom >= 0 then self.vmom = -1
	end
	self.was_stuckdown = self.stuckdown
	self.was_stuckup = self.stuckup
	
	self.stuckleft = false
	self.stuckdown = false
	self.stuckright = false
	self.stuckup = false
	
	--applyhfirst = false --makes tight walljumping sections feel more lenient
	
	if applyhfirst then
		--if this breaks for some reason change self.collisionfunctions to ogmo.collisionfunctions
		self.collisionfunctions.horizontal(self)
		self.collisionfunctions.vertical(self)
	else
		self.collisionfunctions.vertical(self)
		self.collisionfunctions.horizontal(self)
	end
	if self.mustdie then self.mustdie = false; self:die(); return; end
	
	if false or frameadvance then
		print("leniency info:", self.walljumpleniencytimer)
		print("self.lastwalled", "self.walled")
		print(self.lastwalled, self.walled)
		print("self.lastwalled ~= self.walled", "self.walled ~= \"none\"")
		print(self.lastwalled ~= self.walled, self.walled ~= "none")
		print("----")
	end
	if self.walled ~= "none" then
		if self.lastwalled ~= self.walled and self.walljumpleniencytimer == 0 then
			self.lastwalled = self.walled
			self.lastwalledby = self.walledby
			self.lasticewalled.right = self.icewalled.right
			self.lasticewalled.left = self.icewalled.left
		end
		self.walljumpleniencytimer = self.walljumpleniencyframes
		if cheat.isactive("lenientwalljumps") then
			self.walljumpleniencytimer = self.walljumpleniencyframes_extra
		end
	end
	
	if true then --if not self.ghost then --ghost block can't duck. you can use this to your advantage --lol not anymore
		if self:keyDown("down") and self.verticaled == "down" and not self.ducking then
			if frameadvance then
				print("ducking time")
			end
			self.ducking = true
			self.vmom = 0
			if not self.ghost then --ghost blocks don't decrease in height when ducking, and can't activate things like switchpads. they're not actually ducking, they're just stsying still
			--note that this block DOES NOT control whether ghosts fall through duckthrough tiles; that's in docollisioncheck. duckthrough tiles let you through if you're ducking or duckingthrough, and ghosts still have self.ducking set
				self.height = 13
				self.y = self.y + 3
				local fallthrough = true
				for _,v in ipairs(self.verticaledby) do
					if not v.duckthrough then
						fallthrough = false
					end
					if v.onDuck then
						v:onDuck(self)
					end
				end
				if fallthrough then
					if frameadvance then
						print("fallthrough! unducking")
					end
					self.height = 16
					self.y = self.y - 3
					self.ducking = false
					self.duckingthrough = 2
				end
			end
		end
		if ((self.verticaled == "none") or (not self:keyDown("down"))) and self.ducking then
			if frameadvance then
				print("ok now stop ducking...?")
			end
			if self.ghost then self.ducking = false --when ghost block ducks, it doesn't actually change height, it just stops being able to move
			else
				--do we have space to unduck? this is emulated by pretending to give the player a vertical momentum of 3 pixels upward, at their current height, and then seeing if they would collide with anything.
				--subtly this means you can actually be ducking while in midair if you're being followed by something that gives you no room to unduck. @sylviefluff cute jump 4 mechanic
				--...then i made cute jump 2 sequel 2 for sylvie's jam #1. i tried making this a mechanic in one of the "super players" levels but it's not really plausible to have something follow you that closely (except crates, perhaps, but those crush you)
				
				--check downward, then check upward
				--reverse order if gravity is 0 or lower, since being easily able to nudge yourself downward in 0-gravity can break some puzzles
				if self.level.gravity > 0 then
					if self:canUnduck("down") then --if player did not collide with anything while simulating downward movement
						if frameadvance then print("unducked downward") end
						self.ducking = false
						self.height = 16
					elseif self:canUnduck() then --if player did not collide with anything while simulating upward movement
						if frameadvance then print("unducked upward") end
						self.ducking = false
						self.height = 16
						self.y = self.y - 3
					end
				else
					if self:canUnduck() then --if player did not collide with anything while simulating upward movement
						if frameadvance then print("unducked upward") end
						self.ducking = false
						self.height = 16
						self.y = self.y - 3
					elseif self:canUnduck("down") then --if player did not collide with anything while simulating downward movement
						if frameadvance then print("unducked downward") end
						self.ducking = false
						self.height = 16
					end
				end
			end
		end
		if self:keyDown("up") and self.verticaled == "down" and (not self.ducking) and
			(self.hmom == 0 or (cheat.isactive("theincredulousabilitytoglanceupwardswhilstnotyetfullyatastop") and (self:notWalkingLeft() and self:notWalkingRight())))
		then
		--if self:keyDown("up") and self.verticaled == "down" and not self.ducking and self:notWalkingLeft() and self:notWalkingRight() then --the former more closely matches behavior in jumper 3
		--that's stupid. on the plus side it can be used to indicate when ogmo is completely still
			self.lookingup = true
		else
			self.lookingup = false
		end
	end
	
	self.overlaps = mobtools.doOverlapScan(self)
	for k,v in pairs(self.bk_blockage) do self.bk_blockage[k] = false end
	local juststoppedoverlappingwin = false
	if self.overlappingwin then
		juststoppedoverlappingwin = true
	end
	self.overlappingwin = false
	self.insolid = false
	self.icewalled.left = false
	self.icewalled.right = false
	for _,obj in ipairs(self.overlaps) do --despite using "obj" it can also be a tile
		if obj.solid and not (obj.fake or self.insolid) then
			if self.collisioncondition(self, obj, "vertical") then
				self.insolid = true --signals that player can unduck freely
			end
		end
		if obj.onOverlap then
			obj:onOverlap(self)
		end
		if obj.deathly then
			if not cheat.isactive("agodami") then self:die(); break; end
		elseif self.ghost and (obj.type == "ogmo" and (not obj.ghost) and obj.alive) then
			self:die(true); break;
		elseif obj.type == "win" then
			self.overlappingwin = true
			juststoppedoverlappingwin = false
		elseif obj.type == "borderkludge" then
			for i,v in ipairs(obj.blockage) do
				self.bk_blockage[v] = true
			end
		end
	end
	if self.mustdie then self.mustdie = false; self:die(); return; end
	
	if self.tempmaxspeed and math.abs(self.hmom) < self.tempmaxspeed then
		self.tempmaxspeed = math.abs(self.hmom)
	end
	
	if not self.alive then return end
	
	self.grounded = (self.verticaled == "down")
	
	if not self.justjumped and oldverticaledtemp == "down" and self.verticaled == "none" then
		self.jumps = self.jumps - 1
		if self.starstate.gray then self.jumps = 0 end
	end
	
	self.justjumped = false
	if self.duckingthrough then
		self.duckingthrough = self.duckingthrough - 1
		if self.duckingthrough == 0 then self.duckingthrough = false end
	end
	
	--self.x = self.x + self.hmom
	--self.y = self.y + self.vmom
	
	self:handleclamping(dt)
	
	local doflipscreenexit =  false
	if self.y > self.level.height and not (self.overlappingwin or juststoppedoverlappingwin) then
		if game.flipscreen and self.level.validexits["down"] then
			doflipscreenexit = "down"
		else
			self.vmom = 0
			self.y = self.level.height
			self:die()
		end
	end
	if game.flipscreen and (not doflipscreenexit) and not (self.overlappingwin or juststoppedoverlappingwin) then
		if self.level.validexits["up"] and self.y + self.height < 0 then
			doflipscreenexit = "up"
		elseif self.level.validexits["left"] and self.x + self.width < 0 then
			doflipscreenexit = "left"
		elseif self.level.validexits["right"] and self.x > self.level.width then
			doflipscreenexit = "right"
		end
	end
	if doflipscreenexit then
		local xoff = nil
		if doflipscreenexit == "up" or doflipscreenexit == "down" then xoff = self.x end
		local yoff = nil
		if doflipscreenexit == "left" or doflipscreenexit == "right" then yoff = (self.y - self.level.height) + 16 end --logic for yoffset win stuff is a little weird and assumes the player is the same height as the win object
		if self.ducking then yoff = yoff - 3 end
		local exit = {
			flipscreen = true,
			id = doflipscreenexit,
			careening = self.careening,
			jumpsleft = self.jumps,
			hmom = self.hmom,
			vmom = self.vmom,
			xoffset = xoff,
			yoffset = yoff,
			gray = (self.starstate and self.starstate.gray),
			purple = (self.starstate and self.starstate.purple),
			icestar = (self.starstate and self.starstate.ice),
		}
		game.win(exit, self.level, false)
	end
end

function ogmo:keychecks()
	if not game.anykeypressed then return end
	local key = game.keyWasPressed --shorthand for function
	local cantmoveyet = (self.tags and self.tags.nomoveuntilcollide and not self.touchedsolid)
	if frameadvance and key("q") then print(self.x, self.y)
	elseif key(controls["P" .. self.playerno .. "JUMP"]) and self.alive and not cantmoveyet and self.cutscenemovement ~= "down" and not self.docutsceneinit and
		--(not ((self.cutscenemovement == "right" or self.cutscenemovement == "left") and self.cutscene_firstfreemovement)) and
		(not (self.attachedtolauncher or self.careening)) and
		(not self.stuckdown)
	then self:jump()
	elseif key(controls["P" .. self.playerno .. "DIE"]) and self.alive and not self.ghost then self:die(false, true); self:playsfx("ogmo die");
	elseif key(controls["P" .. self.playerno .. "INTERACT"]) and self.alive and not cantmoveyet then
		for _,obj in ipairs(self.overlaps) do
			if(obj.onInteract) then
				obj:onInteract(self)
			end
		end
	end
end

function ogmo:jump()
	local canjump = not self.ducking
	if not canjump then
		local canunduck = self:canUnduck()
		if canunduck and self.ducking then --if player did not collide with anything while simulating upward movement
			self.ducking = false
			if not self.ghost then
				self.height = 16
				self.y = self.y - 3
			end
			canjump = true
		end
	end
	if canjump then
		local canwalljump = false
		local walled = self.walled
		local walledby = self.walledby
		local couldwalljump = (self.verticaled ~= "down" and not self.starstate.ice)
		if couldwalljump then
			if walled ~= "none" and not self.icewalled[walled] then
				for _,thing in ipairs(walledby) do
					if not thing.notwalljumpable then
						canwalljump = true
						break
					end
				end
			end
			if not canwalljump then --try for walljump leniency
				if self.walljumpleniencytimer > 0 and not self.lasticewalled[self.lastwalled] then
					assert(self.lastwalled ~= "none", "in ogmo:jump(), lastwalled is \"none\" and walljump leniency timer is over 0")
					walled = self.lastwalled
					walledby = self.lastwalledby
					for _,thing in ipairs(walledby) do
						if not thing.notwalljumpable then
							--see if we're actually vertically in range
							if (thing.y < self.y + self.height and
							thing.y + thing.height > self.y) then
								--edgecase; make sure we can't get a lenient walljump after we teleport horizontally
								local xdiff = 0
								if walled == "left" then xdiff = self.x - (thing.x + thing.width) --our left edge minus wall's right edge
								elseif walled == "right" then xdiff = thing.x - (self.x + self.width) end --wall's left edge minus our right edge
								if xdiff >= 0 and xdiff < self.wjl_max_xdiff then
									canwalljump = true
									break
								end
							end
						end
					end
					--logic for checking if there's a collidable wall we can walljump off of that wasn't in the original lastwalledby (e.g. we slipped down significantly) would go here (this is where wjl_max_xdiff would come in handy, as we would use mobtools horizontal collision with a simulated momentum of wjl_max_xdiff to see if any collidable tiles are within wjl_max_xdiff of us) but since intended leniency is only 2 frames it's not really worth it and it wouldn't matter unless we have a vertical momentum greater than 16-ish. or if our leniency is larger with the "extra leniency" cheat. but that's a cheat.
					--plus there'd be the minor edgecase of how if the original walls were switchblocks that recently switched off, they would still count if they're in range since no initial check is made for solidity, but other switchblocks wouldn't
					--i guess even with the extra leniency cheat it has the side effect of reducing leniency the faster you're going vertically (albeit in a chunky discrete manner), which is kind of cool
					if false or frameadvance then
						print("====LENIENCY WALLJUMP====")
						print("self.walled", "self.lastwalled")
						print(self.walled, self.lastwalled)
						print("#self.walledby", "#self.lastwalledby")
						print(#self.walledby, #self.lastwalledby)
					end
				end
			end
		end
		if canwalljump then
			self.walljumpleniencytimer = 0 --can't walljump twice
			local wb1 = walledby[1] --note to self: do not use 1 in a variable name when it could be confused with l. a1so great going courier new, making 1 have the same exact appearance as l. why can't we have fonts where the characters a11 actua11y 1ook different. the Il1 test has three characters genius
			if wb1.walljump_fragile then --checks only the first walledby tile for fragility to replicate j2 behavior
				if wb1.istile then
					table.remove(self.level.tilemap[wb1.y_tiled][wb1.x_tiled], wb1.i)
				else
					if wb1.onBreak then wb1:onBreak() end
					wb1.irrelevant = true
				end
				if (not wb1.tags) or (not wb1.tags.silent) then
					audio.playsfx("crackblock shatter");
				end
			end
			self.vmom = (self.vmom * self.jumpzaniness) - self.walljumpforce
			if walled == "left" and not self.stuckleft then
				self.hmom = self.walljumpspeed
				self.tempfriction = self.walljumptempfriction
				self.tempfrictiontimer = self.walljumptempfrictionframes
			elseif walled == "right" and not self.stuckright then
				self.hmom = (-1 * self.walljumpspeed)
				self.tempfriction = self.walljumptempfriction
				self.tempfrictiontimer = self.walljumptempfrictionframes
			end
			if not self.ghost then
				audio.setpitch(1 - (1/24))
				self:playsfx("ogmo jump")
				if cheat.isactive("highlyamusing") then
					self.level:placeascii("lol", love.math.random(1, #self.level.tilemap[1]), love.math.random(1, #self.level.tilemap))
				end
			end
			self.justjumped = true
		elseif self.jumps > 0 then
			self.tempfriction = false --having temp friction stop when you jump feels more natural for some reason
			--self.tempfrictiontimer = 0 --for alternate behavior, uncomment this line and comment the above line. this makes it so when you jump you get the standard tempfriction phase-out as when your tempfriction from a walljump ends normally, rather than your friction immediately becoming normal. this *looks* nicer, but feels far less precise
			local jumpsound = "ogmo jump"
			self.vmom = (self.vmom * self.jumpzaniness) - self.jumpforce
			local airjump = true
			if self.verticaled == "down" then
				airjump = false
				local gravitytoapply = self.gravity
				if not self.ghost then gravitytoapply = self.gravity * (self.level.gravity or 1) end --ghost blocks ignore level gravity
				self.vmom = self.vmom - gravitytoapply --replicates a subtle bug in jumper/jumper 2 that makes your grounded jumps a little higher than your air jumps
			end
			if self.skiddingtimer > 0 and self.verticaled == "down" and not self.iced then
				self.vmom = self.vmom - self.skidjumpextraforce
				--skidding cancels out all momentum in the direction you're skidding away from. in the original games i think skidding just killed all your horizontal momentum, period... but so did most things :p
				if self.skidding == "left" and self.hmom > 0 then self.hmom = 0
				elseif self.skidding == "right" and self.hmom < 0 then self.hmom = 0 end
				if self.skidding == "none" then print "how did you skidjump with no skidding state?" end
				jumpsound = "superjump"
			end
			self.jumps = self.jumps - 1
			if self.starstate.gray then self.jumps = 0 end
			if not self.ghost then
				if airjump then
					audio.setpitch(1 + (1/24))
				end
				self:playsfx(jumpsound)
				if cheat.isactive("highlyamusing") then
					local lol = "lol"
					if jumpsound == "superjump" then lol = "lmao" end
					self.level:placeascii(lol, love.math.random(1, #self.level.tilemap[1]), love.math.random(1, #self.level.tilemap))
				end
			end
			self.justjumped = true
			if self.level.camerafocus == self then statusbar.update("jump") end
		end
		self.skiddingtimer = 0
		self.skidding = "none"
	end
end

function ogmo:die(vanish, nosfx) --"vanish" arg is for if you are ghost block and you've been touched by an ogmo
	if self.alive and not self.level.frozen then
		if vanish then
			self.level:incAmt("ghostsgone")
			self:playsfx("ghostblock vanish")
			print("ghost block vanished")
		end
		if not self.ghost and not nosfx then self:playsfx("ogmo die") end
		self.alive = false
		self.irrelevant = true
		self.solid = false
		local level = self.level
		if not self.ghost then
			level.liveplayeramt = level.liveplayeramt - 1
			self.corpse = true
			self.currentquad = "ded"
			if self:keyDown("left", true, true) and not self:keyDown("right", true, true) then
				self.currentquad = "dedleft"
			elseif self:keyDown("right", true, true) and not self:keyDown("left", true, true) then
				self.currentquad = "dedright"
			end
			
			self.verticaledby = {}
			self.walledby = {}
			self.overlaps = {}
			--if not self.careening then self.vmom = self.corpseforce * -1 end
			if self.vmom <= 0 then
				local corpseforce_divisor
				corpseforce_divisor = math.abs(self.vmom) + 1
				self.vmom = self.vmom - (self.corpseforce / corpseforce_divisor)
			else
				local forcetoapply = self.corpseforce
				forcetoapply = forcetoapply * ((self.vmom / 5) + 1)
				self.vmom = self.vmom - forcetoapply
			end
			table.insert(game.corpses, self)
			if level.liveplayeramt > 0 then print("ogmo is dead! players remaining: " .. level.liveplayeramt) end
		elseif not vanish then
			for i=1, #level.objects do
				obj = level.objects[i]
				if obj.type == "ogmo" and not obj.ghost then
					obj:die()
					break
				end
			end
		end
	end
end

function ogmo:cancrush() return true end; function ogmo:crush() self:die() end;

function ogmo:calculate_y_drawat() --used for camera. the y drawat calculations below could easily be replaced w/ this function
	local y_drawat = self.y_clamped
	if game.ogmofakelag and not evenframe then y_drawat = self.y_clamped_last end
	local duckoffset = 0
	local myquad = (game.ogmofakelag and self.fakelagquad) or self.currentquad
	if game.ogmosnapto ~= 1 and (self.ghost or not (myquad == "duck" or myquad == "duckblink")) then
		y_drawat = math.floor((self.y / game.ogmosnapto) + .5) * game.ogmosnapto
	end
	if not self.ghost then
		if myquad == "duck" or myquad == "duckblink" then
			if game.ogmosnapto == 1 then
				duckoffset = -3
			else
				y_drawat = math.floor(((self.y - 3) / game.ogmosnapto) + .5) * game.ogmosnapto
			end
		end
	end
	return y_drawat + duckoffset
end

function ogmo:draw()
	if self.alive or self.corpse then
		local resetcolor = false
		local resetblend = false
		if self.corpse then
			resetcolor, resetblend = prepcolorfromtags(self) --game won't do this automatically for corpses since corpses are drawn separately
		end
		local y_drawat = self.y_clamped
		if game.ogmofakelag and (not evenframe) and (not game.paused) then y_drawat = self.y_clamped_last end
		local myquad = (game.ogmofakelag and self.fakelagquad) or self.currentquad
		if game.ogmosnapto ~= 1 and (self.ghost or not (myquad == "duck" or myquad == "duckblink")) then
			y_drawat = math.floor((self.y / game.ogmosnapto) + .5) * game.ogmosnapto
		end
		if self.ghost then love.graphics.draw(graphics.load("ogmos/" .. game.ogmoskin), ogmo.quads["ghost"], self.x_clamped, y_drawat)
		else
			local duckoffset = 0
			if myquad == "duck" or myquad == "duckblink" then
				if game.ogmosnapto == 1 then
					duckoffset = -3
				else
					y_drawat = math.floor(((self.y - 3) / game.ogmosnapto) + .5) * game.ogmosnapto
				end
			end
			love.graphics.draw(graphics.load("ogmos/" .. game.ogmoskin), ogmo.quads[myquad], self.x_clamped, y_drawat + duckoffset)
		end
		if resetcolor then
			love.graphics.setColor(1, 1, 1, 1)
		end
		if resetblend then
			love.graphics.setBlendMode("alpha")
		end
	end
	--[[
	love.graphics.print(booltostr(self.ducking), 400)
	love.graphics.print(booltostr(self.lookingup), 432)
	love.graphics.print(self.animtimer, 464)
	local r, g, b, a = love.graphics.getColor()
	love.graphics.setColor(0, 0, 0, a)
	love.graphics.rectangle("fill", 400, 0, 400, 16)
	love.graphics.setColor(r, g, b, a)
	love.graphics.print(self.x, 400)
	love.graphics.print(self.y, 416)
	--]]
	--love.graphics.print(tostring(self.tempfrictiontimer), 400)
end

return ogmo