overlapper = object:new()

function overlapper.editordraw(x, y, options)
	error("overlapper should not be drawn (much less in editor)")
end

function overlapper:init(x, y, w, h)
	self.type = "overlapper"
	self.x = x
	self.y = y
	self.hmom = 0
	self.ymom = 0
	self.width = w
	self.height = h
	self.invisible = true
	self.fake = false
	self.solid = false
	self.subscribers = {}
	self.owner = false
	self.dontclone = true --kludge
end

function overlapper:setup(...)
	error("overlapper is not meant to be setup like a normal editor object (only spawned in with init())")
end

function overlapper:onOverlap(obj)
	for k,v in pairs(self.subscribers) do --order undefined; this object's subscribers should not react differently depending on the state of other subscribers
		if v and k and not k.irrelevant then
			k:activate(self, obj)
		else
			self.subscribers[k] = nil
		end
	end	
	if (not next(self.subscribers)) and (not self.owner) then
		self.irrelevant = true
	end
end

function overlapper:update()
	if self.owner == nil then
		self.irrelevant = true
	end
end

function overlapper:draw()
	if self.invisible then return end
	--error("overlapper should not be drawn")
	local r,g,b,a = love.graphics.getColor()
	love.graphics.setColor(0,1,0,0.25)
	love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
	love.graphics.setColor(r,g,b,a)
end

return overlapper