star = object:new()

star.automask = true
star.maskimagename = "stars"

local img = graphics.load("stars") --starz

star.quads = {
	["gold"] = love.graphics.newQuad(0, 0, 16, 16, img),
	["gray"] = love.graphics.newQuad(16, 0, 16, 16, img),
	["purple"] = love.graphics.newQuad(32, 0, 16, 16, img),
	["ice"] = love.graphics.newQuad(48, 0, 16, 16, img),
}

function star.editordraw(x, y, options)
	love.graphics.draw(graphics.load("stars"), star.quads[options.kind or "purple"], x, y)
end

function star:init(x, y, kind)
	self.type = "star"
	self.x = x
	self.y = y
	self.hmom = 0
	self.ymom = 0
	self.width = tilesize
	self.height = tilesize
	self.solid = false
	self.irrelevant = false
	self.kind = kind
end

function star:setup(x, y, options, level, edge, tags)
	level:incMax("starstaken")
	return star:new(x, y, options.kind)
end

function star:update()
end

function star:onOverlap(obj)
	if(obj.type == "ogmo") then
		if self.kind == "gold" then
			if obj.jumps < (obj.defaultjumps - 1) then
				obj.jumps = obj.defaultjumps - 1
			end
			--TODO: link ghostblocks to ogmos!!! and then have whatever star a ghostblock takes apply to the linked ogmo instead
			obj.starstate = {}
			if obj == self.level.camerafocus then statusbar.update("jump") end
			self:playsfx("gold star collect")
			--note that gold stars do NOT make ogmo un-icy if he has an ice star. this is consistent with how the ice vial works in j3 demo. (also i'd need to distinguish "icy because stepped on ice" from "icy because has ice star".)
		elseif self.kind == "gray" then
			if not obj.grounded then obj.jumps = 0 end
			obj.starstate.gray = true
			self:playsfx("gray star collect")
		elseif self.kind == "purple" then
			obj.starstate.purple = true
			self:playsfx("purple star collect")
		elseif self.kind == "ice" then
			obj.starstate.ice = true
			obj.iced = true
			self:playsfx("ice star collect")
		else obj.starstate[self.kind] = true end
		
		if obj == self.level.camerafocus then statusbar.update("stars") end
		self.level:incAmt("starstaken")
		self.irrelevant = true
	end
end

function star:draw()
	love.graphics.draw(graphics.load("stars"), self.quads[self.kind or "purple"], self.x, self.y)
end

return star