tele_target = object:new()

local img = graphics.load("teles")

tele_target.quads = {
	["red"] = love.graphics.newQuad(0, 32, 16, 16, img),
	["green"] = love.graphics.newQuad(16, 32, 16, 16, img),
	["blue"] = love.graphics.newQuad(32, 32, 16, 16, img),
}

function tele_target.editordraw(x, y, options)
	love.graphics.draw(graphics.load("teles"), tele_target.quads[options.kind], x, y)
end

function tele_target:init(x, y, kind, deceit)
	self.type = "tele_target"
	self.x = x
	self.y = y
	self.hmom = 0
	self.ymom = 0
	self.width = tilesize
	self.height = tilesize
	self.solid = false
	self.kind = kind
	self.deceit = deceit
end

function tele_target:setup(x, y, options, level, edge, tags)
	local deceit = false
	if tags["fake"] then
		tags["fake"] = false
		deceit = true
	end
	local newtarget = tele_target:new(x, y, options.kind, deceit)
	if not deceit then
		local telekind = "tele_" .. options.kind
		if not level.temps[telekind] then level.temps[telekind] = {} end
		table.insert(level.temps[telekind], newtarget)
	end
	return newtarget
end

function tele_target:update()
end

function tele_target:draw()
	love.graphics.draw(graphics.load("teles"), self.quads[self.kind], self.x, self.y)
end

return tele_target