accumulator = 0 --outside the love.run loop in case we want to look at this
updatesdone = 0 --same
fpscap = 120
miniscule_idealframe_dt_discrepancy = .0005
skippedupdates = 0
doubleupdates = 0

function love.run()
	if love.load then love.load(love.arg.parseGameArguments(arg), arg) end

	-- We don't want the first frame's dt to include time taken by love.load.
	if love.timer then love.timer.step() end

	local dt = 0

	-- Main loop time.
	return function()
		-- Process events.
		--where should this fit into the below time kludge (e.g. handles keypresses and mousewheel movements)? does it just stay outside?
		if love.event then
			love.event.pump()
			for name, a,b,c,d,e,f in love.event.poll() do
				if name == "quit" then
					if not love.quit or not love.quit() then
						return a or 0
					end
				end
				love.handlers[name](a,b,c,d,e,f)
			end
		end

		-- Update dt, as we'll be passing it to update
		if love.timer then dt = love.timer.step() end
		
		-- Call update and draw
		--lol glaiel ctrl+c ctrl+v. this is mainly because sef has a 144hz monitor and the game was running at double speed for him and i just realized that is an issue i should address. i had read through glaiel's "how to make your game run at 60fps" article but because i don't actually want to update extra times when it gets laggy i just didn't even consider it would be relevant for j4r
		if math.abs(dt - 1/fpscap) < miniscule_idealframe_dt_discrepancy then
			dt = 1/fpscap --is this ok? nothing in the game logic actually relies on dt but if it ever does, should i be using a temp value here instead of modifying dt itself and then passing that to the game? would this cause everything to blow up?
		end
		if math.abs(dt - 1/(fpscap / 2)) < miniscule_idealframe_dt_discrepancy then
			dt = 1/(fpscap / 2)
		end
		updatesdone = 0
		accumulator = accumulator + dt
		
		while accumulator >= 1/fpscap do
			love.update(dt)
			updatesdone = updatesdone + 1
			if cheat.isactive("legacy144hz") then
				love.update(0) --dt isn't 0 just because this is right after the previous update! this could cause really dumb issues but this is a really dumb cheat (and, again, nothing in-game relies on dt so far)
				updatesdone = updatesdone + 1
			end
			accumulator = accumulator - 1/fpscap
			if not settings.lagmakeup then break end
		end
		
		if updatesdone == 0 then skippedupdates = skippedupdates + 1 end
		if updatesdone == 2 then doubleupdates = doubleupdates + 1 end
		
		while accumulator >= 1/fpscap do accumulator = accumulator - 1/fpscap end
		--]]
		
		if love.graphics and love.graphics.isActive() then
			love.graphics.origin()
			love.graphics.clear(love.graphics.getBackgroundColor())

			if love.draw then love.draw() end

			love.graphics.present()
		end

		if love.timer then love.timer.sleep(0.001) end
	end
end
