accumulator = 0 --outside the love.run loop in case we want to look at this
updatesdone = 0 --same
fpscap = 60
discardable_discrepancy = 0.005
scaled_discardable_discrepancy = discardable_discrepancy * fpscap --0.3
skippedupdates = 0
doubleupdates = 0
bulkupdates = 0

function love.run()
	if love.load then love.load(love.arg.parseGameArguments(arg), arg) end

	-- We don't want the first frame's dt to include time taken by love.load.
	if love.timer then love.timer.step() end

	local dt = 0

	-- Main loop time.
	return function()
		-- Process events.
		--where should this fit into the below time kludge (e.g. handles keypresses and mousewheel movements)? does it just stay outside?
		if love.event then
			love.event.pump()
			for name, a,b,c,d,e,f in love.event.poll() do
				if name == "quit" then
					if not love.quit or not love.quit() then
						return a or 0
					end
				end
				love.handlers[name](a,b,c,d,e,f)
			end
		end

		-- Update dt, as we'll be passing it to update
		if love.timer then dt = love.timer.step() end
		
		-- Call update and draw
		updatesdone = 0
		local scaleddt = dt * fpscap --dt is multiplied by fpscap to make things easier and run into floating point issues less (since small enough non-ideal delta times are set to 1)
		--print(dt)
		
		if math.abs(scaleddt - 1) < scaled_discardable_discrepancy then scaleddt = 1 end
		
		accumulator = accumulator + scaleddt
		
		while accumulator >= 1 do
			love.update(dt)
			updatesdone = updatesdone + 1
			if cheat.isactive("legacy144hz") then
				love.update(0) --using 0 could cause really dumb issues but this is a really dumb cheat (and, again, nothing in-game relies on dt so far)
				updatesdone = updatesdone + 1
			end
			accumulator = accumulator - 1
			if not settings.lagmakeup then break end
		end
		
		if updatesdone == 0 then skippedupdates = skippedupdates + 1
		elseif updatesdone == 2 then doubleupdates = doubleupdates + 1
		elseif updatesdone > 2 then bulkupdates = bulkupdates + 1 end
		
		while accumulator >= 1 do accumulator = accumulator - 1 end
		--]]
		
		if love.graphics and love.graphics.isActive() then
			love.graphics.origin()
			love.graphics.clear(love.graphics.getBackgroundColor())

			if love.draw then love.draw() end

			love.graphics.present()
		end

		if love.timer then love.timer.sleep(0.001) end
	end
end