--adapted from https://lua-users.org/wiki/SandBoxes

sandbox = {}

-- make environment
local environments = { -- add functions you know are safe here
	["default"] = {}
}

-- run code under environment [Lua 5.1]
sandbox.run = function(untrusted_code, env)
	env = environments[env or "default"]
	assert(env, "invalid env chosen for sandbox.run")
	if untrusted_code:byte(1) == 27 then return nil, "binary bytecode prohibited" end
	local untrusted_function, message = loadstring(untrusted_code)
	if not untrusted_function then return nil, message end
	setfenv(untrusted_function, env)
	return pcall(untrusted_function)
end