stageselect = {
	sectors = {},
	things = {},
	things_leftbound = 16,
	things_rightbound = 480,
	things_topbound = 48,
	things_bottombound = 416
}

stageselect.begin = function()
	audio.playsong("flub", false, false, true)
end

stageselect.stop = function()

end

stageselect.draw = function()
	local r, g, b, a = love.graphics.getColor()
	love.graphics.setColor(0.2, 0.2, 0.2, 1)
	love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
	
	love.graphics.setColor(r, g, b, a)
	love.graphics.print("choose a stage", titlefont, (16 * 2), 0)
	
	--setcolor 204/255 for drawing neutral stagebuttons (this will make them the same color as editorbuttons)
	for i,thing in ipairs(stageselect.things) do
		
	end
end

function stageselect.fetchstages()
	stageselect.sectors = {}
	local stagedata = love.filesystem.read(game.levelsetpath .. "/stageselect/stages.txt")
	--if stages file isnt there then return end
	if not stagedata then print("no stagedata"); return; end
	--way more optimal to just do love.filesystem.lines than to load it as a string and then split it (also applies to level but that would be more work to get it to work that way)
	stagedata = stagedata:correctnewlines()
	stagedata = split(stagedata, "\n")
	local header
	local mode
	local currentsector
	local currentstage
	--local validtokens = {}
	local reservedkeys = set("stages", "type", "newline")
	local x = 0
	local y = 0
	local sectorbreak = false
	local newline = false
	local w_sector = 128
	local w_stage = 16
	for i, row in ipairs(stagedata) do
		if string.sub(row, 1, 3) == "===" and string.sub(row, -3, -1) == "===" then
			local stuff = split(string.sub(row, 4, -4), ":", 1)
			header = stuff[1]
			info = stuff[2]
			if header == "SECTOR" then
				currentsector = tonumber(info)
				if not stageselect.sectors[currentsector] then stageselect.sectors[currentsector] = {} end
				local sector = stageselect.sectors[currentsector]
				sector.stages = {}
				sector.type = "sector"
				if newline or sectorbreak or x + w_sector + w_stage > stageselect.things_rightbound then
					x = 0
					y = y + 32
					sectorbreak = false
					newline = false
				end
				stageselect.things[#stageselect.things + 1] = sector
				x = x + w_sector
			elseif header == "STAGE" then
				local stuff_ = split(info, "-", 1)
				currentsector = tonumber(stuff_[1])
				currentstage = tonumber(stuff_[2])
				if not stageselect.sectors[currentsector].stages[currentstage] then stageselect.sectors[currentsector].stages[currentstage] = {} end --i love writing code. i am telling the machine what to do.
				local stage = stageselect.sectors[currentsector].stages[currentstage]
				stage.type = "stage"
				if newline or x + w_stage > stageselect.things_rightbound then
					x = 0
					y = y + 16
					sectorbreak = true
					newline = false
				end
				stageselect.things[#stageselect.things + 1] = stage
				x = x + w_stage
			end
		elseif string.sub(row, 1, 1) == "|" then
			if not header then
				error("in stageselect: data came before header in stages file")
			end
			data = string.sub(row, 2, -1)
			if mode == "x" then
				x = tonumber(data)
			elseif mode == "y" then
				y = tonumber(data)
			else
				if header == "SECTOR" then
					stageselect.sectors[currentsector][mode] = data
				elseif header == "STAGE" then
					stageselect.sectors[currentsector].stages[currentstage][mode] = data
				end
			end
		elseif string.sub(row, 1, 1) == ">" then
			mode = string.sub(row, 2, -1)
			if not mode then error("in stageselect: no mode?") end
			if string.sub(mode, 1, 1) == "_" then error("in stageselect: mode started with _") end
			
			if mode == "newline" then
				newline = true
			elseif reservedkeys[mode] then error("in stageselect: reserved key as mode (" .. mode .. ")") end
		end
	end
end