textfield = class:new()

function textfield:init(rel_x, rel_y, width, height, id, textsource, tooltip, forbidden, relativeto)
	self.id = id
	self.rel_x = rel_x
	self.rel_y = rel_y
	self.width = width
	self.height = height
	self.focus = false
	self.textsource = textsource
	self.tooltip = tooltip
	self.forbidden = forbidden or {} --forbidden characters; not handled by textfield itself but by the environment in which textfield appears
	self.relativeto = relativeto
end

function textfield:setup(rel_x, rel_y, width, height, id, textsource, tooltip, forbidden, relativeto, container_w, container_h)
	if (not relativeto) or relativeto == "none" then relativeto = "topleft" end
	local newtextfield = textfield:new(rel_x, rel_y, width, height, id, textsource, tooltip, forbidden, relativeto)
	newtextfield:updateposfordimensions(container_w or love.graphics.getWidth(), container_h or love.graphics.getHeight())
	return newtextfield
end

function textfield:update()
end

function textfield:updateposfordimensions(w, h)
	local x = self.rel_x
	local y = self.rel_y
	if self.relativeto ~= "topleft" then
		if self.relativeto == "bottomleft" or self.relativeto == "bottomright" then
			y = h - self.rel_y
		end
		if self.relativeto == "topright" or self.relativeto == "bottomright" then
			x = w - self.rel_x
		end
	end
	self.x = x
	self.y = y
end

function textfield:draw()
	local r, g, b, a = love.graphics.getColor()
	
	local unfocusoutercolor = 0.4
	local unfocusinnercolor = 0.6
	local focusoutercolor = 0.6
	local focusinnercolor = 0.8
	
	local oc = unfocusoutercolor
	local ic = unfocusinnercolor
	if self.focus then
		oc = focusoutercolor
		ic = focusinnercolor
	end
	
	love.graphics.setColor(oc, oc, oc)
	love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
	if self.width >= 3 then
		love.graphics.setColor(ic, ic, ic)
		love.graphics.rectangle("fill", self.x + 1, self.y + 1, self.width - 2, self.height - 2)
	end
	if self.textsource ~= nil then
		local texttoprint = editor[self.textsource]
		if self.focus then
			texttoprint = texttoprint .. "|"
		end
		love.graphics.setColor(0, 0, 0)
		love.graphics.print(texttoprint, self.x + 1, self.y + 1)
	end
	love.graphics.setColor(r, g, b, a)
end

--return textfield