--note: show statusbar over transit

transit = {}

transit.progress = 0
transit.target = 20 --this represents a third of a second, because 1. updates are forced 60fps lockstep, 2. rendering doesn't change any variables, and 3. deltatime is only ever used in love.run to enforce 60fps. [a gamer with a 1200hz monitor, for whom 60fps is like a slideshow, begins to cry and stumbles out of the room.]
--note: make sure to measure things so that a fade-out, from the old level freezing to the new level unfreezing, takes exactly 60 frames. also ideally the transit is visible on the very first frame and the very last frame.
transit.type = "fade"
transit.reverse = false --fade in. ideally this just involves subtracting progress from target to flip the value.
transit.queuedwin = nil
transit.active = false

--fade
--wipeleft
--wiperight
--wipeup
--wipedown

transit.reset = function()
	transit.reverse = false
	transit.progress = 0
	transit.active = false
end

transit.update = function()
	if transit.progress < transit.target then
		transit.progress = transit.progress + 1
	else
		if not transit.reverse then
			if transit.queuedwin then
				game.win(unpack(transit.queuedwin))
			end
			--mirror changes here to game.lua loadlevelset
			transit.reverse = true
			transit.progress = 0
			transit.type = "fade" --REDUNDANT ACCESS if the condition two lines below is met! garbage program! start over
			local focus = game.activelevels[1].camerafocus
			if focus and consts.oppositedirs[focus.edge] then --index to get whether this is a valid direction
				transit.type = "wipe" .. focus.edge
			end
		else
			transit.reset()
		end
	end
end

transit.draw = function()
	local r,g,b,a = love.graphics.getColor()
	local vp = game.viewport
	local x,y,w,h = vp.x or 0, vp.y or 0, vp.width or game.width, vp.height or game.height
	local p
	if not transit.reverse then
		p = transit.progress / transit.target
	else
		p = math.max(transit.progress - 1, 0) / transit.target
		p = 1 - p
	end
	--could apply some easing function here
	--will do that right after i'm done with the bloom & screenshake
	if transit.type == "fade" then
		love.graphics.setColor(0,0,0,p)
		love.graphics.rectangle("fill", x,y,w,h)
	elseif transit.type == "wiperight" then
		love.graphics.setColor(0,0,0,1)
		love.graphics.rectangle("fill", x,y,w * p,h)
	elseif transit.type == "wipeleft" then
		love.graphics.setColor(0,0,0,1)
		love.graphics.rectangle("fill", x + (w - (w * p)),y,w * p,h)
	elseif transit.type == "wipedown" then
		love.graphics.setColor(0,0,0,1)
		love.graphics.rectangle("fill", x,y,w,h * p)
	elseif transit.type == "wipeup" then
		love.graphics.setColor(0,0,0,1)
		love.graphics.rectangle("fill", x,y + (h - (h * p)),w,h * p)
	end
	love.graphics.setColor(r,g,b,a)
end