writer = {}
writer.code = [[
require("love.filesystem")
local name, data, id = ...
love.filesystem.write(name, data)
--love.thread.getChannel("writedone"):push(id)
]]
--this is too precarious for comfort
--[==[
writer.code_new = [[
require("love.filesystem")
local t = ...
for i=1, #t, 2 do
	local name = t[i]
	local data = t[i + 1]
	love.filesystem.write(name, data)
end
--love.thread.getChannel("writedone"):push(id)
]]
]==]
writer.multicode = [[
require ("love.filesystem")
local t = {...}
local packets = t[1]
local id = t[2]
for i,packet in ipairs(packets) do
	if not packet.name then
		error("no target filename for write #" .. i)
	elseif not packet.data then
		error("no data for write #" .. i)
	end
	love.filesystem.write(packet.name, packet.data)
end
--love.thread.getChannel("writedone"):push(id)
]]
writer.thread = love.thread.newThread(writer.code)
writer.multithread = love.thread.newThread(writer.multicode)

local dowrite = function(name, data) --holy shit it's Do Write by Cabinet Voltage from their album Micro-Phones
	if writer.thread:isRunning() then
		print("asking the write thread to write again when it's not done with the previous write, yeesh!")
		writer.thread:wait()
	end
	local id = 0 --idk
	writer.thread:start(name, data, id)
end

writeto_multi = function(t)
	--local n = select("#", ...)
	--local args = {...}
	local packets = {} --weird terminology, probably
	for i=1,#t do
		local mode = t[i]
		--if not mode then error("nil argument provided to writeto_multi at index " .. tostring(i)) end
		local name,data = writer.modes[mode]()
		local p = {["name"] = name, ["data"] = data}
		table.insert(packets, p)
	end
	local id = 0 --idk
	writer.multithread:start(packets, id)
	if showsave then
		showsave()
	end
end

writeto = function(mode)
	dowrite(writer.modes[mode]())
	if showsave then
		showsave()
	end
end

writer.modes = {
	settings = function()
		local towrite = {}
		for k,v in pairs(settings) do
			towrite[#towrite + 1] = "==="
			towrite[#towrite + 1] = k
			towrite[#towrite + 1] = "===\n"
			towrite[#towrite + 1] = type(v)
			towrite[#towrite + 1] = "|"
			towrite[#towrite + 1] = tostring(v)
			towrite[#towrite + 1] = "\n"
		end
		table.remove(towrite) --remove last newline
		return "settings.txt", table.concat(towrite)
	end,
	ogmoskin = function()
		return "ogmoskin.txt", game.ogmoskin
	end,
	unlockedcheats = function()
		local towrite = {}
		for i=1, #cheat.unlockedcheats do
			towrite[#towrite + 1] = cheat.unlockedcheats[i]
		end
		return "unlockedcheats.txt", table.concat(towrite, "\n")
	end,
	activecheats = function()
		local towrite = {}
		for i=1, #cheat.activecheats do
			towrite[#towrite + 1] = cheat.activecheats[i]
		end
		return "activecheats.txt", table.concat(towrite, "\n")
	end,
	controls = function()
		local towrite = {}
		for k,v in pairs(controls) do
			--towrite[#towrite + 1] = "===" .. k .. "===\n|" .. v
			towrite[#towrite + 1] = "==="
			towrite[#towrite + 1] = k
			towrite[#towrite + 1] = "===\n"
			towrite[#towrite + 1] = v
			towrite[#towrite + 1] = "\n"
		end
		table.remove(towrite) --removes last newline
		return "controls.txt", table.concat(towrite)
	end,
	save = function()
		if statemachine.currentstate ~= game or game.editormode then
			error("can't save, not in-game", 3)
		end
		if type(game.save_entrance) ~= "table" then
			error("save is not table (you're probably too early? save is just 0 if there's no reason to save yet), save is " .. tostring(game.save_entrance) .. ", type " .. type(game.save_entrance), 3)
		end
		if not love.filesystem.getInfo("saves/" .. game.currentlevelset.foldername, "directory") then
			love.filesystem.createDirectory("saves/" .. game.currentlevelset.foldername)
		end
		
		local towrite = {}
		towrite[#towrite + 1] = "===ROOM===\n|"
		towrite[#towrite + 1] = game.templatelevels[1].name
		towrite[#towrite + 1] = "\n===ENTRANCE==="
		for k,v in pairs(game.save_entrance) do
			towrite[#towrite + 1] = "\n>"
			towrite[#towrite + 1] = k
			towrite[#towrite + 1] = "\n"
			towrite[#towrite + 1] = type(v)
			towrite[#towrite + 1] = "|"
			towrite[#towrite + 1] = tostring(v)
		end
		towrite[#towrite + 1] = "\n===COLORS==="
		for k,v in pairs(game.solid_colors_start) do
			towrite[#towrite + 1] = "\n>"
			towrite[#towrite + 1] = k
			towrite[#towrite + 1] = "\n|"
			towrite[#towrite + 1] = tostring(v)
		end
		towrite[#towrite + 1] = "\n===SWITCHPADS==="
		towrite[#towrite + 1] = "\n>redblue\n|"
		towrite[#towrite + 1] = tostring(game.switchpadstate_start)
		towrite[#towrite + 1] = "\n>cyanyellow\n|"
		towrite[#towrite + 1] = tostring(game.switchpad2state_start)
		towrite[#towrite + 1] = "\n===MUSIC===\n|"
		towrite[#towrite + 1] = game.currentsong
		--gems are stored as whether the gem has been collected here or not. there is 1 gem of each kind to each room. if multiple gems are the same type are placed, all but the last one you collect are holograms and don't count.
		--actually no they're stored byte-level in a separate file for compactness
		--[[
		towrite[#towrite + 1] = "\n===GEMS==="
		towrite[#towrite + 1] = "\n>blue"
		for k,v in pairs(game.collectedgems["blue"]) do
			towrite[#towrite + 1] = "\n|"
			towrite[#towrite + 1] = tostring(k)
		end
		towrite[#towrite + 1] = "\n>red"
		for k,v in pairs(game.collectedgems["red"]) do
			towrite[#towrite + 1] = "\n|"
			towrite[#towrite + 1] = tostring(k)
		end
		]]
		return "saves/" .. game.currentlevelset.foldername .. "/slot" .. game.saveslot .. ".txt", table.concat(towrite)
	end,
	levelsetinfo = function()
		--note: for some reason i thought that this function was going to be running in a thread. it's not. this function *provides arguments for* a thread, which just runs love.filesystem.write
		
		local foldername = editor.currentlevelset --currentlevelset is just the folder name for some reason. probably because the editor didn't need to do anything with levelset info
		local info = editor.levelset.info
		local towrite = {}
		local exclude = {["screenwidth"] = true, ["screenheight"] = true}
		local fixedorder = {"name", "author", "description", "firstroom", "viewportwidth", "viewportheight"}
		local fixedorder_inv = {}
		for k,v in pairs(fixedorder) do fixedorder_inv[v] = true end
		local remainders = {}
		for k,v in pairs(info) do
			if not fixedorder_inv[k] then
				table.insert(remainders, k)
			end
		end
		table.sort(remainders)
		towrite[#towrite + 1] = "==="
		for i,v in ipairs(fixedorder) do
			if info[v] then
				--[[if type(info[v]) ~= "string" then
					error("when writing levelset info: info for " .. v .. " is of type " .. type(info[v]) .. " (" .. tostring(info[v]) .. "), should be string")
				end]]
				towrite[#towrite + 1] = string.upper(v)
				towrite[#towrite + 1] = "===\n|"
				towrite[#towrite + 1] = tostring(info[v])
				towrite[#towrite + 1] = "\n==="
			end
		end
		for i,v in ipairs(remainders) do
			if (not exclude[v]) and info[v] then
				towrite[#towrite + 1] = string.upper(v)
				towrite[#towrite + 1] = "===\n|"
				towrite[#towrite + 1] = tostring(info[v])
				towrite[#towrite + 1] = "\n==="
			end
		end
		towrite[#towrite] = nil
		return "ext_levelsets/" .. foldername .. "/LEVELINFO.txt", table.concat(towrite)
	end
}
